package org.processmining.decomposelogs;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Log to Aggregated Log Heuristics for fast confrmance checking", parameterLabels = { "Log " }, returnLabels = { "AHL" }, returnTypes = { AggregatedHeuristicsL.class })
public class DeclarifyLogPluginL {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();

	public AggregatedHeuristicsL yourPrivatePlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {

		long msecs = System.currentTimeMillis();
		return Log2DeclareL.getAllAggPairHeuristics(log);
		
//		System.out.println(msecs);
		//		PairwiseLogHeuristic plh = PairwiseLog2Declare.getAggPairHeuristics(log);
		//		Map<Short, String> s2a = plh.short2Act;
		//		for (Set<Short> pair : plh.traceCount.keySet()) {
		//			for (Short p : pair)
		//				System.out.print(s2a.get(p) + " ");
		//			System.out.println();
		//			for (Short[] seq : plh.traceCount.get(pair).keySet()) {
		//				for (short s : seq) {
		//					System.out.print(s2a.get(s) + " ");
		//				}
		//				System.out.print(plh.traceCount.get(pair).get(seq));
		//				System.out.println();
		//			}


	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Get AHL", requiredParameterLabels = { 0 })
	public AggregatedHeuristicsL yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {
		return yourPrivatePlugin(context, log);

	}

}
