package org.processmining.decomposelogs;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

@Plugin(name = "1. Log-Model comparison using Declare constraints", parameterLabels = { "Petrinet ", "Event Log", }, returnLabels = { "Fitness/Precision" }, returnTypes = { ConstraintsBasedFitnessPrecision.class })
public class LogModelComparisonPluginL {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public ConstraintsBasedFitnessPrecision yourPrivatePlugin(UIPluginContext context, Petrinet pn, XLog log,boolean multiThreaded)
			throws IllegalAccessException, InstantiationException {
		return LogModelComparisonNewL.compareModelAndLog(context, pn, log,multiThreaded);

	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Reduce petrinet 22", requiredParameterLabels = { 0, 1 })
	public ConstraintsBasedFitnessPrecision yourDefaultPlugin(UIPluginContext context, Petrinet pn, XLog log)
			throws IllegalAccessException, InstantiationException {

		return yourPrivatePlugin(context, pn, log,true);

	}
}
