package org.processmining.decomposelogs;

import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Deque;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.impl.XEventImpl;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.EfficientPetrinetSemantics;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.models.semantics.petrinet.impl.EfficientPetrinetSemanticsImpl;
import org.processmining.prabhakardixit.utils.PetrinetUtilsL;

public class Net2DeclareL {

	//	static Set<String> seqPossible;

	public static AggregatedHeuristicsL net2Declare(PluginContext context, Petrinet pn) {

		//		return Log2Declare.getAggPairHeuristics(getLog(context, pn));
		return null;
	}

	public static XLog getLog(PluginContext context, Petrinet pn) {

		XFactory f = XFactoryRegistry.instance().currentDefault();
		XLog clone = f.createLog();
		Set<Place> marking = new HashSet<Place>();
		marking.add(PetrinetUtilsL.getInitialPlace(pn));
		getLog(pn, marking, new HashSet<Transition>(), new HashSet<Transition>(), new HashSet<Transition>(),
				new HashSet<Transition>(), clone, f.createTrace());
		return clone;

	}

	private static void getLog(Petrinet pn, Set<Place> marking, Set<Transition> execTrans1, Set<Transition> execTrans2,
			Set<Transition> execTrans3, Set<Transition> execTrans4, XLog log, XTrace trace) {
		Set<Transition> enabledTrans = PetrinetUtilsL.getEnabledTransitions(pn, marking);
		XFactory f = XFactoryRegistry.instance().currentDefault();
		if (enabledTrans.isEmpty() && !exists(log, trace)) {
			log.add(trace);
			return;
		}
		for (Transition t : enabledTrans) {
			if ((t.isInvisible() && !execTrans4.contains(t)) || (!t.isInvisible() && !execTrans4.contains(t))) {
				Set<Transition> execTrans1Loop = new HashSet<Transition>(execTrans1);
				Set<Transition> execTrans2Loop = new HashSet<Transition>(execTrans2);
				Set<Transition> execTrans3Loop = new HashSet<Transition>(execTrans3);
				Set<Transition> execTrans4Loop = new HashSet<Transition>(execTrans4);
				Set<Place> newMarking = new HashSet<Place>(marking);
				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eIn : pn.getInEdges(t))
					newMarking.remove(eIn.getSource());
				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eOut : pn.getOutEdges(t))
					newMarking.add((Place) eOut.getTarget());
				if (!execTrans1Loop.add(t))
					if (!execTrans2Loop.add(t))
						if (!execTrans3Loop.add(t))
							execTrans4Loop.add(t);
				XTrace newTrace = (XTrace) trace.clone();
				XEvent e = new XEventImpl();

				if (!t.isInvisible()) {
					XAttribute att = f.createAttributeLiteral("concept:name", t.getLabel(), null);
					e.getAttributes().put("concept:name", att);
					newTrace.add(e);
				}
				getLog(pn, newMarking, execTrans1Loop, execTrans2Loop, execTrans3Loop, execTrans4Loop, log, newTrace);
			}
		}

	}

	private static boolean exists(XLog log, XTrace trace) {

		//		for (XEvent e : trace)
		//			if (trace.size() == 3 && XConceptExtension.instance().extractName(trace.get(0)).equals("a")
		//					&& XConceptExtension.instance().extractName(trace.get(1)).equals("b")
		//					&& XConceptExtension.instance().extractName(trace.get(2)).equals("a"))
		//				System.out.println(" - " + XConceptExtension.instance().extractName(e));

		for (XTrace t : log) {
			if (t.size() == trace.size()) {
				boolean flag = true;
				int i = 0;
				while (flag) {
					if (!XConceptExtension.instance().extractName(t.get(i))
							.equals(XConceptExtension.instance().extractName(trace.get(i))))
						flag = false;
					i++;
					if (i == t.size() && flag)
						return true;
				}
			}
		}
		return false;

	}

	public static Set<DeclarePairsL> net2Declare(Petrinet pn, Set<Place> initMarking, Set<Place> finalMarking) {
		//		AggregatedHeuristics ahm = new AggregatedHeuristics();
		Set<DeclarePairsL> dps = getDeclarePairsEnabledByNet(pn, initMarking, finalMarking);
		for (DeclarePairsL dp : dps)
			System.out.println(dp.getAct1() + " " + dp.getAct2() + " " + dp.getTemplate());
		return dps;
	}

	private static Set<DeclarePairsL> getDeclarePairsEnabledByNet(Petrinet pn, Set<Place> initMarking,
			Set<Place> finalMarking) {
		Set<DeclarePairsL> dps = new HashSet<DeclarePairsL>();
		String a1 = "", a2 = "";
		for (Transition t : pn.getTransitions())
			if (!t.isInvisible()) {
				if (a1.equals(""))
					a1 = t.getLabel();
				else if (a2.equals(""))
					a2 = t.getLabel();
			}
		dps.addAll(getDeclareTemplates(a1, a2, initMarking, finalMarking, pn));

		dps.addAll(getDeclareTemplates(a2, a1, initMarking, finalMarking, pn));

		//		for (DeclareTemplates t : DeclareTemplates.values()) {
		//			//			if (isReplayable(pn, getDeclareTemplateSeq(a1, a2, t), new HashSet<Place>(initMarking), new HashSet<Place>(
		//			//					finalMarking), new HashSet<Transition>(), new ArrayList<String>()))
		//			if (isReplayableNonRecursion(pn, getDeclareTemplateSeq(a1, a2, t), new HashSet<Place>(initMarking)))
		//				dps.add(new DeclarePairs(a1, a2, t));
		//
		//			//			if (isReplayable(pn, getDeclareTemplateSeq(a2, a1, t), new HashSet<Place>(initMarking), new HashSet<Place>(
		//			//					finalMarking), new HashSet<Transition>(), new ArrayList<String>()))
		//			if (isReplayableNonRecursion(pn, getDeclareTemplateSeq(a2, a1, t), new HashSet<Place>(initMarking)))
		//				dps.add(new DeclarePairs(a2, a1, t));
		//		}
		return dps;
	}

	private static Set<DeclarePairsL> getDeclareTemplates(String a1, String a2, Set<Place> initMarking,
			Set<Place> finalMarking, Petrinet pn) {
		//		Set<Place> marking = new HashSet<Place>();
		//		marking.addAll(PetrinetUtils.getInitialMarking(pn));
		//		Map<List<String>, DeclareTemplates> seqDc = new HashMap<List<String>, DeclareTemplates>();

		Set<DeclarePairsL> dps = new HashSet<DeclarePairsL>();

		Map<String, DeclareTemplatesL> seqDc = new HashMap<String, DeclareTemplatesL>();
		DeclareTemplatesL[] templates = DeclareTemplatesL.values();
		for (int i = templates.length - 1; i >= 0; i--) {
			DeclareTemplatesL t = templates[i];
			String str = "";
			List<String> seq = getDeclareTemplateSeq(a1, a2, t);

			for (int j = 0; j < seq.size(); j++) {
				str += seq.get(j);
				if (j != seq.size() - 1)
					str += ",,,";
			}
			seqDc.put(str, t);
		}

		Set<DeclareTemplatesL> addedTemplates = new HashSet<DeclareTemplatesL>();
		Set<String> possibleSequences = new HashSet<String>();
		for (String seq : seqDc.keySet()) {
			if (!possibleSequences.contains(seq)) {
				//				if (isReplayable(pn, seq, new HashSet<Place>(initMarking), new HashSet<Place>(finalMarking),
				//						new HashSet<Transition>(), "", possibleSequences))
				//			if (isReplayableNonRecursion(pn, getDeclareTemplateSeq(a1, a2, t), marking))
				//				if (isReplayableSemantics(pn, new EfficientPetrinetSemanticsImpl(pn, new Marking(initMarking)), seq,
				//						new Marking(initMarking), new Marking(finalMarking), new HashSet<Integer>(), "",
				//						possibleSequences)) {
				if (isReplayableSemanticsNoRec(pn, new EfficientPetrinetSemanticsImpl(pn, new Marking(initMarking)),
						seq, new Marking(initMarking), new Marking(finalMarking)))
					dps.add(new DeclarePairsL(a1, a2, seqDc.get(seq)));
				//				}
				//				updateAddedTemplates(addedTemplates, seqDc, possibleSequences);
			} else
				dps.add(new DeclarePairsL(a1, a2, seqDc.get(seq)));
		}
		return dps;
	}

	private static void updateAddedTemplates(Set<DeclareTemplatesL> addedTemplates, Map<String, DeclareTemplatesL> seqDc,
			Set<String> possibleSequences) {
		for (String s : possibleSequences) {
			boolean flag = false;
			Set<String> seqs = new HashSet<String>(seqDc.keySet());
			if (seqs.contains(s)) {
				addedTemplates.add(seqDc.get(s));
			}
		}

	}

	private static boolean isReplayableNonRecursion(Petrinet pn, List<String> seq, Set<Place> marking) {
		boolean flag = true;

		Deque<Set<Place>> stackMarking = new ArrayDeque<Set<Place>>();
		Deque<Set<Transition>> stackExecTrans = new ArrayDeque<Set<Transition>>();
		Deque<List<String>> stackSeq = new ArrayDeque<List<String>>();
		Deque<Set<Transition>> stackTransChosen = new ArrayDeque<Set<Transition>>();

		stackSeq.add(seq);
		stackMarking.add(marking);
		stackTransChosen.add(PetrinetUtilsL.getEnabledTransitions(pn, stackMarking.getLast()));
		stackExecTrans.add(new HashSet<Transition>());
		while (flag) {
			//			System.out.println(stackTransChosen.size() + " : " + stackTransChosen.getLast());
			if (stackTransChosen.getLast().isEmpty()) {
				if (stackSeq.getLast().isEmpty() && noRemainingTokens(stackMarking.getLast(), pn))
					return true;
				stackMarking.removeLast();
				stackExecTrans.removeLast();
				stackTransChosen.removeLast();
				stackSeq.removeLast();
			}
			if (stackTransChosen.isEmpty())
				return false;
			Set<Transition> enabledTrans = stackTransChosen.getLast();

			String nextAct = stackSeq.getLast().size() > 0 ? stackSeq.getLast().get(0) : "";
			Set<Transition> tran2Remove = new HashSet<Transition>();
			Transition t = null;
			for (Transition t1 : enabledTrans) {
				if ((t1.isInvisible() && !stackExecTrans.getLast().contains(t1))
						|| (!nextAct.equals("") && t1.getLabel().equals(nextAct)))
					t = t1;
				else
					tran2Remove.add(t1);
			}
			stackTransChosen.getLast().removeAll(tran2Remove);
			stackTransChosen.getLast().remove(t);

			if (t != null) {
				Set<Place> newMarking = new HashSet<Place>(stackMarking.getLast());
				List<String> newSeq = new ArrayList<String>(stackSeq.getLast());
				Set<Transition> newExecTrans = new HashSet<Transition>(stackExecTrans.getLast());

				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eIn : pn.getInEdges(t))
					newMarking.remove(eIn.getSource());
				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eOut : pn.getOutEdges(t))
					newMarking.add((Place) eOut.getTarget());
				if (!t.isInvisible()) {
					newSeq.remove(0);
					newExecTrans.clear();
				} else
					newExecTrans.add(t);
				stackMarking.add(newMarking);
				stackExecTrans.add(newExecTrans);
				stackSeq.add(newSeq);
				stackTransChosen.add(PetrinetUtilsL.getEnabledTransitions(pn, newMarking));
			}

		}
		return false;
	}

	//	private static boolean isReplayable(Petrinet pn, List<String> seq, Set<Place> marking, Set<Place> finalMarking,
	//			Set<Transition> execTrans, List<String> currSeq) {
	//		boolean flag = false;
	//		Set<Transition> enabledTrans = PetrinetUtils.getEnabledTransitions(pn, marking);
	//		//		Set<Place> finalMarking = new HashSet<Place>();
	//		//		finalMarking.add(PetrinetUtils.getFinalPlace(pn));
	//
	//		if (noRemainingTokens(marking, pn)) {
	//			if (seq.isEmpty())
	//				flag = true;
	//			else
	//				seqPossible.add(currSeq);
	//		}
	//		String nextAct = seq.size() > 0 ? seq.get(0) : "";
	//
	//		for (Transition t : enabledTrans) {
	//			if ((t.isInvisible() && !execTrans.contains(t)) || (!nextAct.equals("") && t.getLabel().equals(nextAct))
	//					&& !flag) {
	//				Set<Place> newMarking = new HashSet<Place>(marking);
	//				List<String> newSeq = new ArrayList<String>(seq);
	//				List<String> newCurrSeq = new ArrayList<String>(currSeq);
	//				Set<Transition> newExecTrans = new HashSet<Transition>(execTrans);
	//
	//				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eIn : pn.getInEdges(t))
	//					newMarking.remove(eIn.getSource());
	//				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eOut : pn.getOutEdges(t))
	//					newMarking.add((Place) eOut.getTarget());
	//				if (!t.isInvisible()) {
	//					newSeq.remove(0);
	//					newExecTrans.clear();
	//					newCurrSeq.add(t.getLabel());
	//				} else
	//					newExecTrans.add(t);
	//
	//				if (!flag)
	//					flag = isReplayable(pn, newSeq, newMarking, finalMarking, newExecTrans, newCurrSeq);
	//			}
	//		}
	//		return flag;
	//	}

	private static boolean isReplayableSemanticsNoRec(Petrinet pn, EfficientPetrinetSemantics semantics, String seq,
			Marking marking, Marking finalMarking) {
		boolean flag = true;
		Set<String> possibleSequences;
		Set<Marking> execMarkings;
		String currSeq;

		//		AcceptingPetriNet2automaton.convert(new AcceptingPetriNetImpl(pn), 2400);

		Deque<Marking> stackMarking = new ArrayDeque<Marking>();
		Deque<Set<Marking>> stackExecMarkings = new ArrayDeque<Set<Marking>>();
		Deque<String> stackSeq = new ArrayDeque<String>();
		Deque<Collection<Transition>> stackTransChosen = new ArrayDeque<Collection<Transition>>();
		semantics.setCurrentState(marking);
		stackSeq.add(seq);
		stackMarking.add(marking);
		stackTransChosen.add(semantics.getExecutableTransitions());
		stackExecMarkings.add(new HashSet<Marking>());
		while (flag) {

			if (stackTransChosen.getLast().isEmpty() || stackExecMarkings.getLast().contains(stackMarking.getLast())) {
				if (stackSeq.getLast().isEmpty() && noRemainingTokens(stackMarking.getLast(), pn))
					return true;
				stackMarking.removeLast();
				stackExecMarkings.removeLast();
				stackTransChosen.removeLast();
				stackSeq.removeLast();
			}

			if (stackTransChosen.isEmpty())
				return false;

			if (!stackTransChosen.getLast().isEmpty()) {

				Collection<Transition> enabledTrans = stackTransChosen.getLast();

				String[] seqs = seq.split(",,,");
				String nextAct = stackSeq.getLast().length() > 0 ? seqs[0] : "";

				Transition t = enabledTrans.iterator().next();
				stackTransChosen.getLast().remove(t);

				if (t.isInvisible() || t.getLabel().equals(nextAct)) {
					Marking newMarking = new Marking(stackMarking.getLast());
					String newSeq = new String(stackSeq.getLast());
					Set<Marking> newExecMarking = new HashSet<Marking>(stackExecMarkings.getLast());

					for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eIn : pn.getInEdges(t))
						newMarking.remove(eIn.getSource());
					for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eOut : pn.getOutEdges(t))
						newMarking.add((Place) eOut.getTarget());

					if (!t.isInvisible()) {
						if (!nextAct.equals(newSeq)) {
							//							System.out.println(nextAct);
							//							System.out.println(newSeq);
							newSeq = newSeq.substring(nextAct.length() + 3, newSeq.length());
						} else
							newSeq = "";
						newExecMarking.clear();
					}

					stackMarking.add(newMarking);
					stackExecMarkings.add(newExecMarking);
					stackSeq.add(newSeq);
					semantics.setCurrentState(stackMarking.getLast());
					stackTransChosen.add(semantics.getExecutableTransitions());
				}
			}

		}
		return false;

	}

	private static boolean isReplayableSemantics(Petrinet pn, EfficientPetrinetSemantics semantics, String seq,
			Marking marking, Marking finalMarking, Set<Integer> execTrans, String currSeq, Set<String> possibleSequences) {
		boolean flag = false;
		//		Set<Transition> enabledTrans = PetrinetUtils.getEnabledTransitions(pn, marking);
		//		Set<Place> finalMarking = new HashSet<Place>();
		//		finalMarking.add(PetrinetUtils.getFinalPlace(pn));
		semantics.setCurrentState(marking);
		Collection<Transition> enabledTrans = semantics.getExecutableTransitions();

		if (noRemainingTokens(marking, pn)) {
			if (seq.isEmpty())
				flag = true;
			else
				possibleSequences.add(currSeq);
		}
		String[] seqs = seq.split(",,,");
		String nextAct = seq.length() > 0 ? seqs[0] : "";

		for (Transition t : enabledTrans) {
			if ((t.isInvisible() && !execTrans.contains(t.hashCode()))
					|| (!nextAct.equals("") && t.getLabel().equals(nextAct)) && !flag) {
				Marking newMarking = new Marking(marking);
				String newSeq = new String(seq);
				String newCurrSeq = new String(currSeq);
				Set<Integer> newExecTrans = new HashSet<Integer>(execTrans);

				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eIn : pn.getInEdges(t))
					newMarking.remove(eIn.getSource());
				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eOut : pn.getOutEdges(t))
					newMarking.add((Place) eOut.getTarget());
				if (!t.isInvisible()) {
					if (!nextAct.equals(newSeq)) {
						newSeq = newSeq.substring(nextAct.length() + 3, newSeq.length());
					} else
						newSeq = "";
					newExecTrans.clear();
					if (!newCurrSeq.isEmpty())
						newCurrSeq += ",,,";
					newCurrSeq += nextAct;
				} else
					newExecTrans.add(t.hashCode());

				if (!flag)
					flag = isReplayableSemantics(pn, semantics, newSeq, newMarking, finalMarking, newExecTrans,
							newCurrSeq, possibleSequences);
			}
		}
		return flag;
	}

	private static boolean isReplayable(Petrinet pn, String seq, Set<Place> marking, Set<Place> finalMarking,
			Set<Transition> execTrans, String currSeq, Set<String> possibleSequences) {
		boolean flag = false;
		Set<Transition> enabledTrans = PetrinetUtilsL.getEnabledTransitions(pn, marking);
		//		Set<Place> finalMarking = new HashSet<Place>();
		//		finalMarking.add(PetrinetUtils.getFinalPlace(pn));

		if (noRemainingTokens(marking, pn)) {
			if (seq.isEmpty())
				flag = true;
			else
				possibleSequences.add(currSeq);
		}
		String[] seqs = seq.split(",,,");
		String nextAct = seq.length() > 0 ? seqs[0] : "";

		for (Transition t : enabledTrans) {
			if ((t.isInvisible() && !execTrans.contains(t)) || (!nextAct.equals("") && t.getLabel().equals(nextAct))
					&& !flag) {
				Set<Place> newMarking = new HashSet<Place>(marking);
				String newSeq = new String(seq);
				String newCurrSeq = new String(currSeq);
				Set<Transition> newExecTrans = new HashSet<Transition>(execTrans);

				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eIn : pn.getInEdges(t))
					newMarking.remove(eIn.getSource());
				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> eOut : pn.getOutEdges(t))
					newMarking.add((Place) eOut.getTarget());
				if (!t.isInvisible()) {
					if (!nextAct.equals(newSeq)) {
						//						System.out.println(nextAct + newSeq + nextAct.equals(newSeq));
						newSeq = newSeq.substring(nextAct.length() + 3, newSeq.length());
					} else
						newSeq = "";
					newExecTrans.clear();
					if (!newCurrSeq.isEmpty())
						newCurrSeq += ",,,";
					newCurrSeq += nextAct;
				} else
					newExecTrans.add(t);

				if (!flag)
					flag = isReplayable(pn, newSeq, newMarking, finalMarking, newExecTrans, newCurrSeq,
							possibleSequences);
			}
		}
		return flag;
	}

	private static boolean noRemainingTokens(Set<Place> marking, Petrinet pn) {
		for (Place p : marking)
			if (!pn.getInEdges(p).isEmpty() && !pn.getOutEdges(p).isEmpty())
				return false;
		return true;
	}

	private static boolean noRemainingTokens(Marking marking, Petrinet pn) {
		for (Place p : marking)
			if (!pn.getInEdges(p).isEmpty() && !pn.getOutEdges(p).isEmpty())
				return false;
		return true;
	}

	//minimal seq that should be replayable
	private static List<String> getDeclareTemplateSeq(String a1, String a2, DeclareTemplatesL t) {

		List<String> seq = new ArrayList<String>();
		switch (t) {
			case Alternate : //ABAB
				seq.add(a1);
				seq.add(a2);
				seq.add(a1);
				seq.add(a2);
				break;
			case Alternate_A : //ABA
				seq.add(a1);
				seq.add(a2);
				seq.add(a1);
				break;
			case Choice : //A
				seq.add(a1);
				break;
			case RepeatAAlternate : //AABAB
				seq.add(a1);
				seq.add(a1);
				seq.add(a2);
				seq.add(a1);
				seq.add(a2);
				break;
			case RepeatAAlternate_A : //AABABA
				seq.add(a1);
				seq.add(a1);
				seq.add(a2);
				seq.add(a1);
				seq.add(a2);
				seq.add(a1);
				break;
			case RepeatAResponse : //AAB
				seq.add(a1);
				seq.add(a1);
				seq.add(a2);
				break;
			case RepeatBAlternate : //ABBAB
				seq.add(a1);
				seq.add(a2);
				seq.add(a2);
				seq.add(a1);
				seq.add(a2);
				break;
			case RepeatBAlternate_A : //ABBA
				seq.add(a1);
				seq.add(a2);
				seq.add(a2);
				seq.add(a1);
				break;
			case RepeatBResponse : //ABB
				seq.add(a1);
				seq.add(a2);
				seq.add(a2);
				break;
			case RepeatBothAlternate : //AABBAB
				seq.add(a1);
				seq.add(a1);
				seq.add(a2);
				seq.add(a2);
				seq.add(a1);
				seq.add(a2);
				break;
			case RepeatBothAlternate_A : //AABBABA
				seq.add(a1);
				seq.add(a1);
				seq.add(a2);
				seq.add(a2);
				seq.add(a1);
				seq.add(a2);
				seq.add(a1);
				break;
			case RepeatBothResponse : //AABB
				seq.add(a1);
				seq.add(a1);
				seq.add(a2);
				seq.add(a2);
				break;
			case Response : //AB
				seq.add(a1);
				seq.add(a2);
				break;
			default :
				break;

		}
		return seq;
	}
}
