package org.processmining.decomposelogs;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.models.semantics.petrinet.impl.EfficientPetrinetSemanticsImpl;

public class Net2DeclareNewL {

	public static Set<DeclarePairsL> net2Declare(PluginContext context, AcceptingPetriNet apn) {
		Petrinet pn = apn.getNet();
		Set<DeclarePairsL> dps = new HashSet<DeclarePairsL>();
		String a1 = "", a2 = "";

		for (Transition t : pn.getTransitions())
			if (!t.isInvisible()) {
				if (a1 == "")
					a1 = t.getLabel();
				else if (a2 == "" & !a1.equals(t.getLabel()))
					a2 = t.getLabel();
			}

		//	dps.addAll(Net2DeclareAuto.getStats(context, pn, a1, a2));

		dps.addAll(getDeclareTemplates(a1, a2, apn));
		dps.addAll(getDeclareTemplates(a2, a1, apn));
		if (isEmptyTraceAllowed(apn)) {
			dps.add(new DeclarePairsL(a1, a2, DeclareTemplatesL.None));
			dps.add(new DeclarePairsL(a2, a1, DeclareTemplatesL.None));
		}
		return dps;
	}

	//	public static AggregatedHeuristics net2DeclareAll(PluginContext context, Petrinet pn) {
	//		Set<DeclarePairs> dps = new HashSet<DeclarePairs>();
	//		Map<byte[], Short> indexMap = new HashMap<byte[], Short>();
	//		List<byte[]> actComb = new ArrayList<byte[]>();
	//		List<Set<DeclarePairs2>> dpForNets = new ArrayList<Set<DeclarePairs2>>();
	//		Set<String> actStr = new HashSet<String>();
	//		for (Transition t : pn.getTransitions())
	//			if (!t.isInvisible())
	//				actStr.add(t.getLabel());
	//		byte[] acts = new byte[actStr.size()];
	//		int i = 0;
	//		Map<Byte, String> byte2Act = new HashMap<Byte, String>();
	//		Map<String, Byte> act2Byte = new HashMap<String, Byte>();
	//		Iterator<int[]> iterComb = CombinatoricsUtils.combinationsIterator(acts.length, 2);
	//		for (String s : actStr) {
	//			acts[i] = (byte) i;
	//			byte2Act.put(acts[i], s);
	//			act2Byte.put(s, acts[i]);
	//			i++;
	//		}
	//
	//		PetriNetMap pnmap = new PetriNetMap(pn);
	//		//		for (Transition t : pnmap.getPetriNet().getTransitions()) {
	//		//			if (!t.isInvisible())
	//		//				t.getAttributeMap().put(AttributeMap.LABEL, act2Byte.get(t.getLabel()));
	//		//		}
	//		List<Set<DeclarePairs2>> decPairs = new ArrayList<Set<DeclarePairs2>>();
	//		while (iterComb.hasNext()) {
	//			int[] c = iterComb.next();
	//			byte[] b = new byte[] { (byte) c[0], (byte) c[1] };
	//			AcceptingPetriNet apn = new AcceptingPetriNetImpl(new PetriNetMap(pn).getPetriNet());
	//			for (Transition t : apn.getNet().getTransitions()) {
	//				if (!t.isInvisible() && (byte) c[0] != act2Byte.get(t.getLabel())
	//						&& (byte) c[1] != act2Byte.get(t.getLabel()))
	//					t.setInvisible(true);
	//			}
	//			ReduceAcceptingPetriNetKeepLanguage.reduce(apn, new Canceller() {
	//				public boolean isCancelled() {
	//					return false;
	//				}
	//			});
	//			getDeclareTemplates(byte2Act.get((byte) c[0]), byte2Act.get((byte) c[1]), apn.getNet());
	//			getDeclareTemplates(byte2Act.get((byte) c[1]), byte2Act.get((byte) c[0]), apn.getNet());
	//
	//		}
	//
	//		return null;
	//	}

	public static boolean isEmptyTraceAllowed(AcceptingPetriNet pn) {
		Marking initialMarking = new Marking();

		Set<Marking> finalMarking = (pn.getFinalMarkings());
		for (Place p : pn.getNet().getPlaces()) {
			if (pn.getNet().getInEdges(p).isEmpty() && !initialMarking.contains(p))
				initialMarking.add(p);
			//			if (pn.getOutEdges(p).isEmpty())
			//				finalMarking.add(p);
		}
		EfficientPetrinetSemanticsImpl semantics = new EfficientPetrinetSemanticsImpl(pn.getNet(), initialMarking);
		return isEndStateReachable(pn, semantics, initialMarking, new HashSet<Marking>(), true);
	}

	private static Set<DeclarePairsL> getDeclareTemplates(String A, String B, AcceptingPetriNet pn) {
		Set<DeclarePairsL> dps = new HashSet<DeclarePairsL>();
		//		Petrinet pn = apn.getNet();
		Marking initialMarking = new Marking();

		Set<Marking> finalMarking = (pn.getFinalMarkings());
		for (Place p : pn.getNet().getPlaces()) {
			if (pn.getNet().getInEdges(p).isEmpty() && !initialMarking.contains(p))
				initialMarking.add(p);
			//			if (pn.getOutEdges(p).isEmpty())
			//				finalMarking.add(p);
		}
		EfficientPetrinetSemanticsImpl semantics = new EfficientPetrinetSemanticsImpl(pn.getNet(), initialMarking);
		/* A -> Choice */
		Marking marking = replay(pn, semantics, initialMarking, new HashSet<Marking>(), A);
		if (A.equals("O_CREATED") && B.equals("O_CANCELLED"))
			System.out.println(marking);
		if (marking != null) {
			//			semantics.setCurrentState(marking);
			if (isEndStateReachable(pn, semantics, marking, new HashSet<Marking>(), true))
				dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.Choice));
			if (A.equals("O_CREATED") && B.equals("O_CANCELLED"))
				System.out.println(marking);
			// AB -> Response
			Marking markingAB = replay(pn, semantics, marking, new HashSet<Marking>(), B);
			if (A.equals("O_CREATED") && B.equals("O_CANCELLED"))
				System.out.println("markingAB" + markingAB);
			if (markingAB != null) {
				//				semantics.setCurrentState(markingAB);
				if (isEndStateReachable(pn, semantics, markingAB, new HashSet<Marking>(), true))
					dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.Response));
				// ABB -> RepeatBReponse
				Marking markingABB = replay(pn, semantics, markingAB, new HashSet<Marking>(), B);
				if (markingABB != null) {
					//					semantics.setCurrentState(markingABB);
					if (isEndStateReachable(pn, semantics, markingABB, new HashSet<Marking>(), true))
						dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatBResponse));
					// ABBA -> RepeatBAlternate_A
					Marking markingABBA = (replay(pn, semantics, markingABB, new HashSet<Marking>(), A));
					if (markingABBA != null) {
						//						semantics.setCurrentState(markingABBA);
						if (isEndStateReachable(pn, semantics, markingABBA, new HashSet<Marking>(), true))
							dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatBAlternate_A));
						// ABBAB -> RepeatBAlternate
						Marking markingABBAB = (replay(pn, semantics, markingABBA, new HashSet<Marking>(), B));
						if (markingABBAB != null) {
							//							semantics.setCurrentState(markingABBAB);
							if (isEndStateReachable(pn, semantics, markingABBAB, new HashSet<Marking>(), true))
								dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatBAlternate));
						}
					}
				}
				// ABA -> Alternate_A
				Marking markingABA = (replay(pn, semantics, markingAB, new HashSet<Marking>(), A));
				if (markingABA != null) {
					//					semantics.setCurrentState(markingABA);
					if (isEndStateReachable(pn, semantics, markingABA, new HashSet<Marking>(), false))
						dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.Alternate_A));
					//ABAB -> Alternate		
					Marking markingABAB = (replay(pn, semantics, markingABA, new HashSet<Marking>(), B));
					if (markingABAB != null) {
						//						semantics.setCurrentState(markingABAB);
						if (isEndStateReachable(pn, semantics, markingABAB, new HashSet<Marking>(), false))
							dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.Alternate));
					}
				}

			}
			// AAB -> RepeatAResponse
			Marking markingAAB = (replay(pn, semantics, marking, new HashSet<Marking>(), A));
			if (markingAAB != null) {
				//				semantics.setCurrentState(markingAAB);
				markingAAB = (replay(pn, semantics, markingAAB, new HashSet<Marking>(), B));
				if (markingAAB != null) {
					//					semantics.setCurrentState(markingAAB);
					if (isEndStateReachable(pn, semantics, markingAAB, new HashSet<Marking>(), false))
						dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatAResponse));
					// AABA
					Marking markingAABA = (replay(pn, semantics, markingAAB, new HashSet<Marking>(), A));
					if (markingAABA != null) {
						//						semantics.setCurrentState(markingAABA);
						//AABAB -> RepeatAAlternate
						Marking markingAABAB = (replay(pn, semantics, markingAABA, new HashSet<Marking>(), B));
						if (markingAABAB != null) {
							//							semantics.setCurrentState(markingAABAB);
							if (isEndStateReachable(pn, semantics, markingAABAB, new HashSet<Marking>(), false))
								dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatAAlternate));
							//AABABA -> RepeatAAlternate_A 
							Marking markingAABABA = (replay(pn, semantics, markingAABAB, new HashSet<Marking>(), A));
							if (markingAABABA != null)
								//								semantics.setCurrentState(markingAABABA);
								if (isEndStateReachable(pn, semantics, markingAABABA, new HashSet<Marking>(), false))
									dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatAAlternate_A));
						}
					}
					// AABB -> RepeatBothResponse
					Marking markingAABB = (replay(pn, semantics, markingAAB, new HashSet<Marking>(), B));
					if (markingAABB != null) {
						//						semantics.setCurrentState(markingAABB);
						if (isEndStateReachable(pn, semantics, markingAABB, new HashSet<Marking>(), false))
							dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatBothResponse));
						//AABBAB -> RepeatBothAlternate
						Marking markingAABBA = (replay(pn, semantics, markingAABB, new HashSet<Marking>(), A));
						if (markingAABBA != null) {
							//							semantics.setCurrentState(markingAABBA);
							if (isEndStateReachable(pn, semantics, markingAABBA, new HashSet<Marking>(), false))
								dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatBothAlternate));

							Marking markingAABBAB = (replay(pn, semantics, markingAABBA, new HashSet<Marking>(), B));
							if (markingAABBAB != null) {
								//AABBABA -> RepeatBothAlternate_A
								Marking markingAABBABA = (replay(pn, semantics, markingAABBAB, new HashSet<Marking>(),
										B));
								if (markingAABBABA != null
										&& isEndStateReachable(pn, semantics, markingAABBABA, new HashSet<Marking>(),
												false))
									dps.add(new DeclarePairsL(A, B, DeclareTemplatesL.RepeatBothAlternate_A));

							}
						}
					}
				}
			}
		}
		return dps;

	}

	//assuming non-duplicates - else TODO do full recursion -i.e. without checks of first loop
	static Marking replay(AcceptingPetriNet apn, EfficientPetrinetSemanticsImpl semantics, Marking marking,
			Set<Marking> execMarkings, String act) {
		Marking markingReached = null;

		//initiate only once
		if (marking != null)
			semantics.setStateAsMarking(marking);

		if (!execMarkings.add(semantics.getCurrentState()))
			return null;

		Collection<Transition> enabledTrans = semantics.getExecutableTransitions();
		Marking currMarking = semantics.getCurrentState();
		for (Transition t : enabledTrans)
			if (!t.isInvisible() && t.getLabel().equals(act)) {
				semantics.directExecuteExecutableTransition(t);
				markingReached = semantics.getStateAsMarking();
				return markingReached;
			}
		//only tau's remaining?
		for (Transition t : enabledTrans) {
			if (t.isInvisible() && markingReached == null) {
				semantics.setCurrentState(currMarking);
				semantics.directExecuteExecutableTransition(t);
				markingReached = replay(apn, semantics, null, execMarkings, act);
			}
		}
		return markingReached == null ? null : new Marking(markingReached);
	}

	private static boolean isEndStateReachable(AcceptingPetriNet apn, EfficientPetrinetSemanticsImpl semantics,
			Marking marking, Set<Marking> execMarkings, boolean notChoice) {
		//accept incomplete traces - assume every reachable state is end state
		if (!notChoice)
			return true;

		boolean flag = false;
		//initiate only once
		if (marking != null)
			semantics.setStateAsMarking(marking);

		if (noRemainingTokens(semantics.getCurrentState(), apn)
				|| (apn.getFinalMarkings().contains(semantics.getCurrentState())))
			return true;
		if (!execMarkings.add(semantics.getCurrentState()))
			return false;
		Marking currMarking = semantics.getCurrentState();
		Collection<Transition> enabledTrans = semantics.getExecutableTransitions();
		for (Transition t : enabledTrans) {
			semantics.setCurrentState(currMarking);
			if (t.isInvisible() && !flag) {
				semantics.directExecuteExecutableTransition(t);
				flag = isEndStateReachable(apn, semantics, null, execMarkings, notChoice);
			}
		}
		return flag;
	}

	private static boolean noRemainingTokens(Set<Place> marking, Petrinet pn) {
		for (Place p : marking)
			if (!pn.getInEdges(p).isEmpty() && !pn.getOutEdges(p).isEmpty())
				return false;
		return true;
	}

	private static boolean noRemainingTokens(Marking marking, AcceptingPetriNet pn) {
		if (pn.getInitialMarking().equals(marking))
			return false;

		for (Place p : marking)
			if (!pn.getNet().getInEdges(p).isEmpty() && !pn.getNet().getOutEdges(p).isEmpty())
				return false;
		return true;
	}
}
