package org.processmining.decomposelogs;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.prabhakardixit.alignments.CombinationUtilsL;

public class PairwiseLog2DeclareL {

	public static PairwiseLogHeuristicL getAggPairHeuristics(XLog log) {

		PairwiseLogHeuristicL globalTraceSeq = new PairwiseLogHeuristicL();
		Map<String, Short> act2Short = new HashMap<String, Short>();

		List<Set<Short>> addedPairs = new ArrayList<Set<Short>>();

		Map<Short, Short> actFeq = new HashMap<Short, Short>();
		//declare constraint generation code starts
		for (XTrace trace : log) {
			Set<Short> newActs = new HashSet<Short>();
			Set<Short> addedActsToTrace = new HashSet<Short>();
			Map<Set<Short>, Short[]> traceSeq = new HashMap<Set<Short>, Short[]>();
			for (XEvent event : trace) {
				String act = XConceptExtension.instance().extractName(event);
				Short shortAct;
				if (!act2Short.containsKey(act)) {
					act2Short.put(act, (short) (act2Short.size() + 1));
					newActs.add(act2Short.get(act));
					actFeq.put(act2Short.get(act), (short) 1);
					globalTraceSeq.short2Act.put(act2Short.get(act), act);
				} else
					actFeq.put(act2Short.get(act), (short) (actFeq.get(act2Short.get(act)) + 1));

				shortAct = act2Short.get(act);

				if (addedActsToTrace.contains(act))
					for (Set<Short> seqs : traceSeq.keySet()) {
						if (seqs.contains(shortAct)) {
							Short[] newSeq = new Short[traceSeq.get(seqs).length + 1];
							for (int i = 0; i < traceSeq.get(seqs).length; i++)
								newSeq[i] = traceSeq.get(seqs)[i];

							newSeq[newSeq.length] = shortAct;
							traceSeq.put(seqs, newSeq);
						}
					}

				else {
					for (Short s : addedActsToTrace) {
						Set<Short> pair = new HashSet<Short>();
						pair.add(shortAct);
						pair.add(s);
						for (Set<Short> p : addedPairs)
							if (p.equals(pair))
								pair = p;

						Short[] seq = new Short[] { s, shortAct };
						traceSeq.put(pair, seq);
					}
					addedActsToTrace.add(shortAct);
				}
			}

			//add choices corresponding to addedActsInTrace vs all the other acts
			for (Short a1 : act2Short.values()) {
				if (!addedActsToTrace.contains(a1) && !newActs.contains(a1)) {
					for (Short s : addedActsToTrace) {
						Set<Short> pair = new HashSet<Short>();
						pair.add(a1);
						pair.add(s);
						for (Set<Short> p : addedPairs)
							if (p.equals(pair))
								pair = p;

						Short[] seq = new Short[] { s };
						traceSeq.put(pair, seq);
					}
				}
			}

			//add choices corresponding to new Acts and globalTraceSeq
			for (Short a1 : newActs) {
				for (Short s : actFeq.keySet()) {
					if (!a1.equals(s)) {
						Set<Short> pair = new HashSet<Short>();
						pair.add(a1);
						pair.add(s);
						for (Set<Short> p : addedPairs)
							if (p.equals(pair))
								pair = p;

						Short[] seq = new Short[] { a1 };
						addedPairs.add(pair);
						globalTraceSeq.traceCount.put(pair, new HashMap<Short[], Short>());
						globalTraceSeq.traceCount.get(pair).put(seq, actFeq.get(s));
					}
				}
			}

			for (Set<Short> pair : traceSeq.keySet()) {
				if (addedPairs.contains(pair)) {
					boolean added = false;
					for (Short[] gs : globalTraceSeq.traceCount.get(pair).keySet()) {
						if (Arrays.equals(traceSeq.get(pair), gs)) {
							added = true;
							globalTraceSeq.traceCount.get(pair).put(gs,
									(short) (globalTraceSeq.traceCount.get(pair).get(gs) + 1));
						}
					}
					if (!added)
						globalTraceSeq.traceCount.get(pair).put(traceSeq.get(pair), (short) 1);

				} else {
					addedPairs.add(pair);
					globalTraceSeq.traceCount.put(pair, new HashMap<Short[], Short>());
					globalTraceSeq.traceCount.get(pair).put(traceSeq.get(pair), (short) 1);

				}
			}

		}

		globalTraceSeq.act2Short = act2Short;
		globalTraceSeq.actCombs = addedPairs;
		return globalTraceSeq;

	}

	private static void removeInvalidLastActs(Set<DeclarePairsL> dps) {
		Set<DeclarePairsL> pairsToRemove = new HashSet<DeclarePairsL>();
		for (DeclarePairsL dp : dps) {
			switch (dp.getTemplate()) {
				case Alternate :
				case RepeatAAlternate :
				case RepeatBResponse :
				case RepeatBothAlternate :
				case RepeatBothResponse :
				case Response :
				case RepeatAResponse :
				case RepeatBAlternate :
					if (dp.getLastAct().equals(dp.getAct1()))
						pairsToRemove.add(dp);
					break;
				case Alternate_A :
				case Choice :
				case RepeatAAlternate_A :
				case RepeatBAlternate_A :
				case RepeatBothAlternate_A :
					if (!dp.getLastAct().equals(dp.getAct1()))
						pairsToRemove.add(dp);
					break;
				default :
					break;

			}
		}
		dps.removeAll(pairsToRemove);
	}

	//	private static void updateGlobalDps(Set<DeclarePairs> globaldps, Set<DeclarePairs> dps) {
	//		Set<DeclarePairs> newdps = new HashSet<DeclarePairs>();
	//		for (DeclarePairs dp : dps) {
	//			boolean ind = false;
	//			for (DeclarePairs d : globaldps) {
	//				if (dp.getAct1().equals(d.getAct1()) && dp.getAct2().equals(d.getAct2())
	//						&& dp.getTemplate().equals(d.getTemplate())) {
	//					ind = true;
	//					d.setFreq((short) (d.getFreq() + 1));
	//
	//				}
	//
	//			}
	//			if (!ind) {
	//				newdps.add(new DeclarePairs(dp));
	//				globaldps.addAll(newdps);
	//			}
	//
	//		}
	//
	//	}

	private static void updateListCandidates(List<Set<DeclarePairsL>> aggLogH, Set<DeclarePairsL> dps,
			List<Set<String>> actCombs) {
		Set<DeclarePairsL> newdps = new HashSet<DeclarePairsL>();

		for (DeclarePairsL dp : dps) {
			int index = -1, i = 0;
			boolean ind = false, end = false;
			while (!end) {
				if (actCombs.get(i).contains(dp.getAct1()) && actCombs.get(i).contains(dp.getAct2()))
					index = i;
				i++;

				if (i >= actCombs.size() || index != -1)
					end = true;

			}
			for (DeclarePairsL d : aggLogH.get(index)) {
				if (dp.getAct1().equals(d.getAct1()) && dp.getAct2().equals(d.getAct2())
						&& dp.getTemplate().equals(d.getTemplate())) {
					ind = true;
					d.setFreq((short) (d.getFreq() + 1));
				}

			}
			if (!ind) {
				aggLogH.get(index).add(new DeclarePairsL(dp));
			}
		}
	}

	private static void updateLastAct(Set<DeclarePairsL> dps, String act) {
		for (DeclarePairsL dp : dps)
			if (dp.getAct1().equals(act) || dp.getAct2().equals(act))
				dp.setLastAct(act);

	}

	private static void keepMostStrictConstraint(Set<DeclarePairsL> dps, Set<String> events) {
		Set<DeclarePairsL> declarePairs = new HashSet<DeclarePairsL>();
		Map<Integer, String> actMap = new HashMap<Integer, String>();
		int i = 0;
		for (String e : events)
			actMap.put(i++, e);

		Set<Set<Integer>> combs = CombinationUtilsL.getAllCombs(actMap.keySet(), 2);

		for (Set<Integer> comb : combs) {
			List<String> acts = new ArrayList<String>();
			Set<DeclarePairsL> pairsWithAct = new HashSet<DeclarePairsL>();
			for (int j : comb)
				acts.add(actMap.get(j));
			for (DeclarePairsL dp : dps) {
				if (acts.contains(dp.getAct1()) && acts.contains(dp.getAct2()))
					pairsWithAct.add(dp);
			}

			if (acts.contains("c") && acts.contains("d")) {
				System.out.println("");
			}

			//keep restricting pairs
			DeclarePairsL d = null;
			int id = 99;
			for (DeclarePairsL dp : pairsWithAct) {
				if (scoreDeclareTemplates(dp.getTemplate()) <= id) {
					if (id == scoreDeclareTemplates(dp.getTemplate())) {
						d = (d.getAct1().equals(d.getLastAct()) && d.getTemplate().toString().contains("_A")) ? d : dp;
					} else {
						id = scoreDeclareTemplates(dp.getTemplate());
						d = dp;
					}
				}
			}

			//remove all other
			if (d != null) {
				dps.removeAll(pairsWithAct);
				dps.add(d);
			}
		}

	}

	//add declare pairs corresponding to the newly added activity
	private static void addDeclarePairs(String act, Set<String> actsNotAdded, Set<DeclarePairsL> dps) {
		for (String actNotAdded : actsNotAdded) {
			for (DeclareTemplatesL temp : DeclareTemplatesL.values()) {
				DeclarePairsL dp1 = new DeclarePairsL(act, actNotAdded);
				dp1.setTemplate(temp);
				dps.add(dp1);
			}
		}

	}

	//remove pairs which are no longer valid
	private static void removeInvaliadtedPairs(String act, Set<String> addedActs, Set<DeclarePairsL> dps) {
		Set<DeclarePairsL> dpsToRemove = new HashSet<DeclarePairsL>();
		if (act.equals("c"))
			System.out.println();

		for (DeclarePairsL dp : dps) {
			if (dp.getAct1().equals(act) || dp.getAct2().equals(act)) {
				switch (dp.getTemplate()) {

					case Choice :
						if (dp.getAct2().equals(act))
							dpsToRemove.add(dp);
						break;

					case RepeatBothResponse :
						if (dp.getLastAct().equals(dp.getAct2()) && dp.getAct1().equals(act)) //BA not allowed
							dpsToRemove.add(dp);
						break;

					case Response :
						if (dp.getLastAct().equals(dp.getAct2()) && dp.getAct1().equals(act)
								|| (dp.getLastAct().equals(act))) //BA or BB or AA not allowed
							dpsToRemove.add(dp);
						break;

					case RepeatAResponse :
						if ((dp.getLastAct().equals(dp.getAct2()) && dp.getAct1().equals(act))
								|| (dp.getLastAct().equals(act) && dp.getAct2().equals(act)))//BA or BB  not allowed
							dpsToRemove.add(dp);
						break;
					case RepeatBResponse :
						if ((dp.getLastAct().equals(dp.getAct2()) && dp.getAct1().equals(act))
								|| (dp.getLastAct().equals(act) && dp.getAct1().equals(act)))//BA or AA  not allowed
							dpsToRemove.add(dp);
						break;

					case Alternate :
					case Alternate_A :
						if (dp.getLastAct().equals(act)) //repeats not allowed
							dpsToRemove.add(dp);
						break;

					case RepeatAAlternate :
					case RepeatAAlternate_A :
						if (dp.getLastAct().equals(act) && dp.getAct2().equals(act)) //BB allowed
							dpsToRemove.add(dp);
						break;

					case RepeatBAlternate :
					case RepeatBAlternate_A :
						if (dp.getLastAct().equals(act) && dp.getAct1().equals(act)) //AA not allowed
							dpsToRemove.add(dp);
						break;

					case RepeatBothAlternate : // last one standing
						break;
					case RepeatBothAlternate_A :
						break;
					default :
						break;

				}
			}
		}

		dps.removeAll(dpsToRemove);

	}

	//create empty declare constraint - each pair has ALL the pairs - remove the pairs one by one 
	private static Set<DeclarePairsL> getInitialDP(Set<String> events) {
		Set<DeclarePairsL> declarePairs = new HashSet<DeclarePairsL>();
		Map<Integer, String> actMap = new HashMap<Integer, String>();
		int i = 0;
		for (String e : events)
			actMap.put(i++, e);

		Set<Set<Integer>> combs = CombinationUtilsL.getAllCombs(actMap.keySet(), 2);

		for (Set<Integer> comb : combs) {
			List<String> acts = new ArrayList<String>();
			for (int j : comb)
				acts.add(actMap.get(j));

			DeclarePairsL dp1 = new DeclarePairsL(acts.get(0), acts.get(1));
			DeclarePairsL dp2 = new DeclarePairsL(acts.get(1), acts.get(0));
			for (DeclareTemplatesL temp : DeclareTemplatesL.values()) {
				dp1.setTemplate(temp);
				dp2.setTemplate(temp);
			}
			declarePairs.add(dp1);
			declarePairs.add(dp2);
		}

		return declarePairs;

	}

	private static Integer scoreDeclareTemplates(DeclareTemplatesL dt) {
		switch (dt) {
			case Choice :
				return 0;
			case Response :
				return 1;
			case RepeatAResponse :
				return 2;
			case RepeatBResponse :
				return 3;
			case RepeatBothResponse :
				return 4;

			case Alternate :
			case Alternate_A :
				return 5;

			case RepeatAAlternate :
			case RepeatAAlternate_A :
				return 6;

			case RepeatBAlternate :
			case RepeatBAlternate_A :
				return 7;

			case RepeatBothAlternate :
			case RepeatBothAlternate_A :
				return 8;
			default :
				break;

		}
		return -1;
	}
}
