package org.processmining.humbertogarciacaballero.models.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.UIManager;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.humbertogarciacaballero.models.model.PNConstantsL;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.logHeuristics.HeuristicsInfoL;

import prefuse.data.Graph;

import com.fluxicon.slickerbox.factory.SlickerFactory;

@SuppressWarnings("serial")
public class PNetVisualizerGUIL extends JFrame {

	// GUI Components
	private JPanel mainGraphPanel;
	private JPanel miniMapPanel;
	private JPanel graphPanel;
	private ToolBarGUIL toolBar;
	private JTextField searchField;

	// The controller
	private PNetVisualizerControllerL controller;
	private JLabel lblSearch;
	private JLabel lblSearch2;
	private JPanel panel_3;
	//	private JPanel panel;
	private JPanel panel;

	//PMD Dq panel - added to panel
	//	private JPanel panel1;
	//	private JPanel panel2;

	public PNetVisualizerGUIL(Graph graph, InteractivePetriNetL ipn) {
		super("PNet Visualizer");
		setMinimumSize(new Dimension(400, 400));
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
		}

		controller = ipn.getController();
		controller.initController(graph, null);
		controller.setIPN(ipn); //PMD

		init();
	}

	//	//PMD added IPN starts
	//	public PNetVisualizerGUI(Graph graph, InteractivePetriNet ipn) {
	//		super("Dynamic Petri Net Visualizer");
	//		setMinimumSize(new Dimension(400, 400));
	//		//		controller = PNetVisualizerController.getInstance();
	//		controller = ipn.getController();
	//		controller.initController(graph, this, null, null, pa);
	//		controller.setIPN(ipn); //PMD
	//		init(null);
	//	}

	//PMD added IPN ends

	private void init() {
		// Ensure application exits when window is closed
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Maximizes the frame
		setExtendedState(JFrame.MAXIMIZED_BOTH);

		graphPanel = new JPanel(new BorderLayout());
		getContentPane().add(graphPanel, BorderLayout.CENTER);

		JPanel optionsPanel = new JPanel();
		optionsPanel.setPreferredSize(new Dimension(200, 10));
		//		graphPanel.add(optionsPanel, BorderLayout.EAST);
		optionsPanel.setLayout(new BorderLayout(0, 0));

		JPanel parametersPanel = new JPanel();
		optionsPanel.add(parametersPanel, BorderLayout.CENTER);
		parametersPanel.setLayout(new BoxLayout(parametersPanel, BoxLayout.Y_AXIS));

		JPanel itemInformationPanel = new JPanel();
		itemInformationPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Settings",
				TitledBorder.LEFT, TitledBorder.TOP, null, new Color(0, 0, 0)));
		parametersPanel.add(itemInformationPanel);
		itemInformationPanel.setLayout(new BorderLayout(0, 0));

		panel_3 = new JPanel();
		panel_3.setLayout(new BoxLayout(panel_3, BoxLayout.Y_AXIS));
		itemInformationPanel.add(panel_3, BorderLayout.CENTER);
		graphPanel.add(panel_3, BorderLayout.EAST);
		controller.setInfoPanel(panel_3);

		panel = new JPanel();

		mainGraphPanel = new JPanel(new BorderLayout());

		JPanel heuInfoPanel = new JPanel();
		heuInfoPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Heuristic Info",
				TitledBorder.LEFT, TitledBorder.TOP, null, new Color(0, 0, 0)));

		//PMD if DQ then dont add heuPanel
		if (!controller.getIPN().isDataQuality())
			panel_3.add(heuInfoPanel, BorderLayout.CENTER);

		//		graphPanel.add(mainGraphPanel, BorderLayout.CENTER);

		//        lblSearch2= new JLabel("Search:");
		//		panel.add(lblSearch2);

		JScrollPane scrollPane = new JScrollPane();
		JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, mainGraphPanel, scrollPane);
		splitPane.setResizeWeight(1d);
		//		splitPane.setLayout(new BorderLayout());
		//		splitPane.add(mainGraphPanel, BorderLayout.CENTER);
		//		splitPane.add(panel, BorderLayout.SOUTH);
		scrollPane.setViewportView(panel);
		controller.setStatisticsPanel(panel);

		//		mainGraphPanel.add(panel, BorderLayout.SOUTH);
		graphPanel.add(splitPane, BorderLayout.CENTER);
		//PMD start adding combo boxes for configuration

		JPanel charInfoPanel = new JPanel();
		charInfoPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Chart Display",
				TitledBorder.LEFT, TitledBorder.TOP, null, new Color(0, 0, 0)));
		JPanel classifyPanel = new JPanel();
		classifyPanel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Classify",
				TitledBorder.LEFT, TitledBorder.TOP, null, new Color(0, 0, 0)));

		//classification inputs

		//PMD IPN starts
		//		JPanel itemInformationPanel2 = new JPanel();
		//		itemInformationPanel2.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Heuristics Info",
		//				TitledBorder.LEFT, TitledBorder.TOP, null, new Color(0, 0, 0)));
		//		parametersPanel.add(itemInformationPanel2);
		//		itemInformationPanel2.setLayout(new BorderLayout(0, 0));

		JButton btn = new JButton("Save me");
		btn.addActionListener(new ActionListener() {
			int count = 0;

			public void actionPerformed(ActionEvent e) {
				FileOutputStream fileOutPutStream;
				try {
					fileOutPutStream = new FileOutputStream(count++ + ".png");
					//		ExportAsPDF.convertToPdf(this, this.WIDTH, this.HEIGHT, "");
					controller.getMainView().getDisplay().saveImage(fileOutPutStream, "png", 5.);

					fileOutPutStream.flush();
					fileOutPutStream.close();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}

				System.out.println("xxx22");

			}
		});
				panel_3.add(btn);

		JButton btn2 = new JButton("SetAct");
		btn2.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				controller.setActivity("");
			}
		});
		//		panel_3.add(btn2);

		String events[] = new String[controller.getIPN().getSortedEventNames().size() + 1];
		int i = 0;
		events[i] = "";
		//		events[++i] = "";
		if (controller.getIPN() != null)
			for (String event : controller.getIPN().getSortedEventNames())
				events[++i] = event;

		//PMD add combo here starts

		final HeuristicsInfoL heuristicsInfo = new HeuristicsInfoL();

		//add activityCombo to controller - to be used during prediction
		final JCheckBox isSilent = SlickerFactory.instance().createCheckBox("Is silent?", true);

		final JLabel actLbl = new JLabel("Select activity:");
		actLbl.setAlignmentX(Component.CENTER_ALIGNMENT);
		//heuInfoPanel.add(new JLabel("Information Panel:",SwingConstants.LEFT));
		heuInfoPanel.add(actLbl);
		heuInfoPanel.add(isSilent);
		final JComboBox<String> activityCombo = SlickerFactory.instance().createComboBox(events);
		//		final JComboBox<String> activityCombo = new JComboBox<String>(events);
		activityCombo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.setActivity(activityCombo.getSelectedItem().toString());
				heuristicsInfo.updateDirectRelations(controller);
				heuristicsInfo.updateHeuristics(controller.getIPN());
				controller.executeLayout(false);
				if (controller.getActivity() != "")
					isSilent.setSelected(false);
			}
		});

		isSilent.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (isSilent.isSelected()) {
					controller.setActivity("");
					activityCombo.setSelectedIndex(0);
					heuristicsInfo.updateDirectRelations(controller);
					heuristicsInfo.updateHeuristics(controller.getIPN());
					controller.executeLayout(false);
				}
			}
		});
		heuInfoPanel.add(activityCombo);
		heuInfoPanel.add(heuristicsInfo.getPanel());
		heuInfoPanel.setLayout(new BoxLayout(heuInfoPanel, BoxLayout.Y_AXIS));
		heuInfoPanel.setPreferredSize(new Dimension(200, 550));

		controller.setActivityCombo(activityCombo);

		mainGraphPanel.add(controller.getMainView().getDisplay(), BorderLayout.CENTER);

		miniMapPanel = new JPanel(new BorderLayout());
		miniMapPanel.setPreferredSize(new Dimension(10, 150));
		miniMapPanel.add(controller.getMiniMap().getDisplay(), BorderLayout.CENTER);
		optionsPanel.add(miniMapPanel, BorderLayout.SOUTH);

		JPanel panel_1 = new JPanel();
		getContentPane().add(panel_1, BorderLayout.NORTH);
		panel_1.setLayout(new BorderLayout(0, 0));

		// Creates and adds the toolbar
		toolBar = new ToolBarGUIL(this, controller.getMainView().getDisplay(), controller);
		panel_1.add(toolBar, BorderLayout.WEST);

		JPanel panel_2 = new JPanel();
		FlowLayout flowLayout = (FlowLayout) panel_2.getLayout();
		flowLayout.setVgap(10);
		panel_1.add(panel_2, BorderLayout.EAST);

		searchField = new JTextField();
		SearchFieldListener sfl = new SearchFieldListener();
		searchField.addActionListener(sfl);
		searchField.getDocument().addDocumentListener(sfl);
		searchField.addKeyListener(sfl);

		lblSearch = new JLabel("Search:");
		panel_2.add(lblSearch);
		panel_2.add(searchField);
		searchField.setMargin(new Insets(0, 2, 2, 2));
		searchField.setColumns(30);
		searchField.setText("Ctrl+F to search");
		searchField.setEnabled(false);

		loadEvents();

		// Prepares the window.
		pack();
	}

	private void loadEvents() {
		graphPanel.addComponentListener(new ComponentAdapter() {
			private boolean firstTime = true;

			@Override
			public void componentResized(ComponentEvent e) {
				if (firstTime) {
					firstTime = !firstTime;
				} else {
					resizeHandler();
				}
			}
		});

		graphPanel.registerKeyboardAction(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				toggleSearchBox();
			}
		}, "show search field", KeyStroke.getKeyStroke("ctrl F"), JComponent.WHEN_IN_FOCUSED_WINDOW);

		graphPanel.registerKeyboardAction(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				//                toolBar.undo();
			}
		}, "undo", KeyStroke.getKeyStroke("ctrl Z"), JComponent.WHEN_IN_FOCUSED_WINDOW);

		graphPanel.registerKeyboardAction(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				//                toolBar.redo();
			}
		}, "redo", KeyStroke.getKeyStroke("ctrl Y"), JComponent.WHEN_IN_FOCUSED_WINDOW);
	}

	private void resizeHandler() {
		controller.fitViews();
	}

	private void toggleSearchBox() {
		searchField.setEnabled(!searchField.isEnabled());
		if (searchField.isEnabled()) {
			searchField.setText(null);
			searchField.requestFocusInWindow();
		} else {
			searchField.setText("Ctrl+F to search");
		}
	}

	public class SearchFieldListener implements ActionListener, DocumentListener, KeyListener {

		@Override
		public void removeUpdate(DocumentEvent e) {
			if (e.getDocument().getLength() == 0) {
				controller.searchFor(PNConstantsL.EMPTY_LABEL);
			}
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			controller.searchFor(((JTextField) e.getSource()).getText());
		}

		@Override
		public void keyReleased(KeyEvent e) {
			if (e.getKeyCode() == KeyEvent.VK_ESCAPE) {
				toggleSearchBox();
			}
		}

		@Override
		public void changedUpdate(DocumentEvent e) {
			// no-op

		}

		@Override
		public void insertUpdate(DocumentEvent e) {
			// no-op
		}

		@Override
		public void keyPressed(KeyEvent e) {
			// no-op
		}

		@Override
		public void keyTyped(KeyEvent e) {
			// no-op
		}
	}

	public void layoutGraph() {
		controller.executeLayout(true);
	}

	//DQ data quality starts
	private void revalitdatePanels() {
		panel.repaint();
		panel.revalidate();
		panel_3.repaint();
		panel_3.revalidate();
	}

	//DQ data quality ends
}
