package org.processmining.humbertogarciacaballero.models.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTable;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.ToolTipManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import org.processmining.help.CustomToolTipUtilsL;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.humbertogarciacaballero.models.gui.components.ColorLeyendComponentL;
import org.processmining.humbertogarciacaballero.models.gui.images.ImageHelper;
import org.processmining.incrementaldiscovery.DiscoveryPredictorL;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.prabhakardixit.fcnets.expansion.ReduceUndoL;
import org.processmining.prabhakardixit.fcnets.models.ControllerViewModeL;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMapL;

import prefuse.util.ColorLib;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * @author 310187521
 *
 */
public class ToolBarGUIL extends JToolBar {

	/**
     * 
     */
	private static final long serialVersionUID = 1L;

	private PNetVisualizerControllerL controller;

	//	private LayoutParametersGUI gui;
	private LegendGUIL legendGUI;

	private ImageIcon loaderImage = null;
	private JLabel loaderLabel = null;

	private ImageIcon fitScreenImage = null;
	private ToolButton fitScreenButton = null;

	private ImageIcon rotateAntiClockwiseImage = null;
	private ToolButton rotateAntiClockwiseButton = null;

	private ImageIcon rotateClockwiseImage = null;
	private ToolButton rotateClockwiseButton = null;

	private ImageIcon executeLayoutImage = null;
	private ToolButton executeLayoutButton = null;

	private ImageIcon redoImage = null;
	private ToolButton redoButton = null;

	private ImageIcon undoImage = null;
	private ToolButton undoButton = null;

	private ImageIcon highlightPathImage = null;
	private ToggleToolButton highlightPathButton = null;

	private ImageIcon toggleSimplificationImage = null;
	private ToggleToolButton toggleSimplificationButton = null;

	private ImageIcon toggleSimplificationEdgeImage = null;
	private ToggleToolButton toggleSimplificationEdgeButton = null;

	private ImageIcon toggleLoopHighLightImage = null;
	private ToggleToolButton toggleLoopHighLightButton = null;

	private ImageIcon optionToCompleteImage = null;
	private ToggleToolButton optionToCompleteButton = null;

	private ImageIcon properCompletionImage = null;
	private ToggleToolButton properCompletionButton = null;

	private ImageIcon noDeadTasksImage = null;
	private ToggleToolButton noDeadTasksButton = null;

	private ImageIcon spanGraphImage = null;
	private ToggleToolButton spanGraphButton = null;

	private ImageIcon addImage = null;
	private ToggleToolButton addButton = null;

	private ImageIcon removeImage = null;
	private ToggleToolButton removeButton = null;

	//    private JLabel pathLabel = null;
	//    private JSpinner pathSpinner = null;
	//    private JRadioButton pathIncoming = null;
	//    private JRadioButton pathOutgoing = null;
	//    private JRadioButton pathBoth = null;

	private ImageIcon optionsImage = null;
	private ToolButton optionsButton = null;

	private ImageIcon legendImage = null;
	private ToolButton legendButton = null;

	private ToggleToolButton shortEdgesSimplify = null;

	private ToggleToolButton longEdgesSimplify = null;

	private JCheckBox reorderNodes = null;

	private ImageIcon highlightPathImagePMD = null; //PMD
	private ToggleToolButton highlightPathButtonPMD = null; //PMD

	private ImageIcon alignmentImg = null; //PMD
	private ToggleToolButton alignmentBtn = null; //PMD

	private ImageIcon viewOnlyImg = null; //PMD
	private ToggleToolButton viewOnlyBtn = null; //PMD

	private JRadioButton dirFollows = SlickerFactory.instance().createRadioButton("Directly Follows-Precedes");
	private JRadioButton eveFollows = SlickerFactory.instance().createRadioButton("Eventually Follows-Precedes");
	//	setToolTipText(CustomToolTipUtils.getToolTipText("followsprecedes"));

	private final ColorLeyendComponentL colorLeyend = new ColorLeyendComponentL("Directly Precedes-Follows", "Precedes",
			"Follows", ColorBrewerL.getSequentialColorPalettes(false)[4].getColorPalette(10));
	private final ColorLeyendComponentL colorLeyend4 = new ColorLeyendComponentL("Eventually Precedes-Follows",
			"Precedes", "Follows", ColorBrewerL.getSequentialColorPalettes(false)[4].getColorPalette(10));
	private final ColorLeyendComponentL colorLeyend2 = new ColorLeyendComponentL("Frequency", "0%", "100%",
			ColorBrewerL.getSequentialColorPalettes(false)[8].getColorPalette(10));
	private final ColorLeyendComponentL colorLeyend3 = new ColorLeyendComponentL("Performance", "0%", "100%",
			ColorBrewerL.getSequentialColorPalettes(false)[6].getColorPalette(10));

	public ToolBarGUIL(final JFrame application, Component mainGraphPanel, final PNetVisualizerControllerL controller) {
		super();
		//		controller = PNetVisualizerController.getInstance();
		this.controller = controller;
		//        controller.addObserver(this);
		//		gui = new LayoutParametersGUI(application);
		//        legendGUI = new LegendGUI(application, mainGraphPanel);
		setFloatable(false);

		undoImage = ImageHelper.loadImage("undo_icon.png");
		undoButton = new ToolButton(undoImage);
		//		undoButton.setEnabled(false);
		undoButton.setToolTipText("Undo");
		undoButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (controller.getIPN().getImnIndex() == 0)
					JOptionPane.showMessageDialog(null, "Undo not possible.");
				else
					ReduceUndoL.undo(controller);
			}
		});

		redoImage = ImageHelper.loadImage("redo_icon.png");
		redoButton = new ToolButton(redoImage);
		//		undoButton.setEnabled(false);
		redoButton.setToolTipText("Redo");
		redoButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (controller.getIPN().getImnIndex() == controller.getIPN().getImnList().size() - 1)
					JOptionPane.showMessageDialog(null, "Redo not possible.");
				else
					ReduceUndoL.redo(controller);
			}
		});

		//PMD starts
		highlightPathImagePMD = ImageHelper.loadImage("neighbors.png");
		highlightPathButtonPMD = new ToggleToolButton(highlightPathImagePMD);
		highlightPathButtonPMD.setToolTipText("Edit mode.");
		highlightPathButtonPMD.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AbstractButton abstractButton = (AbstractButton) e.getSource();
				boolean selected = abstractButton.getModel().isSelected();
				setEditView(selected, false);
			}
		});
		add(highlightPathButtonPMD);

		//alignment starts
		//		if (controller.getIPN().isAlignmentMode()) {
		alignmentImg = ImageHelper.loadImage("play.png");
		alignmentBtn = new ToggleToolButton(alignmentImg);
		alignmentBtn.setToolTipText("Investigate detailed alignments.");
		alignmentBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AbstractButton abstractButton = (AbstractButton) e.getSource();
				boolean selected = abstractButton.getModel().isSelected();
				setEditView(false, selected);
			}

		});
		//			add(alignmentBtn);
		//		}
		//alignment ends

		//view button starts
		viewOnlyImg = ImageHelper.loadImage("fit_screen.png");
		viewOnlyBtn = new ToggleToolButton(viewOnlyImg);
		viewOnlyBtn.setToolTipText("View only mode.");
		viewOnlyBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				setEditView(false, false);
			}

		});
		if (controller.getIPN().isPredictorMode())
			add(viewOnlyBtn);

		if (controller.getIPN().isAlignmentMode())
			add(alignmentBtn);
		//view button ends

		//PMD ends

		ButtonGroup radioGroup = new ButtonGroup();
		radioGroup.add(dirFollows);
		radioGroup.add(eveFollows);

		add(dirFollows);
		add(eveFollows);
		ActionListener listener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//				controller.setInformationMode((colorLeyend2.getRadioButton().isSelected() ? 1 : 2));
				if (dirFollows.isSelected())
					controller.getIPN().setViewMode(ControllerViewModeL.DIRECTLYFOLLOWS);
				else if (colorLeyend2.getRadioButton().isSelected())
					controller.getIPN().setViewMode(ControllerViewModeL.ALIGNMENT);
				else if (colorLeyend3.getRadioButton().isSelected())
					controller.getIPN().setViewMode(ControllerViewModeL.PERFORMANCE);
				else if (eveFollows.isSelected())
					controller.getIPN().setViewMode(ControllerViewModeL.EVENTUALLYFOLLOWS);
			}
		};
		dirFollows.addActionListener(listener);
		eveFollows.addActionListener(listener);
		dirFollows.setSelected(true);
		//		ButtonGroup radiogroup = new ButtonGroup();
		//		radiogroup.add(colorLeyend.getRadioButton());
		//		radiogroup.add(colorLeyend2.getRadioButton());
		//		radiogroup.add(colorLeyend3.getRadioButton());
		//		radiogroup.add(colorLeyend4.getRadioButton());
		//		ActionListener listener = new ActionListener() {
		//			public void actionPerformed(ActionEvent e) {
		//				//				controller.setInformationMode((colorLeyend2.getRadioButton().isSelected() ? 1 : 2));
		//				if (colorLeyend.getRadioButton().isSelected())
		//					controller.getIPN().setViewMode(ControllerViewMode.DIRECTLYFOLLOWS);
		//				else if (colorLeyend2.getRadioButton().isSelected())
		//					controller.getIPN().setViewMode(ControllerViewMode.ALIGNMENT);
		//				else if (colorLeyend3.getRadioButton().isSelected())
		//					controller.getIPN().setViewMode(ControllerViewMode.PERFORMANCE);
		//				else if (colorLeyend4.getRadioButton().isSelected())
		//					controller.getIPN().setViewMode(ControllerViewMode.EVENTUALLYFOLLOWS);
		//			}
		//		};

		//		colorLeyend.getRadioButton().addActionListener(listener);
		//		colorLeyend.getRadioButton().setSelected(true);
		colorLeyend2.getRadioButton().addActionListener(listener);
		colorLeyend3.getRadioButton().addActionListener(listener);
		colorLeyend4.getRadioButton().addActionListener(listener);
		colorLeyend.getRadioButton().addActionListener(listener);

		addSeparator();

		//		add(colorLeyend);
		//		add(colorLeyend2);
		//		add(colorLeyend3);
		//		add(colorLeyend4);

		//initially set the colorleylends invisible - until an action is performed by the user
		//		colorLeyend.setVisible(false);
		//		colorLeyend2.setVisible(false);
		//		colorLeyend3.setVisible(false);
		//		colorLeyend4.setVisible(false);
		dirFollows.setVisible(false);
		eveFollows.setVisible(false);

		add(undoButton);

		JButton saveBtn = SlickerFactory.instance().createButton("Save Petrinet");
		//		saveBtn.setToolTipText("Saves current Petri net to workspace.");
		ToolTipManager.sharedInstance().setDismissDelay(Integer.MAX_VALUE);
		saveBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				AbstractButton abstractButton = (AbstractButton) e.getSource();
				PetriNetMapL pnmap = new PetriNetMapL(controller.getIPN().getselectedPetriNetMap());
				controller
						.getIPN()
						.getContext()
						.getProvidedObjectManager()
						.createProvidedObject("Extracted Petrinet", pnmap.getPetriNet(), Petrinet.class,
								controller.getIPN().getContext());
				controller.getIPN().getUIContext().getGlobalContext().getResourceManager()
						.getResourceForInstance(pnmap.getPetriNet()).setFavorite(true);
			}
		});
		add(saveBtn);
		add(redoButton);
		add(controller.getFitPre());
	}

	@SuppressWarnings("serial")
	public class ToolButton extends JButton {

		public ToolButton(Icon icon) {
			super(icon);
		}

		public boolean isFocusTraversable() {
			return false;
		}

		public void requestFocus() {
		}
	}

	@SuppressWarnings("serial")
	private class ToggleToolButton extends JToggleButton {

		public ToggleToolButton(Icon icon) {
			super(icon);
		}

		public boolean isFocusTraversable() {
			return false;
		}

		public void requestFocus() {
		}
	}

	/**
	 * function to switch between alignment view and edit view p1 = edit,
	 * p2=align
	 */
	private void setEditView(boolean editSelected, boolean alignSelected) {
		controller.setHighlightNeighborsEnabled(editSelected);
		if (editSelected) {
			colorLeyend.setToolTipText(CustomToolTipUtilsL.getToolTipText("followsprecedes"));
			alignmentBtn.setSelected(false);
			controller.getStatisticsPanel().removeAll();
			controller.getStatisticsPanel().revalidate();
			controller.getStatisticsPanel().repaint();
			dirFollows.setVisible(true);
			eveFollows.setVisible(true);
			colorLeyend.getRadioButton().setSelected(true);
			controller.getIPN().setViewMode(ControllerViewModeL.DIRECTLYFOLLOWS);
			controller.setAlignmentMode(false);
			controller.getStatisticsPanel().setSize(1024, 768);
			JPanel panel = createHelpPanel();
			controller.getStatisticsPanel().add(panel);
			controller.getStatisticsPanel().revalidate();
			controller.getStatisticsPanel().repaint();

		} else if (alignSelected) {
			highlightPathButtonPMD.setSelected(false);
			//			SplitPanelIntoPetrinetAndLog.splitPanel(controller);

			controller.getIPN().setViewMode(ControllerViewModeL.ALIGNMENT);
			controller.setAlignmentMode(true);
			dirFollows.setVisible(false);
			eveFollows.setVisible(false);

		}

		else if (!editSelected && !alignSelected) {

			dirFollows.setVisible(false);
			eveFollows.setVisible(false);

			controller.getIPN().setViewMode(ControllerViewModeL.VIEWONLY);
			controller.setAlignmentMode(false);
			if (controller.getIPN().isPredictorMode() && viewOnlyBtn.isSelected()) {
				JPanel panel = controller.getStatisticsPanel();
				//				DiscoveryPredictor.discover(controller);
				DiscoveryPredictorL dp = new DiscoveryPredictorL();
				dp.discover(controller);
				//				org.processmining.incrementaldiscovery.DiscoveryPredictor.discover(controller);

			}
		}

	}

	private void updateUndoRedo() {
		int currId = controller.getIPN().getImnIndex();
		if (currId == 0)
			undoButton.enable();
		else
			undoButton.disable();

		if (currId == controller.getIPN().getImnList().size())
			redoButton.enable();
		else
			redoButton.disable();
	}

	private JPanel createHelpPanel() {
		JPanel panel = new JPanel();
		panel.setSize(1024, 768);
		String[] headers = { "Name11", "" };
		DefaultTableModel dtm = new DefaultTableModel(headers, 11);

		// Populate all cells in the default table model.

		//		String[] names = { "Node", "Node", "Jack Jones", "Paul Finch", "Susan Smyth" };

		String[] balances = {
				"",
				"Input only ",
				"(Single) Output only ",
				"(Possibly) Both Input and Output ",
				"Multiple Output Nodes",
				"",
				"",
				"",
				"Selected activity (from dropdown) happens after the activity represented by the node - according to the event log",
				"Selected activity (from dropdown) happens before the activity represented by the node - according to the event log",
				"Indicates the selected activity and the activity represented by node never co-occurs together" };

		int nrows = dtm.getRowCount();
		int ncols = dtm.getColumnCount();

		for (int i = 0; i < nrows; i++) {
			if (i == 0)
				dtm.setValueAt("Edit Operations:", i, 0);
			else if (i == 6)
				dtm.setValueAt("Event Log Projections:", i, 0);
			else
				dtm.setValueAt("", i, 0);
			dtm.setValueAt(balances[i], i, 1);
			//			dtm.setValueAt(new Double(balances[i]), i, 1);
		}

		// Create a table using the previously created default table
		// model.

		JTable jt = new JTable(dtm);
		jt.setSize(1024, 768);
		// Create a renderer for displaying cells in certain colors.

		TableRenderer tr = new TableRenderer();

		// Get the column model so we can extract individual columns.

		TableColumnModel tcm = jt.getColumnModel();
		tcm.getColumn(0).setPreferredWidth(130);
		tcm.getColumn(1).setPreferredWidth(670);
		// For each table column, sets its renderer to the previously 
		// created table renderer.

		for (int c = 0; c < ncols; c++) {
			TableColumn tc = tcm.getColumn(c);
			tc.setCellRenderer(tr);
		}

		controller.getStatisticsPanel().add(jt);
		panel.add(jt);
		return panel;
	}

	class TableRenderer extends DefaultTableCellRenderer {
		private int row, col;

		public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
				boolean hasFocus, int row, int column) {
			// Save row and column information for use in setValue().

			this.row = row;
			this.col = column;

			// Allow superclass to return rendering component.

			return super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
		}

		protected void setValue(Object v) {
			// Allow superclass to set the value.
			super.setValue(v);
			if (col == 1) {
				setForeground(Color.black);
				setBackground(Color.white);
				return;
			}

			if (row == 0) {
				setBackground(Color.white);
				return;
			}

			// If in names column, color cell with even row number white on
			// dark green, and cell with odd row number black on white.
			if (row == 1) {
				setBackground(new Color(242, 124, 124));
				return;
			}

			if (row == 2) {
				setBackground(new Color(0, 230, 118));
				return;
			}
			setForeground(Color.white);
			if (row == 3) {
				setBackground(new Color(ColorLib.gray(100)));
				return;
			}
			setForeground(Color.black);
			if (row == 4) {
				setBackground(new Color(144, 195, 212));
				return;
			}

			setForeground(Color.black);
			setBackground(Color.white);

			if (row == 8) {
				setBackground(new Color(1f, 0f, 1f, 1));
			}

			if (row == 9) {
				setBackground(new Color(1f, 1f, 0f, 1));
			}

			if (v == null)
				return;

		}
	}
}
