package org.processmining.humbertogarciacaballero.models.gui.action;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.model.PNConstantsL;

import prefuse.data.Tuple;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.AggregateItem;
import prefuse.visual.AggregateTable;
import prefuse.visual.VisualItem;

public class AggregateNodesSimplifierL extends AggregateNodesBySimplifiedLayerL {

    public AggregateNodesSimplifierL(String group, AggregateTable aggregateTable) {
        super(group, aggregateTable);
    }
    
    @SuppressWarnings("unchecked")
    @Override
    public void run(double frac) {
//        aggregateTable.clear();
        TupleSet ts = getVisualization().getGroup(getGroup());
        int maxLayer = getMaxLayer(ts);
        
        for (int i = 0; i < maxLayer; i++) {
            Iterator<Tuple> iter = ts.tuples(ExpressionParser.predicate("[" + PNConstantsL.NODE_LAYER_KEY + "] = " + i));
            if (iter.hasNext()) {
//                AggregateItem aggregateItem = (AggregateItem)aggregateTable.addItem();
                AggregateItem aggregateItem = getAggregate(i);
                aggregateItem.removeAllItems();
                while (iter.hasNext()) {
                    aggregateItem.addItem((VisualItem)iter.next());
                }
                
                iter = ts.tuples(ExpressionParser.predicate("[" + PNConstantsL.NODE_LAYER_KEY + "] = " + (i + 1)));
                if (iter.hasNext()) {
                    while (iter.hasNext()) {
                        aggregateItem.addItem((VisualItem)iter.next());
                    }
                }
                
                aggregateItem.setInt(PNConstantsL.NODE_LAYER_KEY, i);
                aggregateItem.setInt(PNConstantsL.NODE_MAX_LAYER_KEY, maxLayer);
            }
        }
    }
}
