package org.processmining.humbertogarciacaballero.models.gui.action;

import static org.processmining.humbertogarciacaballero.models.model.PNConstantsL.FILLING_EXTRA_COLOR_KEY;
import static org.processmining.humbertogarciacaballero.models.model.PNConstantsL.INCOMING_HIGHLIGHTED_NODE_COLOR;
import static org.processmining.humbertogarciacaballero.models.model.PNConstantsL.NODE_DEPTH_KEY;
import static org.processmining.humbertogarciacaballero.models.model.PNConstantsL.OUTGOING_HIGHLIGHTED_NODE_COLOR;

import prefuse.action.assignment.ColorAction;
import prefuse.data.expression.Predicate;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;

public class DepthColorActionL extends ColorAction {

    public DepthColorActionL(String group, Predicate filter, String field, int color) {
        super(group, filter, field, color);
    }

    @Override
    public int getColor(VisualItem item) {
        int color = super.getColor(item);
        int depth = item.getInt(NODE_DEPTH_KEY);
        
        // Special case
        if (ColorLib.alpha(color) == 0) {
            int c1 = INCOMING_HIGHLIGHTED_NODE_COLOR;
            int c2 = OUTGOING_HIGHLIGHTED_NODE_COLOR;
            for (int i = 1; i < depth; i++) {
                c1 = ColorLib.rgba(Math.max(0, (int) (0.9 * ColorLib.red(c1))),
                        Math.max(0, (int) (0.9 * ColorLib.green(c1))),
                        Math.max(0, (int) (0.9 * ColorLib.blue(c1))), ColorLib.alpha(c1));
                c2 = ColorLib.rgba(Math.max(0, (int) (0.9 * ColorLib.red(c2))),
                        Math.max(0, (int) (0.9 * ColorLib.green(c2))),
                        Math.max(0, (int) (0.9 * ColorLib.blue(c2))), ColorLib.alpha(c2));
            }
            item.set(FILLING_EXTRA_COLOR_KEY, c2);
            color = c1;
        } else {
            for (int i = 1; i < depth; i++) {
                color = ColorLib.rgba(Math.max(0, (int) (0.9 * ColorLib.red(color))),
                        Math.max(0, (int) (0.9 * ColorLib.green(color))),
                        Math.max(0, (int) (0.9 * ColorLib.blue(color))), ColorLib.alpha(color));
            }
            item.set(FILLING_EXTRA_COLOR_KEY, 0);
        }

        return color;
    }
}
