package org.processmining.humbertogarciacaballero.models.gui.action;

import java.util.logging.Logger;

import org.processmining.humbertogarciacaballero.models.model.PNConstantsL;

import prefuse.action.assignment.ColorAction;
import prefuse.data.expression.Predicate;
import prefuse.util.ColorLib;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

public class PNColorActionL extends ColorAction {

    private boolean loopModeEnabled;
    private String[] fields;
    private int[] palette;

    public PNColorActionL(String group, String field, int color) {
        this(group, new String[] { field }, color);
    }

    public PNColorActionL(String group, String[] fields, int color) {
        super(group, fields[0], color);
        this.fields = fields;
        palette = ColorLib.getCategoryPalette(12);
        loopModeEnabled = false;
    }

    public void process(VisualItem item, double frac) {
        for (String field : fields) {
            setField(field);
            super.process(item, frac);
        }
    }

    public int getColor(VisualItem item) {
        if (loopModeEnabled && item instanceof EdgeItem && item.getInt(PNConstantsL.LOOP_KEY) > -1) {
            return palette[item.getInt(PNConstantsL.LOOP_KEY) % palette.length];
        }

        Object o = lookup(item);
        if (o != null) {
            if (o instanceof ColorAction) {
                return ((ColorAction) o).getColor(item);
            } else if (o instanceof Integer) {
                return ((Integer) o).intValue();
            } else if (o instanceof String) {
                return item.getInt((String) o);
            } else {
                Logger.getLogger(this.getClass().getName()).warning("Unrecognized Object from predicate chain.");
            }
        }
        return m_defaultColor;
    }

    public void setLoopModeEnabled(boolean enabled) {
        loopModeEnabled = enabled;
    }

    public boolean isLoopModeEnabled() {
        return loopModeEnabled;
    }

    public void add(Predicate p, String field) {
        super.add(p, field);
    }
   
}
