package org.processmining.humbertogarciacaballero.models.gui.action;

import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.processmining.humbertogarciacaballero.models.model.PNConstantsL;

import prefuse.action.layout.Layout;
import prefuse.data.Graph;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;

public class RotateActionL extends Layout {

	private boolean clockwise;
	
	public RotateActionL(String group) {
		super(group);
	}
	
	@SuppressWarnings("unchecked")
    @Override
	public void run(double frac) {
		Graph graph = (Graph) getVisualization().getGroup(getGroup());
		AffineTransform transform;
		
		if (clockwise) {
			transform = AffineTransform.getQuadrantRotateInstance(1);
		} else {
			transform = AffineTransform.getQuadrantRotateInstance(3);
		}
		
		Iterator<NodeItem> iter = graph.nodes();
		while (iter.hasNext()) {
			NodeItem node = iter.next();
			Point2D p = new Point2D.Double(node.getX(), node.getY());
			Point2D result = transform.transform(p, null);
			
			setX(node, null, result.getX());
			setY(node, null, result.getY());
		}
		
		Iterator<EdgeItem> iter2 = graph.edges();
		while (iter2.hasNext()) {
			EdgeItem edge = iter2.next();
			LinkedList<Point2D> bends = new LinkedList<>((List<Point2D>) edge.get(PNConstantsL.EDGE_BENDS_KEY));
			
			for (Point2D p : bends) {
				transform.transform(p, p);
			}
		}
	}

	public void setClockwise(boolean clockwise) {
		this.clockwise = clockwise;
	}
}
