package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.model.PNConstantsL;

import prefuse.controls.NeighborHighlightControl;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;

public class NodeHighlightControlL extends NeighborHighlightControl {

	private TupleSet incomingNeighbors;
	
	private TupleSet outgoingNeighbors;
	
	public NodeHighlightControlL(TupleSet incomingNeighbors, TupleSet outgoingNeighbors, String activity) {
		super(activity);
		this.incomingNeighbors = incomingNeighbors;
		this.outgoingNeighbors = outgoingNeighbors;
	}

	/**
	 * Set the highlighted state of the neighbors of a node.
	 * 
	 * @param n
	 *            the node under consideration
	 * @param state
	 *            the highlighting state to apply to neighbors
	 */
	@SuppressWarnings("unchecked")
    protected void setNeighborHighlight(NodeItem n, boolean state) {
		Iterator<EdgeItem> iter = n.edges();
		n.setHighlighted(state);
		while (iter.hasNext()) {
			EdgeItem eitem = (EdgeItem) iter.next();
			NodeItem nitem = eitem.getAdjacentItem(n);
			if (eitem.isVisible() || isHighlightWithInvisibleEdge()) {
				eitem.setHighlighted(state);
				nitem.setHighlighted(state);
				
				if (state) {
					if (eitem.getSourceItem().equals(nitem)) {
						incomingNeighbors.addTuple(nitem);
					} else {
						outgoingNeighbors.addTuple(nitem);
					}
				} else {
					if (eitem.getSourceItem().equals(nitem)) {
						incomingNeighbors.removeTuple(nitem);
					} else {
						outgoingNeighbors.removeTuple(nitem);
					}
				}
			}
		}
		
		n.setHighlighted(state);
		
//		if (getActivity() != null) {
//		    n.getVisualization().cancel(getActivity());
		    n.getVisualization().run(PNConstantsL.VIS_FILL_NODES_ACTIONS_NAME);
//			n.getVisualization().run(getActivity());
//		}
	}
}
