package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.AWTException;
import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.humbertogarciacaballero.models.model.PNConstantsL;
import org.processmining.prabhakardixit.fcnets.synthesis.VizGraphParametersUtilsL;
import org.processmining.reduction.ReductionTrackerL;

import prefuse.Display;
import prefuse.Visualization;
import prefuse.controls.Control;
import prefuse.controls.NeighborHighlightControl;
import prefuse.data.Graph;
import prefuse.data.Node;
import prefuse.data.Tuple;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ui.UILib;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class NodeHighlightControlPMDL extends NeighborHighlightControl {

	private TupleSet inputSet;
	private TupleSet inputOutputSet; //both input and output
	private TupleSet outputSet;
	TupleSet selectedEdgeSet;
	private TupleSet conformanceActivities; //transitions from net to do conformance upon

	private TupleSet outputMultipleSet;
	protected int button = Control.LEFT_MOUSE_BUTTON;
	protected int ctrl = KeyEvent.VK_CONTROL;
	boolean ctrlPressed = false;
	boolean clicked = false;
	protected int enter = KeyEvent.VK_ENTER;
	protected int esc = KeyEvent.VK_ESCAPE;
	protected int prev = KeyEvent.KEY_FIRST;
	protected int next = KeyEvent.VK_TAB;
	protected int f2 = KeyEvent.VK_F2;
	protected int f12 = KeyEvent.VK_F12;
	protected int f11 = KeyEvent.VK_F11; //replay

	Tuple prevSelection;
	PNetVisualizerControllerL controller;
	private Set<Integer> selectedInput = new HashSet<Integer>();
	private Set<Integer> selectedOutput = new HashSet<Integer>();

	boolean rename = false;

	Set<VisualItem> selectedEdges = new HashSet<VisualItem>();

	//	private boolean predictorMode; //updated to true just before adding thru prediction, and reseted to false after adding prediction
	//	private int newTranId;
	//	private int newPlaceId;

	String TRANSITION = "TRANSITION";
	String PLACE = "PLACE";

	public NodeHighlightControlPMDL(TupleSet startSet, TupleSet endSet, String activity) {
		super(activity);
		// this.startSet = startSet;
		// this.endSet = endSet;

	}

	public NodeHighlightControlPMDL(String activity) {
		super(activity);
	}

	public NodeHighlightControlPMDL(TupleSet inputSet, TupleSet outputSet, TupleSet outputMultipleSet,
			TupleSet inputOutputSet, TupleSet selectedEdgeSet, TupleSet conformanceActivities, String activity,
			PNetVisualizerControllerL controller) {
		super(activity);
		this.inputSet = inputSet;
		this.outputSet = outputSet;
		this.outputMultipleSet = outputMultipleSet;
		//		this.isLoop = isLoop;
		this.controller = controller;
		this.inputOutputSet = inputOutputSet;
		this.selectedEdgeSet = selectedEdgeSet;
		this.conformanceActivities = conformanceActivities;
		NodeHighlightControlPMDUtilsL.layouter(controller.getVisualization());
	}

	/**
	 * Set the highlighted state of the neighbors of a node.
	 * 
	 * @param n
	 *            the node under consideration
	 * @param state
	 *            the highlighting state to apply to neighbors
	 */
	protected void setNeighborHighlight(NodeItem n, boolean state) {
		Visualization v = n.getVisualization();
		Iterator iter2 = n.getGraph().getNodes().tuples();
		if (isClicked())
			return;

		System.out.println(n.get("ID"));

		controller.setConformanceMode(false);
		//		if (controller.isConformanceMode())
		//			state = false;

		while (iter2.hasNext()) {
			NodeItem node = (NodeItem) iter2.next();
			inputSet.clear();
			outputSet.clear();
			outputMultipleSet.clear();
			inputOutputSet.clear();
			inputSet.removeTuple(node);
			outputSet.removeTuple(node);
			outputMultipleSet.removeTuple(node);
			inputOutputSet.removeTuple(node);
			if (!controller.isConformanceMode()) //clear conformance otherwise
				conformanceActivities.removeTuple(node);
			if (!state) {
				node.setHighlighted(state);
				selectedInput.removeAll(selectedInput);
				selectedOutput.removeAll(selectedOutput);
			}
		}
		Set<String> joinPlaces = new HashSet<String>();
		Map<String, Boolean> joinPlacesMultiple = new HashMap<String, Boolean>();
		Set<String> choiceSplitPlaces = new HashSet<String>();
		List<String> choicePlaces = new ArrayList<String>();
		getChoiceAndJoinPlaces(n, choiceSplitPlaces, joinPlacesMultiple, joinPlaces);

		//n.setHighlighted(state);
		iter2 = n.getGraph().getNodes().tuples();
		while (iter2.hasNext()) {
			NodeItem node = (NodeItem) iter2.next();
			if (n.get("type") != node.get("type"))
				continue;
			if (//n.get("type") != TRANSITION &&
			choiceSplitPlaces.contains(node.get("ID").toString())
					&& (joinPlaces.contains(node.get("ID").toString()) || joinPlacesMultiple.containsKey(node.get("ID")
							.toString()) && joinPlacesMultiple.get(node.get("ID").toString()))) {
				inputOutputSet.addTuple(node);
			}
			if (choiceSplitPlaces.contains(node.get("ID").toString())) {
				inputSet.addTuple(node);
				node.setHighlighted(state);
			} else if (joinPlaces.contains(node.get("ID").toString())) {
				if (joinPlacesMultiple.containsKey(node.get("ID").toString())
						&& joinPlacesMultiple.get(node.get("ID").toString()))
					outputMultipleSet.addTuple(node);
				else
					outputSet.addTuple(node);
				node.setHighlighted(state);
			}
		}

		//		if (getActivity() != null) {
		n.getVisualization().run(PNConstantsL.VIS_FILL_NODES_ACTIONS_NAME);
		n.getVisualization().run(PNConstantsL.VIS_SHAPE_ASSIGNMENT_ACTIONS_NAME);
		n.getVisualization().run(PNConstantsL.VIS_LAYOUT_ACTIONS_NAME);
		n.getVisualization().run("highlights");

		//		}
	}

	public void itemClicked(VisualItem item, MouseEvent e) {
		if (item instanceof EdgeItem) {
			EdgeItem ed = (EdgeItem) item;
			NodeItem nSource = ed.getSourceItem();
			if (nSource.get("type") == TRANSITION) {
				selectedEdges.add(item);
				selectedEdgeSet.addTuple(item);
				((EdgeItem) item).setHighlighted(true);
				item.getVisualization().run(PNConstantsL.VIS_FILL_NODES_ACTIONS_NAME);
				item.getVisualization().run("highlights");
				//			item.getVisualization().run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
				item.getVisualization().run(PNConstantsL.VIS_SHAPE_ASSIGNMENT_ACTIONS_NAME);
				item.getVisualization().run(PNConstantsL.VIS_LAYOUT_ACTIONS_NAME);
				return;
			} else {
				try {
					clearAllHighlights(nSource); //adding tran between place n tran not allowed
				} catch (AWTException e1) {
					e1.printStackTrace();
				}
			}

		} else if (item instanceof NodeItem) {
			if (controller.isConformanceMode()) {
				conformanceActivities.addTuple(item);
			} else {//do normal processing
				if (rename) {
					NodeHighlightControlPMDUtilsL.renameActivity(item, this, controller.getActivity(), true);

				} else {
					boolean conditionsSatisfied = false;
					if (UILib.isButtonPressed(e, button)) {
						{
							if (inputSet.containsTuple(item) && !selectedInput.contains(item.get("ID"))) {
								updateGroupsForInput((NodeItem) item);
							} else {
								if (outputMultipleSet.containsTuple(item) || inputOutputSet.containsTuple(item)) {
									//if multiple wait to add all - also remove others
									updateMultiChoiceForCurrInput((NodeItem) item);
									if (selectedOutput.size() == outputMultipleSet.getTupleCount()
											+ inputOutputSet.getTupleCount())
										conditionsSatisfied = true;
								} else if (outputSet.containsTuple(item)) {
									selectedOutput.add((int) item.get("ID"));
									//							if (selectedOutput.size() == inputOutputSet.getTupleCount())
									conditionsSatisfied = true;
								}
								if (!checkIfAllInputsSelected((NodeItem) item))
									conditionsSatisfied = false;
								if (conditionsSatisfied) {
									NodeHighlightControlPMDUtilsL.addLinearlyDependentNode(item, this, -1,
											controller.getActivity(), true, true, false);
									setNeighborHighlight((NodeItem) item, false);
								}
							}
							if (!conditionsSatisfied) {
								setNeighborHighlight((NodeItem) item, true);
								clicked = true;
							}
						}
					}
				}
			}
		}
		//		if (getActivity() != null) {
		item.getVisualization().run(PNConstantsL.VIS_FILL_NODES_ACTIONS_NAME);
		item.getVisualization().run("highlights");
		//			item.getVisualization().run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
		item.getVisualization().run(PNConstantsL.VIS_SHAPE_ASSIGNMENT_ACTIONS_NAME);
		item.getVisualization().run(PNConstantsL.VIS_LAYOUT_ACTIONS_NAME);
		//		}
	}

	public void itemKeyPressed(VisualItem item, java.awt.event.KeyEvent e) {
		if (e.getKeyCode() == esc) {
			Iterator<VisualItem> iter = selectedEdgeSet.tuples();
			while (iter.hasNext()) {
				((EdgeItem) iter.next()).setHighlighted(false);
			}
			selectedEdgeSet.clear();
			selectedEdges.removeAll(selectedEdges);
			if (prevSelection != null) {
				clicked = false;
				setNeighborHighlight((NodeItem) prevSelection, false);
				prevSelection = null;
			}
		}
		if (e.getKeyCode() == enter) {
			NodeHighlightControlPMDUtilsL.addTransAndPlace(this, -1, -1, controller.getActivity(), true, true, false);
			selectedEdgeSet.clear();
			selectedEdges.removeAll(selectedEdges);
		}

		//		if (e.getKeyCode() == prev) {
		//			controller.replaceGraph(PrevNextGraphs.getPrevGraph(controller.getIPN()));
		//			//			controller.getIPN().selectNextIndex();
		//			//			Graph g = InteractivePetrinetVisualizer.petrinetToGraph(controller.getIPN());
		//			//			controller.initController(g);
		//		}

		if (e.getKeyCode() == f2) {
			if (rename)
				rename = false;
			else
				rename = true;
		}

		if (e.getKeyCode() == KeyEvent.VK_SPACE) {
			//			AggregatedAlignmentInfo.getAlignmentInfo(controller.getIPN());
			//			ProjectedAveragedAlignments.alignmentCal(controller.getIPN());
			//			AlignmentsGraph.getAlignments(controller);
			//			printStats(controller.getIPN());
			//			System.out.println(" The map is : " + controller.getIPN().getAllTranId());
			//			SplitPanelIntoPetrinetAndLog.splitPanel(controller);
			//			controller.getStatisticsPanel().add(
			//					DiscoveryUsingIM.getArray(controller.getActivity(), controller.getIPN(), controller
			//							.getStatisticsPanel().getWidth(), controller.getStatisticsPanel().getHeight()));

			//			DiscoveryPredictor.discover(controller);
			//			VizGraphParametersUtils.getAllHighlights(controller.getIPN());
			//			CompareExhaustiveIncrementalApproach.compare(controller.getIPN().getContext(), controller.getIPN().getInteractiveMatNet());

		}

		//		if (e.getKeyCode() == f12)
		//			VisualizeTable.visualizeTable(controller);
		//		if (e.getKeyCode() == f11)
		//			try {
		//				ExportAsPDF.convertToPdf(controller.getStatisticsPanel(), 4, 5, "");
		//			} catch (FileNotFoundException | DocumentException e1) {
		//				// TODO Auto-generated catch block
		//				e1.printStackTrace();
		//			}
		//						ReplayLogOnPetriNet.replayLogOnNet(controller.getIPN().getContext(), controller.getIPN()
		//								.getselectedPetriNetMap().getPetriNet(), controller.getIPN().getLog());
		//			NaiveReplayer.naiveReplayer(controller.getIPN().getselectedPetriNetMap().getPetriNet(), controller.getIPN()
		//					.getLog());
		item.getVisualization().run(PNConstantsL.VIS_FILL_NODES_ACTIONS_NAME);
		item.getVisualization().run("highlights");
		item.getVisualization().run(PNConstantsL.VIS_SHAPE_ASSIGNMENT_ACTIONS_NAME);
		item.getVisualization().run(PNConstantsL.VIS_LAYOUT_ACTIONS_NAME);

	}

	private Set<Integer> getSelectedTransitions() {
		Set<Integer> sourceNodes = new HashSet<Integer>();
		Iterator iter = conformanceActivities.tuples();
		while (iter.hasNext())
			sourceNodes.add((Integer) ((Tuple) iter.next()).get("ID"));
		return sourceNodes;
	}

	public void keyPressed(java.awt.event.KeyEvent e) {
		if (e.getKeyCode() == esc) {
			if (selectedEdgeSet.getTupleCount() > 0) {
				Iterator<VisualItem> iter = selectedEdgeSet.tuples();
				while (iter.hasNext()) {
					iter.next().setHighlighted(false);
				}
				selectedEdgeSet.clear();
				selectedEdges.removeAll(selectedEdges);
			}
			if (prevSelection != null) {
				clicked = false;
				setNeighborHighlight((NodeItem) prevSelection, false);
				prevSelection = null;
			}
		}
		if (e.getKeyCode() == enter) {
			System.out.print("Selected IPN : " + controller.getIPN());
			NodeHighlightControlPMDUtilsL.addTransAndPlace(this, -1, -1, controller.getActivity(), true, true, false);
			selectedEdges.removeAll(selectedEdges);
			selectedEdgeSet.clear();
		}

		//		if (e.getKeyCode() == prev) {
		//			//			controller.getIPN().selectNextIndex();
		//			controller.replaceGraph(PrevNextGraphs.getPrevGraph(controller.getIPN()));
		//
		//			//			Graph g = InteractivePetrinetVisualizer.petrinetToGraph(controller.getIPN());
		//			//			controller.initController(g);
		//			//			controller.replaceGraph(g);
		//		}
		//
		//		if (e.getKeyCode() == KeyEvent.VK_SPACE)
		//			SelectFeatures.scoreFeatures(controller);
		//			StateEqBasedConformance.stateEqBasedConformance(controller.getIPN());
		//		if (e.getKeyCode() == KeyEvent.VK_SPACE)

		if (e.getKeyCode() == KeyEvent.VK_SPACE) {
			//						AggregatedAlignmentInfo.getAlignmentInfo(controller.getIPN());
			//			ProjectedAveragedAlignments.alignmentCal(controller.getIPN());
			//						AlignmentsGraph.getAlignments(controller);
			//			printStats(controller.getIPN());
			//			GetLongTermDependencies.getLongTermDependencies(controller.getIPN().getLog());

			//			controller.getStatisticsPanel().add(
			//					DiscoveryUsingIM.getArray(controller.getActivity(), controller.getIPN(), controller
			//							.getStatisticsPanel().getWidth(), controller.getStatisticsPanel().getHeight()));
			//			DiscoveryPredictor.discover(controller);

			VizGraphParametersUtilsL.getAllHighlights(controller.getIPN());
			//			CompareExhaustiveIncrementalApproach.compare(controller.getIPN().getContext(), controller.getIPN().getInteractiveMatNet());
		}
		if (e.getKeyCode() == f2) {
			if (rename)
				rename = false;
			else
				rename = true;
		}
		//		if (e.getKeyCode() == f12)
		//			VisualizeTable.visualizeTable(controller);
		//

		//		if (e.getKeyCode() == f11)
		//			try {
		//				ExportAsPDF.convertToPdf(controller.getStatisticsPanel(), 4, 5, "");
		//			} catch (FileNotFoundException | DocumentException e1) {
		//				// TODO Auto-generated catch block
		//				e1.printStackTrace();
		//			}
		//						ReplayLogOnPetriNet.replayLogOnNet(controller.getIPN().getContext(), controller.getIPN()
		//								.getselectedPetriNetMap().getPetriNet(), controller.getIPN().getLog());
		//					NaiveReplayer.naiveReplayer(controller.getIPN().getselectedPetriNetMap().getPetriNet(), controller.getIPN()
		//							.getLog());

		controller.getVisualization().run(PNConstantsL.VIS_FILL_NODES_ACTIONS_NAME);
		controller.getVisualization().run("highlights");
		controller.getVisualization().run(PNConstantsL.VIS_SHAPE_ASSIGNMENT_ACTIONS_NAME);
		controller.getVisualization().run(PNConstantsL.VIS_LAYOUT_ACTIONS_NAME);

	}

	private void updateGroupsForInput(NodeItem n) {
		Set<String> joinPlaces = new HashSet<String>();
		Map<String, Boolean> joinPlacesMultiple = new HashMap<String, Boolean>();
		Set<String> choiceSplitPlaces = new HashSet<String>();
		getChoiceAndJoinPlaces(n, choiceSplitPlaces, joinPlacesMultiple, joinPlaces);
		//n.setHighlighted(state);
		prevSelection = n;
		selectedInput.add((int) n.get("ID"));
		Iterator iter = outputSet.tuples();
		Set<Tuple> removeTuples = new HashSet<Tuple>();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			System.out.println("Index : " + controller.getIPN().getImnIndex());
			if (!joinPlaces.contains(node.get("ID").toString())) {
				removeTuples.add(node);
				node.setHighlighted(false);
			}
		}
		for (Tuple node : removeTuples)
			outputSet.removeTuple(node);
		removeTuples.removeAll(removeTuples);
		iter = outputMultipleSet.tuples();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			if (!joinPlaces.contains(node.get("ID").toString())) {
				removeTuples.add(node);
				node.setHighlighted(false);
			}
		}
		for (Tuple node : removeTuples)
			outputMultipleSet.removeTuple(node);
		removeTuples.removeAll(removeTuples);
		iter = inputSet.tuples();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			if (!choiceSplitPlaces.contains(node.get("ID").toString())) {
				removeTuples.add(node);
				node.setHighlighted(false);
			}
		}
		for (Tuple node : removeTuples)
			inputSet.removeTuple(node);

		changeInputOutputToInputTuple(n);
	}

	private void updateMultiChoiceForCurrInput(NodeItem nSelected) {
		Set<String> keep = new HashSet<String>();
		Set<Tuple> removeTuples = new HashSet<Tuple>();
		List<String> choicePlaces = new ArrayList<String>();
		Iterator iter = inputSet.tuples();
		selectedOutput.add((int) nSelected.get("ID"));
		while (iter.hasNext()) {
			NodeItem n = (NodeItem) iter.next();
			//			if (isLoop)
			//				choicePlaces = (List<String>) n.get("LoopPlaces");
			//			else
			choicePlaces = (List<String>) n.get("InputOutputNodes");
			for (String t : choicePlaces) {
				List<String> allSet = Arrays.asList(t.split(";"));

				boolean keepCurr = false;
				String start = allSet.get(0);
				String end = allSet.get(1);

				if (end.split(",").length > 1
						&& (Arrays.asList(end.split(",")).contains(nSelected.get("ID").toString()))) {
					boolean allInputPresent = true;
					for (String input : Arrays.asList(start.split(","))) {
						if (!input.contains(",") && !selectedInput.contains(Integer.parseInt(input)))
							allInputPresent = false;
					}
					if (allInputPresent)
						for (String e : Arrays.asList(end.split(","))) {
							keep.add(e);
						}
				}

			}

		}
		iter = outputMultipleSet.tuples();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			if (!keep.contains(node.get("ID").toString())) {
				removeTuples.add(node);
				node.setHighlighted(false);
			}
		}
		for (Tuple node : removeTuples)
			outputMultipleSet.removeTuple(node);

		iter = inputOutputSet.tuples();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			if (!keep.contains(node.get("ID").toString())) {
				removeTuples.add(node);
				//				node.setHighlighted(false);
			}
		}
		for (Tuple node : removeTuples) {
			if (!((NodeItem) node).equals(nSelected)) {
				inputOutputSet.removeTuple(node);
				inputSet.addTuple(node);
			}
		}

		iter = outputSet.tuples();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			node.setHighlighted(false);
		}
		outputSet.clear();

	}

	private void getChoiceAndJoinPlaces(NodeItem n, Set<String> choiceSplitPlaces,
			Map<String, Boolean> joinPlacesMultiple, Set<String> joinPlaces) {
		List<String> choicePlaces = new ArrayList<String>();
		//		if (isLoop)
		//			choicePlaces = (List<String>) n.get("LoopPlaces");
		//		else
		//		System.out.println((List<String>) n.get("InputOutputNodes"));
		choicePlaces = (List<String>) n.get("InputOutputNodes");
		for (String t : choicePlaces) {
			List<String> allSet = Arrays.asList(t.split(";"));

			String start = allSet.get(0);
			for (String e : Arrays.asList(start.split(","))) {
				choiceSplitPlaces.add(e);
			}
			String end = allSet.get(1);

			for (String e : Arrays.asList(end.split(","))) {
				joinPlaces.add(e);
				if (end.split(",").length > 1)
					joinPlacesMultiple.put(e, true);
				else
					joinPlacesMultiple.put(e, false);
			}
		}
	}

	private boolean checkIfAllInputsSelected(NodeItem node) {
		List<String> choicePlaces = new ArrayList<String>();
		NodeItem n = null;
		List<String> selectedInputStr = new ArrayList<String>();
		List<String> selectedOutputStr = new ArrayList<String>();
		Iterator iter = selectedOutput.iterator();
		while (iter.hasNext()) {
			selectedOutputStr.add(String.valueOf(iter.next()));
		}
		iter = selectedInput.iterator();
		while (iter.hasNext()) {
			selectedInputStr.add(String.valueOf(iter.next()));
		}
		iter = inputSet.tuples();
		while (iter.hasNext()) {
			NodeItem nTemp = (NodeItem) iter.next();
			if (selectedInput.contains(nTemp.get("ID")))
				n = nTemp;
		}
		choicePlaces = (List<String>) n.get("InputOutputNodes");
		System.out.println(choicePlaces);

		for (String t : choicePlaces) {
			boolean allInputsPresent = false;

			List<String> allSet = Arrays.asList(t.split(";"));

			String start = allSet.get(0);
			String end = allSet.get(1);
			System.out.println("in " + Arrays.asList(start.split(",")));
			System.out.println("out " + Arrays.asList(end.split(",")));

			String endTrans = "";
			String startTrans = "";
			for (String endStr : (Arrays.asList(end.split(",")))) {
				if (!endStr.contains(","))
					endTrans += controller.getIPN().getPlaceBasedOnID(Integer.parseInt(endStr)) + " ";
			}
			for (String startStr : (Arrays.asList(start.split(",")))) {
				if (!startStr.contains(","))
					startTrans += controller.getIPN().getPlaceBasedOnID(Integer.parseInt(startStr)) + " ";
			}
			System.out.println("Choice Places : " + startTrans + " ; " + endTrans);

			if (selectedInputStr.containsAll(Arrays.asList(start.split(","))))
				if (Arrays.asList(end.split(",")).containsAll(selectedOutputStr)) {
					//remove input and inputoutput highlights if not in selectedInputs
					iter = inputSet.tuples();
					while (iter.hasNext()) {
						NodeItem node1 = (NodeItem) iter.next();
						if (!(Arrays.asList(start.split(","))).contains(String.valueOf(node1.get("ID"))))
							node1.setHighlighted(false);
					}
					iter = inputOutputSet.tuples();
					while (iter.hasNext()) {
						NodeItem node1 = (NodeItem) iter.next();
						if (!Arrays.asList(start.split(",")).contains(String.valueOf(node1.get("ID")))
								&& !Arrays.asList(end.split(",")).contains(node1.get("ID")))
							node1.setHighlighted(false);
					}
					return true;
				}
		}

		//clear all highlights
		try {
			System.out.println("cleared!");
			clearAllHighlights(n);
		} catch (AWTException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}

	private void changeInputOutputToInputTuple(NodeItem n) {
		List<String> selectedInputStr = new ArrayList<String>();
		List<String> selectedOutputStr = new ArrayList<String>();
		//change from inputOutput to input only depending on selection
		List<String> choicePlaces = (List<String>) n.get("InputOutputNodes");
		Iterator iter = selectedOutput.iterator();
		while (iter.hasNext()) {
			selectedOutputStr.add(String.valueOf(iter.next()));
		}
		iter = selectedInput.iterator();
		while (iter.hasNext()) {
			selectedInputStr.add(String.valueOf(iter.next()));
		}
		iter = inputSet.tuples();
		while (iter.hasNext()) {
			NodeItem nTemp = (NodeItem) iter.next();
			if (selectedInput.contains(nTemp.get("ID")))
				n = nTemp;
		}
		System.out.println(choicePlaces);
		Set<String> removeTupleID = new HashSet<String>();
		for (String selectedInput : selectedInputStr) {
			boolean inOutPresent = false;
			for (String t : choicePlaces) {
				boolean allInputsPresent = false;
				List<String> allSet = Arrays.asList(t.split(";"));
				String start = allSet.get(0);
				String end = allSet.get(0);
				if (Arrays.asList(start.split(",")).containsAll(selectedInputStr))
					if (Arrays.asList(end.split(",")).contains(selectedInput))
						inOutPresent = true;
			}
			if (!inOutPresent)
				removeTupleID.add(selectedInput);
		}
		iter = inputOutputSet.tuples();
		while (iter.hasNext()) {
			NodeItem node = (NodeItem) iter.next();
			if (removeTupleID.contains(String.valueOf(node.get("ID")))) {
				inputOutputSet.removeTuple(node);
				node.setHighlighted(false);
			}

		}
	}

	// itemClicked
	public boolean isClicked() {
		return clicked;
	}

	public void setClicked(boolean clicked) {
		this.clicked = clicked;
	}

	public void mouseEntered(MouseEvent e) {
		((Display) e.getSource()).requestFocus();
	}

	//prev next code starts
	private void getPrevGraph() {
		Graph graph = controller.getData();
		ReductionTrackerL redTrack = controller.getIPN().getCurrentRedTracker();
		switch (redTrack.getMethodName()) {
			case ABSTRACTION :
				int placeToRemove = redTrack.getNewPlaceID();
				int tranToRemove = redTrack.getNewTranID();
				Iterator iter = graph.getNodes().tuples();
				Node n1 = null;
				Node n2 = null;
				Set<Node> inputNodes = new HashSet<Node>();
				Set<Node> outputNodes = new HashSet<Node>();

				while (iter.hasNext()) {
					Tuple tuple = (Tuple) iter.next();
					Node node = graph.getNode(tuple.getRow());
					if ((node.getInt("ID") == placeToRemove && node.get("type") == "PLACE")
							|| (node.getInt("ID") == tranToRemove && node.get("type") == "TRANSITION")) {
						if (n1 == null)
							n1 = node;
						else
							n2 = node;
					} else if (redTrack.getAtt1().contains(node.getInt("ID")) && node.get("type") == "TRANSITION")
						inputNodes.add(node);
					else if (redTrack.getAtt2().contains(node.getInt("ID")) && node.get("type") == "PLACE")
						outputNodes.add(node);
				}
				graph.removeNode(n1);
				graph.removeNode(n2);
				for (Node inputNode : inputNodes) {
					for (Node outputNode : outputNodes) {
						graph.addEdge(inputNode, outputNode);
					}

				}
				controller.getIPN().reduceInteractiveMatNet();
				break;
			case LDPLACE :
				break;
			case LDTRAN :
				break;
			default :
				break;

		}

	}

	//expose for robotic adding - predictor
	//	public TupleSet getInputSet() {
	//		return inputSet;
	//	}
	//
	//	public void setInputSet(TupleSet inputSet) {
	//		this.inputSet = inputSet;
	//	}
	//
	//	public TupleSet getInputOutputSet() {
	//		return inputOutputSet;
	//	}
	//
	//	public void setInputOutputSet(TupleSet inputOutputSet) {
	//		this.inputOutputSet = inputOutputSet;
	//	}
	//
	//	public TupleSet getOutputSet() {
	//		return outputSet;
	//	}
	//
	//	public void setOutputSet(TupleSet outputSet) {
	//		this.outputSet = outputSet;
	//	}
	//
	//	public TupleSet getOutputMultipleSet() {
	//		return outputMultipleSet;
	//	}
	//
	//	public void setOutputMultipleSet(TupleSet outputMultipleSet) {
	//		this.outputMultipleSet = outputMultipleSet;
	//	}

	public Set<VisualItem> getSelectedEdges() {
		return selectedEdges;
	}

	public void setSelectedEdges(Set<VisualItem> selectedEdges) {
		this.selectedEdges = selectedEdges;
	}

	//	public boolean isPredictorMode() {
	//		return predictorMode;
	//	}
	//
	//	public void setPredictorMode(boolean predictorMode) {
	//		this.predictorMode = predictorMode;
	//	}
	//
	//	public int getNewTranId() {
	//		return newTranId;
	//	}
	//
	//	public void setNewTramId(int newTranId) {
	//		this.newTranId = newTranId;
	//	}
	//
	//	public int getNewPlaceId() {
	//		return newPlaceId;
	//	}
	//
	//	public void setNewPlaceId(int newPlaceId) {
	//		this.newPlaceId = newPlaceId;
	//	}
	public Set<Integer> getSelectedInput() {
		return selectedInput;
	}

	public void setSelectedInput(Set<Integer> selectedInput) {
		this.selectedInput = selectedInput;
	}

	public Set<Integer> getSelectedOutput() {
		return selectedOutput;
	}

	public void setSelectedOutput(Set<Integer> selectedOutput) {
		this.selectedOutput = selectedOutput;
	}

	//expose for robotic adding - predictor

	private void clearAllHighlights(NodeItem n) throws AWTException {

		Robot robot = new Robot();
		robot.keyPress(esc);

	}

}
