package org.processmining.humbertogarciacaballero.models.model;

import java.util.LinkedList;
import java.util.List;

public class SoundnessInformationL {

    private Boolean optionToComplete;
    private Boolean properCompletion;
    private Boolean noDeadTasks;
    
    private List<String> nonLiveTransitions;
    private List<String> deadTransitions;
    private List<String> unboundedPlaces;
    
    private List<List<String>> nonLiveSequenceMarking;
    private List<String> nonLiveSequenceTransition;
    
    private List<List<String>> unboundedSequenceMarking;
    private List<String> unboundedSequenceTransition;
    
    public SoundnessInformationL() {
        optionToComplete = Boolean.FALSE;
        properCompletion = Boolean.FALSE;
        noDeadTasks = Boolean.FALSE;
        nonLiveTransitions = new LinkedList<>();
        deadTransitions = new LinkedList<>();
        unboundedPlaces = new LinkedList<>();
        nonLiveSequenceMarking = new LinkedList<>();
        nonLiveSequenceTransition = new LinkedList<>();
        unboundedSequenceMarking = new LinkedList<>();
        unboundedSequenceTransition = new LinkedList<>();
    }

    public Boolean isOptionToComplete() {
        return optionToComplete;
    }

    public void setOptionToComplete(Boolean optionToComplete) {
        this.optionToComplete = optionToComplete;
    }

    public Boolean isProperCompletion() {
        return properCompletion;
    }

    public void setProperCompletion(Boolean properCompletion) {
        this.properCompletion = properCompletion;
    }

    public Boolean isNoDeadTasks() {
        return noDeadTasks;
    }

    public void setNoDeadTasks(Boolean noDeadTasks) {
        this.noDeadTasks = noDeadTasks;
    }

    public void addNonLiveTransition(String key) {
        nonLiveTransitions.add(key);
    }
    
    public List<String> getNonLiveTransitions() {
        return nonLiveTransitions;
    }

    public void addDeadTransition(String key) {
        deadTransitions.add(key);
    }
    
    public List<String> getDeadTransitions() {
        return deadTransitions;
    }

    public void addUnboundedPlace(String key) {
        unboundedPlaces.add(key);
    }
    
    public List<String> getUnboundedPlaces() {
        return unboundedPlaces;
    }
 
    public void addNonLiveSequence(List<String> marking, String transition) {
        nonLiveSequenceMarking.add(marking);
        nonLiveSequenceTransition.add(transition);
    }
    
    public int getNonLiveSequenceSize() {
        return nonLiveSequenceMarking.size();
    }
    
    public List<String> getNonLiveSequenceMarking(int i) {
        return nonLiveSequenceMarking.get(i);
    }
    
    public String getNonLiveSequenceTransition(int i) {
        return nonLiveSequenceTransition.get(i);
    }
    
    public void addUnboundedSequence(List<String> marking, String transition) {
        unboundedSequenceMarking.add(marking);
        unboundedSequenceTransition.add(transition);
    }
    
    public int getUnboundedSequenceSize() {
        return unboundedSequenceMarking.size();
    }
    
    public List<String> getUnboundedSequenceMarking(int i) {
        return unboundedSequenceMarking.get(i);
    }
    
    public String getUnboundedSequenceTransition(int i) {
        return unboundedSequenceTransition.get(i);
    }
}
