package org.processmining.incrementaldiscovery;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeMap;

import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.ListModel;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetArrayFactory;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetImpl;
import org.processmining.acceptingpetrinet.plugins.VisualizeAcceptingPetriNetPlugin;
import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.incrementaldiscovery.models.IncrementalModelL;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.plugins.InductiveMiner.efficienttree.EfficientTreeReduce.ReductionFailedException;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.projectedrecallandprecision.result.ProjectedRecallPrecisionResult.ProjectedMeasuresFailedException;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class CopyOfDiscoveryPanelL extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7703464059203854169L;

	private JLabel fitness = new JLabel();
	private JLabel precision = new JLabel();
	List<IncrementalModelL> incM;
	int selectedModel;
	ButtonGroup radiogroup = new ButtonGroup();
	PNetVisualizerControllerL controller;
	JPanel panel = new JPanel();
	GridBagConstraints gbc = new GridBagConstraints();
	ProMList<ListModel> list;
	DefaultListModel model;

	public CopyOfDiscoveryPanelL(PNetVisualizerControllerL controller2) {
		//		super(ProMSplitPane.VERTICAL_SPLIT);
		super(new GridBagLayout());
		setLayout(new GridBagLayout());
		//		this.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		this.controller = controller2;
		final int w = controller.getStatisticsPanel().getWidth();
		final int h = controller.getStatisticsPanel().getHeight();

		gbc.gridx = 0;
		gbc.gridy = 0;
		add(SlickerFactory.instance().createButton("Policy Dropdown"), gbc); //policy dropdown

		gbc.gridx = 0;
		gbc.gridy = 1;
		fitness.setText("-");
		//		fitness.setPreferredSize(new Dimension(20,20));
		add(fitness, gbc);

		precision.setText("-");
		gbc.gridx = 0;
		gbc.gridy = 2;
		//		precision.setPreferredSize(new Dimension(20,20));
		add(precision, gbc);
		this.setPreferredSize(new Dimension(w, h));
		//		this.setMinimumSize(new Dimension(h, 23));
		this.setBackground(Color.LIGHT_GRAY);

		//add button
		JButton addBtn = SlickerFactory.instance().createButton("Use model");
		addBtn.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				//TODO add the selected model
				addSelectedModel();

			}
		});
		gbc.gridx = 1;
		gbc.gridy = 0;
		add(addBtn, gbc);

		JButton nextAct = SlickerFactory.instance().createButton(" Select next activity ");
		nextAct.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				//TODO selection of next activity  - based on policy
				setControllerActivity();
				//update using bottom comp
				updateBottomComp(w, h);
			}

		});
		gbc.gridx = 2;
		gbc.gridy = 0;
		add(nextAct, gbc);
		//top comp
		//		setTopComponent(panel);
		//		setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));

		gbc.gridx = 2;
		gbc.gridy = 1;
		//		add(new JButton("prevAct"), gbc);
		updateBottomComp(w, h);

		//		ProMList<String> list = new ProMList<String>("",(ListModel) list2);
		model = new DefaultListModel();
		list = new ProMList<ListModel>("", model);
		list.setPreferredSize(new Dimension(250, 80));
		List<String> actArrList = new ArrayList<String>(controller.getIPN().getLogInfo().getActivities());
		Collections.sort(actArrList);
		for (int i = 0; i < actArrList.size(); i++) {
			model.addElement(actArrList.get(i));
			if (controller.getActivity() == actArrList.get(i))
				list.setSelectedIndex(i);
		}

		
		gbc.gridx = 2;
		gbc.gridy = 1;
		gbc.gridheight = 2;
		add(list, gbc);

		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.gridheight = 2;
		add(panel, gbc);
		panel.setPreferredSize(new Dimension(850, 80));
		panel.setBackground(Color.LIGHT_GRAY);

	}

	private void updateBottomComp(int w, int h) {
		try {
			panel.removeAll();
			panel.add(getDiscoveryPanelForSelectedAct(w, h, controller.getIPN()));
		} catch (ProjectedMeasuresFailedException | ReductionFailedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void addSelectedModel() {
		// TODO Auto-generated method stub
		removeSelectedModelTemporary();
		ExpandUsingTrackerForVizAndNetL.expandUsingTracker(controller, incM.get(selectedModel), true);

	}

	private void addSelectedModelTemporary() {
		ExpandUsingTrackerForVizAndNetL.expandUsingTracker(controller, incM.get(selectedModel), false);
	}

	private void removeSelectedModelTemporary() {
		ReduceUsingTrackerForVizAndNetL.reduceUsingTracker(controller, incM.get(selectedModel), false,false);
	}

	private JComponent getDiscoveryPanelForSelectedAct(int w, int h, InteractivePetriNetL ipn)
			throws ProjectedMeasuresFailedException, ReductionFailedException {
		IncrementalDiscoveryGuidedDFAlgorithmL algo = new IncrementalDiscoveryGuidedDFAlgorithmL();
		final JTabbedPane tabbedPane = new JTabbedPane();

		JPanel panel = new JPanel();
		ButtonGroup group = new ButtonGroup();

		TreeMap<Float, IncrementalModelL> sortedMap = algo.generatePetriNetForSelectedActivity(ipn.getLog(),
				ipn.getUIContext(), ipn, 1, 1.5f,1,1,1, true);
		AcceptingPetriNetArray apnArr = AcceptingPetriNetArrayFactory.createAcceptingPetriNetArray();
		int count = 0;
		incM = new ArrayList<IncrementalModelL>();
		for (Float f : sortedMap.descendingMap().keySet()) {
			incM.add(sortedMap.get(f));
		}

		for (IncrementalModelL m : incM) {
			if (count < 5) {
				apnArr.addNet(new AcceptingPetriNetImpl(m.getNet()));
				count++;
			}
		}
		ButtonGroup radiogroup2 = new ButtonGroup();
		VisualizeAcceptingPetriNetPlugin visualizer = new VisualizeAcceptingPetriNetPlugin();
		tabbedPane.setPreferredSize(new Dimension(w, h));
		//		JPanel panel = new JPanel();

		final Set<JButton> buttons = new HashSet<JButton>();

		for (int index = 0; index < apnArr.getSize(); index++) {
			if (index == 0) {
				fitness.setText(" fitness1 : " + String.valueOf(incM.get(0).getFitness()));
				precision.setText(" precision : " + String.valueOf(incM.get(0).getPrecision()));
			}
			JButton button = SlickerFactory.instance().createButton(String.valueOf(index));
			button.setName(String.valueOf(index));
			group.add(button);
			buttons.add(button);
			button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JButton o = (JButton) e.getSource();
					String name = o.getName();
					removeSelectedModelTemporary();
					selectedModel = Integer.valueOf(name); //tabbedPane.getSelectedIndex();
					addSelectedModelTemporary();
					updateInfoPanel(Integer.valueOf(name));
					updateButtonEnabling(buttons);
				}
			});
			panel.add(button);
		}

		return panel;
	}

	private void updateInfoPanel(int selectedIndex) {

		fitness.setText(" fitness : " + String.valueOf(incM.get(selectedIndex).getFitness()));
		precision.setText(" precision : " + String.valueOf(incM.get(selectedIndex).getPrecision()));

	}

	private void updateButtonEnabling(Set<JButton> buttons) {
		for (JButton button : buttons)
			if (selectedModel == (Integer.valueOf(button.getName())))
				button.setEnabled(false);
			else
				button.setEnabled(true);
	}

	//sets the next controller activity : based on some policy
	private void setControllerActivity() {
		//alphabetical
		String currAct = controller.getActivity();
		List<String> activities = new ArrayList<String>(controller.getIPN().getLogInfo().getActivities());

		//remove trans which are already present
		for (Transition t : controller.getIPN().getselectedPetriNetMap().getPetriNet().getTransitions()) {
			if (!t.isInvisible()) {
				activities.remove(t.getLabel());
			}
		}

		Collections.sort(activities);

//		if (!activities.isEmpty())
//			controller.getActivityCombo().setSelectedItem(activities.get(0));

		//update list view with selected act
		for (int i = 0; i < model.getSize(); i++)
			if (model.getElementAt(i) == currAct) {
				list.setSelectedIndex(i);
			}

		
		// TODO make other policies

	}
}
