package org.processmining.incrementaldiscovery;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.InductiveMiner.efficienttree.EfficientTreeReduce.ReductionFailedException;
import org.processmining.projectedrecallandprecision.result.ProjectedRecallPrecisionResult.ProjectedMeasuresFailedException;

@Plugin(name = "Expt Petri net genera321tor", parameterLabels = { "Log " }, returnLabels = { "AllNets" }, returnTypes = { AcceptingPetriNetArray.class })
public class LogInputL {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public AcceptingPetriNetArray yourPrivatePlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException, ProjectedMeasuresFailedException, ReductionFailedException {
//		IncrementalDiscoveryBruteForceAlgorithm algo = new IncrementalDiscoveryBruteForceAlgorithm();
//		return algo.generatePetriNet(log, context);
		IncrementalDiscoveryGuidedDFAlgorithmL algo = new IncrementalDiscoveryGuidedDFAlgorithmL();
		return algo.generatePetriNet(log, context);
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 * @throws ProjectedMeasuresFailedException 
	 * @throws ReductionFailedException 
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati11on", requiredParameterLabels = { 0 })
	public AcceptingPetriNetArray yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException, ProjectedMeasuresFailedException, ReductionFailedException {

		return yourPrivatePlugin(context, log);

	}
}
