package org.processmining.prabhakardixit.alignments;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetImpl;
import org.processmining.framework.plugin.ProMCanceller;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.projectedrecallandprecision.framework.CompareParameters;
import org.processmining.projectedrecallandprecision.helperclasses.AutomatonFailedException;
import org.processmining.projectedrecallandprecision.plugins.CompareLog2PetriNetPlugin;
import org.processmining.projectedrecallandprecision.result.ProjectedRecallPrecisionResult;
import org.processmining.projectedrecallandprecision.result.ProjectedRecallPrecisionResult.ProjectedMeasuresFailedException;

public class ProjectedAndRegularAlignmentsL {

	public static float[] getProjectedFitnessAndPrecision(XLog log, Petrinet pn)
			throws ProjectedMeasuresFailedException {
		AcceptingPetriNet model = new AcceptingPetriNetImpl(pn);
		float[] fitPre = new float[2];
		CompareLog2PetriNetPlugin compare = new CompareLog2PetriNetPlugin();
		CompareParameters param = new CompareParameters();

		Set<String> act = new HashSet<String>();
		for (Transition t : model.getNet().getTransitions())
			if (!t.isInvisible()) {
				//				System.out.println("\n Transition : " + t);
				act.add(t.getLabel());

			}
		//		System.out.println("\n LOG: ");
		//		for (XTrace t : log)
		//			for (XEvent e : t)
		//				System.out.println(XConceptExtension.instance().extractName(e));
		param.setK(act.size() > 1 ? 2 : 1);
		ProjectedRecallPrecisionResult result = null;
		try {
			result = compare.measure(log, model, param, new ProMCanceller() {
				public boolean isCancelled() {
					return false;
				}
			});
		} catch (AutomatonFailedException | InterruptedException | ProjectedMeasuresFailedException e) {
			e.printStackTrace();
		}
		fitPre[0] = (float) result.getRecall();
		fitPre[1] = (float) result.getPrecision();

		return fitPre;
	}

	
}
