package org.processmining.prabhakardixit.alignments;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;

public class ProjectedAveragedAlignmentsL {

	public static void alignmentCal(InteractivePetriNetL ipn) {

		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		Set<String> allAct = new HashSet<String>();
		TransPairAlignmentL tranPairTemp = null;
		//create pairs of transitions
		int c = 0;
		Map<Integer, String> actCombMap = new HashMap<Integer, String>(); //map for get comb
		for (Transition t : pn.getTransitions()) {
			if (!t.isInvisible() && !allAct.contains(t.getLabel())) {
				allAct.add(t.getLabel());
				actCombMap.put(c++, t.getLabel());
			}
		}

		//get all combi
		Set<Set<Integer>> allComb = CombinationUtilsL.getAllCombs(actCombMap.keySet(), 2);

		Set<TransPairAlignmentL> tranPairs = new HashSet<TransPairAlignmentL>();
		//create tpa for each combination and add to tranPairs
		for (Set<Integer> comb : allComb) {
			TransPairAlignmentL tpa = new TransPairAlignmentL();
			for (Integer i : comb) {
				tpa.getActivities().add(actCombMap.get(i));
			}
			tranPairs.add(tpa);
		}

		//temp code keep only b and o
		//		Set<TransPairAlignment> tranPairs2 = new HashSet<TransPairAlignment>();
		//		for (TransPairAlignment tpa : tranPairs)
		//			if (tpa.containsActivity("b") && tpa.containsActivity("o"))
		//				tranPairs2.add(tpa);
		//		tranPairs.removeAll(tranPairs);
		//		tranPairs.addAll(tranPairs2);
		//temp code keep only b and or

		ipn.getTranPairs().clear();
		//		ipn.setTranPairs(tranPairs);

		UpdateProjectedAveragedAlignmentsL.totalLogTime = 0;
		UpdateProjectedAveragedAlignmentsL.totalReplayTime = 0;
		UpdateProjectedAveragedAlignmentsL.totalPrecTime = 0;
		System.out.println("Total combinations : " + tranPairs.size() + " for " + allAct.size() + " activities ");
		UpdateProjectedAveragedAlignmentsL.calculateAlignments(tranPairs, ipn, null);

		System.out.println("Total log time : " + UpdateProjectedAveragedAlignmentsL.totalLogTime);
		System.out.println("Total Replay time : " + UpdateProjectedAveragedAlignmentsL.totalReplayTime);
		System.out.println("Total Prec time : " + UpdateProjectedAveragedAlignmentsL.totalPrecTime);
	}

	public static XLog createMergedLog(XLog log, Set<String> activities, boolean keepEmptyTraces) {
		//		XLog log = (XLog) ipn.getLogInfo().actLog.get(act1).clone();
		//		XLog log2 = ipn.getLogInfo().actLog.get(act2);
		//		for (XTrace trace : log2)
		//			for (XEvent e : trace) {
		//				XEvent e2 = (XEvent) e.clone();
		//				log.get(log2.indexOf(trace)).add(e2);
		//			}
		//		return log;

		//		XLog log = (XLog) ipn.getLog().clone();
		//
		//		for (XTrace trace : log) {
		//			Set<XEvent> evtToRemove = new HashSet<XEvent>();
		//			for (XEvent e : trace) {
		//				evtToRemove.add(e);
		//			}
		//			trace.removeAll(evtToRemove);
		//		}
		//		XLog log = ipn.getLog();
		XFactory factory = XFactoryRegistry.instance().currentDefault();
		//Compute the labels of each cluster and create an empty sublog for each cluster
		Map<Integer, Set<String>> labelsMap = new HashMap<Integer, Set<String>>();
		//		for (Set<XEventClass> activities : clusters.getClusters()) {
		//			Set<String> labels = new HashSet<String>();
		//			for (XEventClass activity : activities) {
		//				labels.add(activity.getId());
		//			}
		XLog subLog = factory.createLog((XAttributeMap) log.getAttributes().clone());
		subLog.getClassifiers().addAll(log.getClassifiers());
		subLog.getExtensions().addAll(log.getExtensions());
		subLog.getGlobalTraceAttributes().addAll(log.getGlobalTraceAttributes());
		subLog.getGlobalEventAttributes().addAll(log.getGlobalEventAttributes());
		//			int idx = eventLogs.addLog(subLog);
		//			labelsMap.put(idx, labels);
		//		}

		//Walk thought each trace of the original log
		Map<Integer, XTrace> tracesMap = new HashMap<Integer, XTrace>();
		Iterator<XTrace> itTrace = log.iterator();
		int num = 0;
		for (XTrace trace : log) {
			XAttribute att = factory.createAttributeLiteral("OrgId", String.valueOf(log.indexOf(trace)), null);
			XTrace trace2 = factory.createTrace((XAttributeMap) trace.getAttributes().clone());
			if (!trace2.getAttributes().containsKey("OrgId"))
				trace2.getAttributes().put("OrgId", att);
			//Walk thought each event of the original trace
			//			System.out.println(act1);
			//			System.out.println(act2);

			//			Iterator<XEvent> itEvent = trace.iterator();
			for (XEvent event : trace) {

				//				XEvent event = itEvent.next();
				//				System.out.println(event);
				if (activities.contains(XConceptExtension.instance().extractName(event).toString())) {
					XAttribute att2 = factory.createAttributeLiteral("orgEvtId", String.valueOf(event.getID()),
							null);
					XEvent event2 = (XEvent) event.clone();
					if (!event2.getAttributes().containsKey("orgEvtId"))
						event2.getAttributes().put("orgEvtId", att2);
					trace2.add(event2);
				}
			}
			//			if (!trace2.isEmpty())
			if (keepEmptyTraces || !trace2.isEmpty())
				subLog.add(trace2);
		}
		return subLog;
	}
}
