package org.processmining.prabhakardixit.alignments;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.ejml.simple.SimpleMatrix;
import org.processmining.decomposelogs.LogModelComparisonNewL;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtilsL;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMapL;
import org.processmining.reduction.ReductionL;
import org.processmining.reduction.ReductionUtilsL;

public class UpdateProjectedAveragedAlignmentsL {

	public static long totalLogTime = 0;
	public static long totalReplayTime = 0;
	public static long totalPrecTime = 0;

	public static String times = "";

	public static void addSeqAlignmentCal(InteractivePetriNetL ipn, Transition tNew) {
		if (tNew.isInvisible())
			return;
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();

		Set<TransPairAlignmentL> newTranAlignments = new HashSet<TransPairAlignmentL>();

		ipn.setFitPre(LogModelComparisonNewL.compareModelAndLog(ipn.getPromContext(), ipn.getselectedPetriNetMap()
				.getPetriNet(), ipn.getAggregatedHeuristics(),ipn.getLog(),true));
		
//		ipn.getController().getFitPre().getParent().repaint();
//		ipn.getController().getFitPre().getParent().revalidate();
		if (true)
			return;
		//TODO fix projection for petri nets
		/*
		 * If tNew labelled activity is already present in the net, then remove
		 * from aggregated info (as these would be re-cauclated)
		 */

		//get all duplicates
		Set<String> duplicateAct = getDuplicateActs(pn);

		//if tNew already present, then remove it 
		if (duplicateAct.contains(tNew.getLabel())) {
			//			Set<TransPairAlignment> transPairAlignmentsWithTNew = getTransPairsWithTNew(ipn, tNew); //remove these from aggregate and pairs
			//			removeFromAggregateAndPairs(ipn, transPairAlignmentsWithTNew);
			ipn.getTranPairs().removeAll(getTransPairsWithTNew(ipn, tNew));
		}
		times += "\n \n ";
		//calculate all alignments
		long msecs = -System.currentTimeMillis();
		totalLogTime = 0;
		totalReplayTime = 0;
		totalPrecTime = 0;
		calculateAlignments(newTranAlignments, ipn, tNew);
		System.out.println("Total time : " + totalLogTime + " " + totalReplayTime + " " + totalPrecTime);
		msecs += System.currentTimeMillis();
		//				System.out.println("Time taken for alignments : " + msecs + " for pairs : " + newTranAlignments.size());
		//		times += "\n New approach alignment time is : " + msecs;

		//PMD expt log other alignment information starts
		//		AlignmentExperiments.doExperiments(ipn);

		//PMD expt log other alignment information ends

		//		System.out.println("size : " + ipn.getTranPairs().size());
	}

	//non loop choices
	public static void addChoiceAlignmentCal(InteractivePetriNetL ipn, Transition tNew) {

		ipn.setFitPre(LogModelComparisonNewL.compareModelAndLog(ipn.getPromContext(), ipn.getselectedPetriNetMap()
				.getPetriNet(), ipn.getAggregatedHeuristics(),ipn.getLog(),true));
		if (true)
			return;

		int card = 2; //TODO take card as input
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		long msecs = -System.currentTimeMillis();
		//use non-sc net - only loop back or choice sets without sc
		Map<Transition, Integer> tranInciMap = new HashMap<Transition, Integer>();
		Map<Place, Integer> placeInciMap = new HashMap<Place, Integer>();
		Set<TransPairAlignmentL> newTranAlignments = new HashSet<TransPairAlignmentL>();
		SimpleMatrix inciMat = MatrixUtilsL.createInciMap(tranInciMap, placeInciMap, ipn.getselectedPetriNetMap()
				.getPetriNet());
		SimpleMatrix augMat3 = inciMat.combine(0, inciMat.numCols(), new SimpleMatrix(inciMat.numRows(), 1));
		//MatrixUtils.getSCIncidenceMatrix2(inciMat, placeInciMap, ipn.getselectedPetriNetMap()
		//				.getPetriNet());
		int inciIndexOftNew = tranInciMap.get(tNew);
		SimpleMatrix inciMatWithoutNewLD = new SimpleMatrix(augMat3.numRows(), augMat3.numCols() - 1);
		SimpleMatrix ldCol = new SimpleMatrix(augMat3.numRows(), 1);
		MatrixUtilsL.splitInciMat(augMat3, inciMatWithoutNewLD, ldCol, inciIndexOftNew);
		PetriNetMapL pnmap = new PetriNetMapL(ipn.getselectedPetriNetMap());
		Set<Set<Integer>> ldCols = ReductionUtilsL.getPossibleDistinctPathsInBetween(inciMatWithoutNewLD, ldCol,
				inciIndexOftNew, false);
		ldCols.addAll(ReductionUtilsL.getPossibleDistinctPathsInBetween(inciMatWithoutNewLD, ldCol, inciIndexOftNew,
				true));//maximize for loop
		msecs += System.currentTimeMillis();
		//		System.out.println(" Time taken for reduction : " + msecs);
		/*
		 * Check how many escape routes exists, and check to see if these are
		 * one higher than card already, then no need to do anything for the
		 * pre-exsiting trans
		 */
		Set<Place> inPlaces = new HashSet<Place>();
		Set<Place> outPlaces = new HashSet<Place>();

		for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> ed : pn.getInEdges(tNew)) {
			inPlaces.add((Place) ed.getSource());
			//			System.out.println("Input place : " + ed.getSource().getLabel());
		}
		for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> ed : pn.getOutEdges(tNew)) {
			outPlaces.add((Place) ed.getTarget());
			//			System.out.println("Output place : " + ed.getTarget().getLabel());
		}

		if (ldCols.size() < card + 1 && !inPlaces.equals(outPlaces)) {
			Set<Integer> mappedIds = new HashSet<Integer>();
			for (Set<Integer> ldColSet : ldCols) {
				mappedIds.addAll(ldColSet);
			}

			//get the original id from ipn
			Set<Integer> allTransInBw = new HashSet<Integer>();
			for (Transition t2 : tranInciMap.keySet())
				if (mappedIds.contains(tranInciMap.get(t2))) {
					allTransInBw.add(ipn.getTranId(t2));
				}

			boolean changed = true;
			msecs = -System.currentTimeMillis();

			//TODO PMD changed calculator - use - reduced net comparison approach 
			//			while (changed) {
			//				changed = false;
			//				for (Set<Integer> set1 : ipn.getMapLDTrans().keySet()) {
			//					if (allTransInBw.containsAll(set1) || allTransInBw.equals(set1))
			//						if (!allTransInBw.containsAll(ipn.getMapLDTrans().get(set1))) {
			//							allTransInBw.addAll(ipn.getMapLDTrans().get(set1));
			//							changed = true;
			//						} else if (allTransInBw.containsAll(ipn.getMapLDTrans().get(set1))
			//								|| allTransInBw.equals(ipn.getMapLDTrans().get(set1)))
			//							if (!allTransInBw.containsAll(set1)) {
			//								changed = true;
			//								allTransInBw.addAll(set1);
			//							}
			//
			//				}
			//			}
			msecs += System.currentTimeMillis();
			//			System.out.println(" Time taken for getting all map lds : " + msecs);
			msecs = -System.currentTimeMillis();

			//first get all in between activity label map
			Set<String> allActInBw = new HashSet<String>();

			//			Set<Transition> allTransitionsInBw = new HashSet<Transition>();
			for (int i : allTransInBw)
				//this is already the id of the mapped tran
				if (!ipn.getTranBasedOnID(i).isInvisible())
					allActInBw.add(ipn.getTranBasedOnID(i).getLabel());

			Set<String> duplicateActs = getDuplicateActs(ipn.getselectedPetriNetMap().getPetriNet());

			boolean duplicateActsInBw = !Collections.disjoint(allActInBw, duplicateActs);

			//			System.out.println(" All in between aactivities : " + allActInBw);
			/*
			 * Navigate through all pairs and if fitness is not 1 for set of
			 * transitions which are not all in between or not all outside
			 */
			for (TransPairAlignmentL tpa : ipn.getTranPairs()) {
				//				!allActInBw.containsAll(tpa.getActivities()) &&		//condition exluded to check incorrect removal of choices for in bw
				if ((!Collections.disjoint(allActInBw, tpa.getActivities()))
						|| (duplicateActsInBw && !Collections.disjoint(duplicateActs, tpa.getActivities()))) {
					if (tpa.getFitness() != 1.) {
						//recalculate alignments for this tran pair
						//						PetriNetMap pnmap2 = new PetriNetMap(ipn.getselectedPetriNetMap().getPetriNet());
						//						Set<PetrinetNode> transToKeep = new HashSet<PetrinetNode>();
						//						for (Transition t : pnmap2.getPetriNet().getTransitions())
						//							if (tpa.getActivities().contains(t.getLabel()))
						//								transToKeep.add(t);

						//Reduction rd = new Reduction(pnmap2.getPetriNet(), transToKeep);
						//								ReductionPlugin().reduceNet(ipn.getPromContext(), pnmap2.getPetriNet(),
						//								transToKeep);
						//tpa.setPetriNetMap(pnmap2);
						newTranAlignments.add(tpa);
					}
				}
			}
			msecs += System.currentTimeMillis();
			//			System.out.println(" Time taken for Reduction of all map lds : " + msecs);
			msecs = -System.currentTimeMillis();
		}
		totalLogTime = 0;
		totalReplayTime = 0;
		totalPrecTime = 0;
		calculateAlignments(newTranAlignments, ipn, tNew);
		System.out.println("Total time : " + totalLogTime + " " + totalReplayTime + " " + totalPrecTime);

		//		msecs += System.currentTimeMillis();
		//		System.out.println(" Time taken for alignements : " + msecs + " with size of pairs : "
		//				+ newTranAlignments.size());
		//		msecs = -System.currentTimeMillis();
		//		System.out.println("size : " + ipn.getTranPairs().size());
		//		AlignmentExperiments.doExperiments(ipn);
	}

	//	private static void removeModelMovesForNonDuplAct(InteractivePetriNet ipn,
	//			Set<TransPairAlignment> nonDuplRemoveModelMoves, Set<String> nonDuplInBwTrans) {
	//		for (TransPairAlignment tranPair : nonDuplRemoveModelMoves) {
	//			Set<Transition> tranSet = new HashSet<Transition>();
	//			for (Transition t : tranPair.getPetriNetMap().getPetriNet().getTransitions())
	//				if (t.getLabel().equals(tranPair.getAct1()) || t.getLabel().equals(tranPair.getAct2()))
	//					tranSet.add(t);
	//			for (int i = 0; i < tranPair.getReplayResult().toArray().length; i++) {
	//				SyncReplayResult sync = (SyncReplayResult) tranPair.getReplayResult().toArray()[i];
	//				AggregatedTraceLevelPairwiseInfo tlpi = ipn.getPairwiseAlignmentInfoBasedOnIds(sync.getTraceIndex());
	//				for (int actIndex = 0; actIndex < sync.getStepTypes().size(); actIndex++) {
	//					StepTypes type = sync.getStepTypes().get(actIndex);
	//					Object stepObj = sync.getNodeInstance().get(actIndex);
	//					if (nonDuplInBwTrans.contains(stepObj.toString()))
	//						switch (type) {
	//							case MREAL :
	//								tlpi.getModelMoves().remove(tranPair.getMappedTransition((Transition) stepObj), 1);
	//								break;
	//							case L :
	//							case LMGOOD :
	//							case MINVI :
	//							case LMNOGOOD :
	//							case LMREPLACED :
	//							case LMSWAPPED :
	//								break;
	//						}
	//				}
	//			}
	//		}
	//	}

	public static Set<String> getDuplicateActs(Petrinet petriNet) {
		Set<String> actsInNet = new HashSet<String>();
		Set<String> duplAct = new HashSet<String>();
		for (Transition t : petriNet.getTransitions()) {
			if (!t.isInvisible())
				if (!actsInNet.add(t.getLabel()))
					duplAct.add(t.getLabel());
		}
		return duplAct;
	}

	private static Set<TransPairAlignmentL> getTransPairsWithTNew(InteractivePetriNetL ipn, Transition tNew) {
		Set<TransPairAlignmentL> transPairAlignments = new HashSet<TransPairAlignmentL>();
		for (TransPairAlignmentL tpa : ipn.getTranPairs()) {
			if (tpa.containsActivity(tNew.getLabel()))
				transPairAlignments.add(tpa);
		}
		return transPairAlignments;
	}

	private static Set<String> getAllActsInNet(InteractivePetriNetL ipn) {
		Set<String> allActivities = new HashSet<String>();
		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions())
			if (!t.isInvisible())
				allActivities.add(t.getLabel());
		return allActivities;
	}

	//	private static void removeFromAggregateAndPairs(InteractivePetriNet ipn, Set<TransPairAlignment> transPairsToRemove) {
	//		for (TransPairAlignment tranPair : transPairsToRemove) {
	//			Set<Transition> tranSet = new HashSet<Transition>();
	//			for (Transition t : tranPair.getPetriNetMap().getPetriNet().getTransitions())
	//				if (t.getLabel().equals(tranPair.getAct1()) || t.getLabel().equals(tranPair.getAct2()))
	//					tranSet.add(t);
	//			for (int i = 0; i < tranPair.getReplayResult().toArray().length; i++) {
	//				SyncReplayResult sync = (SyncReplayResult) tranPair.getReplayResult().toArray()[i];
	//				AggregatedTraceLevelPairwiseInfo tlpi = ipn.getPairwiseAlignmentInfoBasedOnIds(sync.getTraceIndex());
	//				for (int actIndex = 0; actIndex < sync.getStepTypes().size(); actIndex++) {
	//					StepTypes type = sync.getStepTypes().get(actIndex);
	//					Object stepObj = sync.getNodeInstance().get(actIndex);
	//					if (tranPair.containsActivity(stepObj.toString()))
	//						switch (type) {
	//							case L :
	//								tlpi.getLogMoves().remove(stepObj.toString(), 1);
	//								break;
	//							case LMGOOD :
	//								tlpi.getSyncMoves().remove(tranPair.getMappedTransition((Transition) stepObj), 1);
	//								break;
	//							case MINVI :
	//								break;
	//							case MREAL :
	//								tlpi.getModelMoves().remove(tranPair.getMappedTransition((Transition) stepObj), 1);
	//								break;
	//							case LMNOGOOD :
	//							case LMREPLACED :
	//							case LMSWAPPED :
	//								// unable to project this case, stop
	//						}
	//				}
	//			}
	//		}
	//		ipn.getTranPairs().removeAll(transPairsToRemove);
	//	}

	public static void calculateAlignments(Set<TransPairAlignmentL> newTranAlignments, InteractivePetriNetL ipn,
			Transition tNew) {

		//				System.out.println(" new tran size : " + newTranAlignments.size());
		Set<String> allActInNet = getAllActsInNet(ipn);
		Set<String> duplAct = getDuplicateActs(ipn.getselectedPetriNetMap().getPetriNet());
		boolean isDupl = false;
		if (!(tNew == null && !newTranAlignments.isEmpty())) {
			if (duplAct.contains(tNew.getLabel()))
				isDupl = true;
			if (tNew.isInvisible() && newTranAlignments.isEmpty())
				return;

			//create new tpa set for new act 
			if (!isDupl) {
				if (!tNew.isInvisible())
					for (String act : allActInNet) {
						if (!act.equals(tNew.getLabel())) {
							TransPairAlignmentL tranPair = new TransPairAlignmentL();
							tranPair.put(act);
							tranPair.put(tNew.getLabel());
							newTranAlignments.add(tranPair);
						}
					}
			} else { //use the pre existing tpas
				for (TransPairAlignmentL tranPair : ipn.getTranPairs())
					if (tranPair.getActivities().contains(tNew.getLabel()))
						newTranAlignments.add(tranPair);
			}
		}
		for (TransPairAlignmentL tranPair : newTranAlignments) {

			//subtract from aggr
			//subtract sync moves first
			for (Transition t : tranPair.getSyncMoveMap().keySet())
				ipn.subFromAggrSyncMoves(t, tranPair.getSyncMoveMap().get(t));

			//subtract log moves
			for (String l : tranPair.getLogMoveMap().keySet())
				ipn.subFromAggrLogMoves(l, tranPair.getLogMoveMap().get(l));

			//subtract model moves
			for (Transition t : tranPair.getModelMove().keySet())
				ipn.subFromAggrModelMoves(t, tranPair.getModelMove().get(t));

			//reset tranPair counters
			tranPair.getSyncMoveMap().clear();
			tranPair.getLogMoveMap().clear();
			tranPair.getModelMove().clear();

			//create new petri net object corresponding to each pair, and reduce it 
			Set<PetrinetNode> transToKeep = new HashSet<PetrinetNode>();
			PetriNetMapL pnmap = new PetriNetMapL(ipn.getselectedPetriNetMap().getPetriNet());
			for (Transition t : pnmap.getPetriNet().getTransitions())
				if (tranPair.getActivities().contains(t.getLabel()))// || PetrinetUtils.initialOrFinalTran(pnmap.getPetriNet(), t))
					transToKeep.add(t);

			//reduce petrinet now
			ReductionL rd = new ReductionL(pnmap.getPetriNet(), transToKeep);
			tranPair.setPetriNetMap(pnmap);

			//calculate alignments and precision
			Set<Transition> tranSet = new HashSet<Transition>();
			long msecs = System.currentTimeMillis();
			XLog log = ProjectedAveragedAlignmentsL.createMergedLog(ipn.getLog(), tranPair.getActivities(), false);
			msecs = System.currentTimeMillis() - msecs;
			totalLogTime += msecs;
			for (Transition t : tranPair.getPetriNetMap().getPetriNet().getTransitions())
				if (tranPair.containsActivity(t.getLabel())) {
					tranSet.add(t);
					//			System.out.println("Transitions : " + t.getLabel());
				} else
					//set all other acts invi
					t.setInvisible(true);
			//calculate alignments
			msecs = System.currentTimeMillis();
			//TODO calculate fitness precision PMD180518

			//			PNRepResult replay = AlignmentCalculations.calculateNAlignment1(ipn.getPromContext(), log, tranPair
			//					.getPetriNetMap().getPetriNet(), 5, false, tranSet);
			msecs = System.currentTimeMillis() - msecs;
			totalReplayTime += msecs;
			long t1 = msecs;
			//			tranPair.setReplayResult(replay);
			//			tranPair.setFitness((double) replay.getInfo().get(PNRepResult.TRACEFITNESS));

			//calculate precision
			msecs = System.currentTimeMillis();
			//			AlignmentPrecGen precGen = new AlignmentPrecGen();
			//			AlignmentPrecGenRes precRes = precGen.measureConformanceAssumingCorrectAlignment(ipn.getPromContext(),
			//					AlignmentCalculations.transitionToEventClassMapperByLabel(log, tranPair.getPetriNetMap()
			//							.getPetriNet(), null, false), replay, tranPair.getPetriNetMap().getPetriNet(),
			//					PetrinetUtils.getInitialMarking(tranPair.getPetriNetMap().getPetriNet()), true);

			msecs = System.currentTimeMillis() - msecs;
			totalPrecTime += msecs;
			//			tranPair.setPrecision(precRes.getPrecision());
			t1 += msecs;

			//			tranPair.setPrecision(1);
			//			System.out.println("Precision is : " + "precRes.getPrecision()" + " Time taken to compute = " + msecs);
			//end prec cal
			//			if (false)
			//				for (int i = 0; i < tranPair.getReplayResult().toArray().length; i++) {
			//					SyncReplayResult sync = (SyncReplayResult) tranPair.getReplayResult().toArray()[i];

			ipn.getTranPairs().add(tranPair);

			//add to aggr
			//add sync moves 
			for (Transition t : tranPair.getSyncMoveMap().keySet()) {
				ipn.addToAggrSyncMoves(t, tranPair.getSyncMoveMap().get(t));
			}
			//add log moves
			for (String l : tranPair.getLogMoveMap().keySet())
				ipn.addToAggrLogMoves(l, tranPair.getLogMoveMap().get(l));

			//add model moves
			for (Transition t : tranPair.getModelMove().keySet()) {
				ipn.addToAggrModelMoves(t, tranPair.getModelMove().get(t));
			}
		}

	}

}
