package org.processmining.prabhakardixit.fcnets.expansion;

import java.util.List;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.fcnets.synthesis.VizToPnetMapperL;
import org.processmining.reduction.ReductionTrackerL;

public class ExpandUsingTrackerL {

	public static void expanUsingTracker(List<ReductionTrackerL> redTrack, InteractivePetriNetL ipn) {
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		//first rule is always abstraction 

		//		//first map the mid place to the place from the abstraction rule
		//		Place placeMid = null;
		//		for (Place p : pn.getPlaces())
		//			if (pn.getInEdges(p).size() > 0 && pn.getOutEdges(p).size() > 0)
		//				placeMid = p;

		//		for (Integer i : redTrack.get(redTrack.size() - 1).getAtt2())
		//			ipn.setPlaceId(placeMid, i);
		//		System.out.println(redTrack.get(redTrack.size() - 1).getAtt1() + "  "
		//				+ redTrack.get(redTrack.size() - 1).getAtt2() + "  " + redTrack.get(redTrack.size() - 1).getName()
		//				+ "  " + ipn + "  " + redTrack.get(redTrack.size() - 1).isSilent());
		//		VizToPnetMapper.addNewTransition(redTrack.get(redTrack.size() - 1).getAtt1(), redTrack.get(redTrack.size() - 1)
		//				.getAtt2(), redTrack.get(redTrack.size() - 1).getName(), ipn, false,redTrack.get(redTrack.size() - 1).getNewPlaceID(),redTrack.get(redTrack.size() - 1).getNewTranID(), redTrack.get(redTrack.size() - 1).isSilent());

		//		IncrementalLayoutCalculations ilc = new IncrementalLayoutCalculations(pn);
		for (int i = redTrack.size() - 1; i >= 0; i--) {
			ReductionTrackerL currRedTrack = redTrack.get(i);
			switch (currRedTrack.getMethodName()) {
				case ABSTRACTION :
					System.out.println("abstraction ");
					//					System.out.println(currRedTrack.getAtt1() + "  " + currRedTrack.getAtt2() + "  "
					//							+ currRedTrack.getName() + "  " + ipn + "  " + currRedTrack.isSilent());
					VizToPnetMapperL.addNewTransition(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
							currRedTrack.getTranName(), currRedTrack.getPlaceName(), ipn, false,
							currRedTrack.getNewPlaceID(), currRedTrack.getNewTranID(), currRedTrack.isSilent());
					//					ilc.useAbstractionRule(currRedTrack.getAtt1(), currRedTrack.getAtt2(), ipn,
					//							currRedTrack.getNewPlaceID(), currRedTrack.getNewTranID());
					break;
				case LDPLACE :
					System.out.println("place ");
					VizToPnetMapperL.addParallelPlace(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
							currRedTrack.getPlaceName(), ipn, currRedTrack.getNewPlaceID());
					//					ilc.useLDRule(ipn, currRedTrack.getAtt1(), currRedTrack.getAtt2(), currRedTrack.getNewPlaceID(),
					//							true);
					break;
				case LDTRAN :
					System.out.println("choice ");
					VizToPnetMapperL
							.addChoiceTransition(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
									currRedTrack.getTranName(), ipn, currRedTrack.getNewTranID(),
									currRedTrack.isSilent());
					//					ilc.useLDRule(ipn, currRedTrack.getAtt1(), currRedTrack.getAtt2(), currRedTrack.getNewTranID(),
					//							false);
					break;
				case RENAME :
					Transition t = ipn.getTranBasedOnID(currRedTrack.getNewTranID());
					t.setInvisible(currRedTrack.isSilent());
					t.getAttributeMap().put(AttributeMap.LABEL, currRedTrack.getTranName());
					break;
			}

			//PMD alignment experiments
			//			AlignmentExperiments.doExperiments(ipn);

		}
		//		for (PetrinetNode n : ilc.getNodePos().keySet()) {
		//			if (n instanceof Transition) {
		//				System.out.println(n + " - > " + ilc.getNodePos().get(n));
		//			}
		//		}

	}

	public static void expanUsingTracker(ReductionTrackerL currRedTrack, InteractivePetriNetL ipn) {
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		//first rule is always abstraction 

		switch (currRedTrack.getMethodName()) {
			case ABSTRACTION :
				VizToPnetMapperL.addNewTransition(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
						currRedTrack.getTranName(), currRedTrack.getPlaceName(), ipn, false,
						currRedTrack.getNewPlaceID(), currRedTrack.getNewTranID(), currRedTrack.isSilent());
				break;
			case LDPLACE :
				VizToPnetMapperL.addParallelPlace(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
						currRedTrack.getPlaceName(), ipn, currRedTrack.getNewPlaceID());
				break;
			case LDTRAN :
				VizToPnetMapperL.addChoiceTransition(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
						currRedTrack.getTranName(), ipn, currRedTrack.getNewTranID(), currRedTrack.isSilent());
				break;
			case RENAME :
				Transition t = ipn.getTranBasedOnID(currRedTrack.getNewTranID());
				t.setInvisible(currRedTrack.isSilent());
				t.getAttributeMap().put(AttributeMap.LABEL, currRedTrack.getTranName());
				break;
		}

	}
}
