package org.processmining.prabhakardixit.fcnets.expansion;

import java.util.HashSet;
import java.util.Set;

import org.processmining.decomposelogs.LogModelComparisonNewL;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtilsL;
import org.processmining.prabhakardixit.fcnets.models.InteractiveMatrixNetL;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMapL;

public class ParallelPlaceL {
	public static void addParallelPlace(Transition tStart, Transition tEnd, String placeName, InteractivePetriNetL ipn,
			Integer newPlaceID) {
		Set<Transition> tStartSet = new HashSet<Transition>();
		Set<Transition> tEndSet = new HashSet<Transition>();
		tStartSet.add(tStart);
		tEndSet.add(tEnd);
		addParallelPlace(tStartSet, tEndSet, placeName, ipn, newPlaceID);
	}

	public static void addParallelPlace(Set<Transition> tStartSet, Set<Transition> tEndSet, String placeName,
			InteractivePetriNetL ipn, Integer newPlaceID) {
		PetriNetMapL pnmap = ipn.getselectedPetriNetMap();
		Place pNew = pnmap.getPetriNet().addPlace(placeName);
		ipn.setPlaceId(pNew, newPlaceID);
		Set<Place> startPlaces = new HashSet<Place>();
		Set<Place> endPlaces = new HashSet<Place>();

		for (Transition t : tStartSet)
			//			for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge : pnmap.getPetriNet().getOutEdges(t)) {
			pnmap.getPetriNet().addArc(t, pNew);
		//			}

		for (Transition t : tEndSet)
			//			for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge : pnmap.getPetriNet().getOutEdges(t)) {
			pnmap.getPetriNet().addArc(pNew, t);
		//			}
		if (ipn.isKeepHistory())
			updateLDSets(tStartSet, tEndSet, ipn.getInteractiveMatNet(), pNew);

		if (ipn.isAlignmentMode())
			ipn.setFitPre(LogModelComparisonNewL.compareModelAndLog(ipn.getPromContext(), ipn.getselectedPetriNetMap()
					.getPetriNet(), ipn.getAggregatedHeuristics(),ipn.getLog(),true));

		//place conformance starts
		//		Place pi=null;
		//		for(Transition t: tStartSet)
		//			for(PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> e:pnmap.getPetriNet().getOutEdges(t))
		//				pi=(Place) e.getTarget();
		//		PlaceConformanceUtils.copyPlaceLogs(ipn,pi,pNew);
		//	System.out.println(fcnetsUtils.getPathToStart(ipn.getselectedPetriNetMap().getPetriNet(),pNew));
		//	PlaceConformanceUtils.updatePostPlaceSet(pNew,ipn);

		//	PlaceConformanceUtils.updateAllPostTransitions(ipn);
		//place conformance ends

	}

	public static void updateLDSets(Set<Transition> tranStart, Set<Transition> tranEnd, InteractiveMatrixNetL imn,
			Place pNew) {
		Integer pNewID = imn.getPlaceId(pNew);

		//update TranLD

		MatrixUtilsL.updateTranLDForNewPlace(imn, imn.getselectedPetriNetMap().getPetriNet(), pNewID);

	}
}
