package org.processmining.prabhakardixit.fcnets.expansion;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.humbertogarciacaballero.models.gui.controllers.NodeHighlightControlPMDUtilsL;
import org.processmining.prabhakardixit.utils.InteractiveUtilsL;
import org.processmining.reduction.ReductionTrackerL;

import prefuse.data.Node;
import prefuse.visual.EdgeItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class ReduceUndoL {
	public static void undo(PNetVisualizerControllerL controller) {

		ReductionTrackerL rt = controller.getIPN().getCurrentRedTracker();
		controller.getMainView().getDisplay().requestFocus();
		//		controller.getIPN().setCurrentRedTracker(rt);
		//		controller.getIPN().setImnIndex(controller.getIPN().getImnIndex() - 1);
		switch (rt.getMethodName()) {
			case ABSTRACTION :
				reduceAbstraction(controller, rt);
				break;
			case LDPLACE :
				reduceLinearDependency(controller, rt, true);
				break;
			case LDTRAN :
				reduceLinearDependency(controller, rt, false);
				break;
			case RENAME :
				renameActivity(controller, rt);
				break;
			default :
				break;
		}
		controller.getIPN().setImnIndex(controller.getIPN().getImnIndex() - 1);
		InteractiveUtilsL.updateVizParameters(controller.getData(), controller);
		System.out.println(controller.getIPN().getImnIndex());

	}

	public static void redo(PNetVisualizerControllerL controller) {
		int next = controller.getIPN().getImnIndex() + 1;
		if (controller.getIPN().getImnList().get(next) != null) {
			controller.getMainView().getDisplay().requestFocus();
			ReductionTrackerL rt = controller.getIPN().getImnList().get(next).getCurrentRedTracker();
			//			controller.getIPN().setCurrentRedTracker(rt);
			switch (rt.getMethodName()) {
				case ABSTRACTION :

					expandAbstraction(controller, rt);
					break;
				case LDPLACE :
					expandLinearDependency(controller, rt, true);
					break;
				case LDTRAN :
					expandLinearDependency(controller, rt, false);
					break;
				case RENAME :
					renameActivity(controller, rt);
					break;
				default :
					break;
			}
			controller.getIPN().setImnIndex(next);
			InteractiveUtilsL.updateVizParameters(controller.getData(), controller);
			System.out.println(controller.getIPN().getselectedPetriNetMap().getPetriNet().getTransitions().size());
		}
		//			ExpandUsingTracker.expanUsingTracker(controller.getIPN().getImnList().get(next).getCurrentRedTracker(),
		//					controller.getIPN());
	}

	private static void renameActivity(PNetVisualizerControllerL controller, ReductionTrackerL rt) {
		int tranId = rt.getNewTranID();
		Iterator iter = controller.getVisualization().getVisualGroup("graph.nodes").tuples();
		NodeItem item = null;
		while (iter.hasNext()) {
			VisualItem n = (VisualItem) iter.next();
			if (n instanceof NodeItem && n.get("type") == "TRANSITION" && n.getInt("ID") == rt.getNewTranID()) {
				item = (NodeItem) n;
			}
		}
		if (item != null)
			NodeHighlightControlPMDUtilsL.renameActivity(item, controller.getMainView().getNodeHighlightControlPMD(),
					rt.isSilent() ? rt.getTranName() : "", true); //for reduction - reverse the original silence action
	}

	/**
	 * @param controller
	 * @param rt
	 * @param parallePlace
	 *            -is new place
	 * @param runLayout
	 */
	private static void reduceLinearDependency(PNetVisualizerControllerL controller, ReductionTrackerL rt,
			boolean parallePlace) {
		if (parallePlace)
			NodeHighlightControlPMDUtilsL.reduceLinearlyDependentNode(controller, rt.getNewPlaceID(), false, true, true);
		else
			NodeHighlightControlPMDUtilsL.reduceLinearlyDependentNode(controller, rt.getNewTranID(), false, false, true);
	}

	private static void reduceAbstraction(PNetVisualizerControllerL controller, ReductionTrackerL rt) {
		NodeHighlightControlPMDUtilsL.reduceAbstraction(controller.getMainView().getNodeHighlightControlPMD(),
				rt.getNewPlaceID(), rt.getNewTranID(), false, true);

	}

	private static void expandAbstraction(PNetVisualizerControllerL controller, ReductionTrackerL rt) {

		Iterator iter = controller.getVisualization().getVisualGroup("graph.edges").tuples();
		NodeItem item = null;
		controller.getMainView().getNodeHighlightControlPMD().getSelectedEdges().clear();
		while (iter.hasNext()) {
			VisualItem vi = (VisualItem) iter.next();
			Node nSource = (Node) ((EdgeItem) vi).getSourceItem().getSourceTuple();
			Node nTarget = (Node) ((EdgeItem) vi).getTargetItem().getSourceTuple();
			if (vi instanceof EdgeItem
					&& ((nSource.get("type") == "TRANSITION") && rt.getAtt1().contains(nSource.get("ID")))
					&& (nTarget.get("type") == "PLACE") && rt.getAtt2().contains(nTarget.get("ID"))) {
				controller.getMainView().getNodeHighlightControlPMD().getSelectedEdges().add(vi);
			}
		}

		NodeHighlightControlPMDUtilsL.addTransAndPlace(controller.getMainView().getNodeHighlightControlPMD(),
				rt.getNewPlaceID(), rt.getNewTranID(), rt.getTranName(), false, true, false);
	}

	private static void expandLinearDependency(PNetVisualizerControllerL controller, ReductionTrackerL rt,
			boolean parallePlace) {
		Iterator iter = controller.getVisualization().getVisualGroup("graph.nodes").tuples();
		NodeItem item = null;
		while (iter.hasNext()) {
			VisualItem n = (VisualItem) iter.next();
			if (n instanceof NodeItem && ((n.get("type") == "TRANSITION") && parallePlace)
					|| (n.get("type") == "PLACE" && !parallePlace)) {
				item = (NodeItem) n;
			}
		}

		controller.getMainView().getNodeHighlightControlPMD().getSelectedInput().clear();
		controller.getMainView().getNodeHighlightControlPMD().getSelectedOutput().clear();
		//		controller.getMainView().getNodeHighlightControlPMD().setSelectedInput(rt.getAtt1());
		//		controller.getMainView().getNodeHighlightControlPMD().setSelectedOutput(rt.getAtt2());
		controller.getMainView().getNodeHighlightControlPMD().getSelectedInput().addAll(rt.getAtt1());
		controller.getMainView().getNodeHighlightControlPMD().getSelectedOutput().addAll(rt.getAtt2());

		if (parallePlace)
			NodeHighlightControlPMDUtilsL.addLinearlyDependentNode(item, controller.getMainView()
					.getNodeHighlightControlPMD(), rt.getNewPlaceID(), rt.getPlaceName(), false, true, false);
		else
			NodeHighlightControlPMDUtilsL.addLinearlyDependentNode(item, controller.getMainView()
					.getNodeHighlightControlPMD(), rt.getNewTranID(), rt.getTranName(), false, true, false);
	}
}
