package org.processmining.prabhakardixit.fcnets.models;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.decomposelogs.AggregatedHeuristicsL;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.alignments.TransPairAlignmentL;
import org.processmining.prabhakardixit.logHeuristics.CalculateLogHeuristicsL;
import org.processmining.reduction.ReductionTrackerL;

public class InteractivePetriNetL {
	private PluginContext context;
	private UIPluginContext UIContext;
	//	private XLog log;
	private CalculateLogHeuristicsL logInfo;

	//	private JFrame frame1;

	private boolean proAnView = false; //Process Analytics View off - dont calculate any process analytics features

	private int imnIndex = 0;
	private List<InteractiveMatrixNetL> imnList = new ArrayList<InteractiveMatrixNetL>();
	private LinkedList<Integer> orderOfImn = new LinkedList<>();

	private boolean alignment; //toggle to show/hide the alignment view
	private boolean predictor; //toggle to show/hide the predictor view - part of editor view
	private boolean keepHistory; //toggle to keep history
	private boolean calculateAlignments; //toggle to calculate/alignments
	private boolean declareAlignments; //toggle to calculate declare like alignments

	private boolean dataQuality = false;
	private boolean bruteForce = false;

	private ControllerViewModeL viewMode;

	private PNetVisualizerControllerL controller;

	//new additions end

	private String selectedActivity = new String();
	private XLog log;

	public PluginContext getContext() {
		return context;
	}

	public void setContext(PluginContext context) {
		this.context = context;
	}

	public int getImnIndex() {
		return imnIndex;
	}

	public void setImnIndex(int imnIndex) {
		this.imnIndex = imnIndex;
	}

	public List<InteractiveMatrixNetL> getImnList() {
		return imnList;
	}

	public void setImnList(List<InteractiveMatrixNetL> imnList) {
		this.imnList = imnList;
	}

	public void setLog(XLog log) {
		this.log = log;
	}

	public XLog getLog() {
		return log;
	}

	public void setLogInfo(CalculateLogHeuristicsL logInfo) {
		this.logInfo = logInfo;
	}

	//History n future ends

	//	public SimpleMatrix getIncidenceMatrixInput() {
	//		return imnList.get(imnIndex).getIncidenceMatrixInput();
	//	}
	//
	//	public SimpleMatrix getIncidenceMatrixOutput() {
	//		return imnList.get(imnIndex).getIncidenceMatrixOutput();
	//	}

	public Set<Integer> getPlaceLDNonSiphonIndex() {
		return imnList.get(imnIndex).getPlaceLDNonSiphonIndex();
	}

	public Set<Integer> getTranLDFCs() {
		return imnList.get(imnIndex).getTranLDFCs();
	}

	public List<LDSetsL> getplaceLDNonSiphons() {
		return imnList.get(imnIndex).getplaceLDNonSiphons();
	}

	public Integer getPlaceId(Place p) {
		return imnList.get(imnIndex).getPlaceId(p);
	}

	public void setPlaceId(Place p, Integer i) {
		imnList.get(imnIndex).setPlaceId(p, i);
	}

	public Map<Place, Integer> getAllPlaceId() {
		return imnList.get(imnIndex).getAllPlaceId();
	}

	public Integer getTranId(Transition t) {
		return imnList.get(imnIndex).getTranId(t);
	}

	public void setTranId(Transition t, Integer i) {
		imnList.get(imnIndex).setTranId(t, i);
	}

	public Map<Transition, Integer> getAllTranId() {
		return imnList.get(imnIndex).getAllTranId();
	}

	public InteractivePetriNetL(String selectedActivity) {
		this.selectedActivity = selectedActivity;
	}

	public InteractivePetriNetL(PetriNetMapL pnmap, XLog log, AggregatedHeuristicsL ahl, UIPluginContext context) {
		//this.acceptingPetriNetArray = apn;
		//		this.pnMapList.add(pnmap);
		imnIndex = 0;
		InteractiveMatrixNetL imn = new InteractiveMatrixNetL();
		imnList.add(imn);
		setselectedPetriNetMap(pnmap);
		this.UIContext = context;
		this.context = context;
		this.log = log;
		//		graphPanel = SwingGraphs.getGraphs(this);
		logInfo = new CalculateLogHeuristicsL(log,ahl);

		//keep history 
		setKeepHistory(true);

		setViewMode(ControllerViewModeL.VIEWONLY);

		setController();
		//		graphPanel3 = new StackedChart("title", this);
		//		frame1 = new JFrame();
		//		SwingGraphs sg = new SwingGraphs("Graphs", this);
		//		SwingGraphs.getGraphs(this);
		//		placeLog1.setPlace(PetrinetUtils.getMiddlePlace(pnmap.getPetriNet()));
		//		placeLogList.add(placeLog1);

	}

	public InteractivePetriNetL(PetriNetMapL pnmap) {
		//		this.pnMapList.add(pnmap);
		setselectedPetriNetMap(pnmap);
	}

	public PetriNetMapL getselectedPetriNetMap() {
		return imnList.get(imnIndex).getselectedPetriNetMap();
	}

	public void setselectedPetriNetMap(PetriNetMapL pnMap) {
		imnList.get(imnIndex).setselectedPetriNetMap(pnMap);
	}

	public void setSelectedActivity(String selectedActivity) {
		this.selectedActivity = selectedActivity;
	}

	public String getSelectedActivity() {
		return selectedActivity;
	}

	//	public List<PetriNetMap> getPetriNetMapList() {
	//		return pnMapList;
	//	}
	//
	//	public void setPetriNetMapList(List<PetriNetMap> pnMapList) {
	//		this.pnMapList = pnMapList;
	//	}

	//	public Map<String, Map<String, Double>> getFollowsRelations() {
	//		return logInfo.followsMap;
	//	}
	//
	//	public Map<String, Map<String, Double>> getCoOccorsRelations() {
	//		return logInfo.coOccursMap;
	//	}

	public Set<String> getEventNames() {
		return logInfo.events;
	}

	public CalculateLogHeuristicsL getLogInfo() {
		return logInfo;
	}

	//	public void setInciMatrixInput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setInciMatrixInput(m);
	//	}
	//
	//	public void setInciMatrixOutput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setInciMatrixOutput(m);
	//		;
	//	}

	//	public void setTranLDMatrixInput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setTranLDMatrixInput(m);
	//	}
	//
	//	public void setTranLDMatrixOutput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setTranLDMatrixOutput(m);
	//	}
	//
	//	public void setPlaceLDMatrixInput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setPlaceLDMatrixInput(m);
	//	}
	//
	//	public void setPlaceLDMatrixOutput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setPlaceLDMatrixOutput(m);
	//	}

	public Place getPlaceBasedOnID(int id) {
		return imnList.get(imnIndex).getPlaceBasedOnID(id);
	}

	//tranId in viz is tran+1000
	public Transition getTranBasedOnID(int id) {
		return imnList.get(imnIndex).getTranBasedOnID(id);
	}

	public PluginContext getPromContext() {
		return context;
	}

	public UIPluginContext getUIContext() {
		return UIContext;
	}

	//	public XLog getLog() {
	//		return log;
	//	}

	public void selectPrevIndex() {
		if (imnIndex != 0)
			imnIndex--;
	}

	public void selectNextIndex() {
		if (imnIndex < imnList.size() - 1)
			imnIndex++;
	}

	public InteractiveMatrixNetL getInteractiveMatNet() {
		return this.imnList.get(imnIndex);
	}

	public void updateInteractiveMatNet(ReductionTrackerL rd) {
		InteractiveMatrixNetL imn = new InteractiveMatrixNetL(this.getInteractiveMatNet(), true);
		imnList.add(imn);
		orderOfImn.add(imnIndex);
		imnIndex = imnList.size() - 1;
		imnList.get(imnIndex).setCurrentRedTracker(rd);
	}

	public void reduceInteractiveMatNet() {
		//		InteractiveMatrixNet imn = new InteractiveMatrixNet(this.getInteractiveMatNet());
		//		this.getInteractiveMatNet().setGraph(prevGraph);
		//		imnList.add(imn);
		imnIndex--;

	}

	public List<String> getSortedEventNames() {
		List list = new ArrayList(logInfo.getActivities());
		Collections.sort(list, String.CASE_INSENSITIVE_ORDER);
		return list;
	}

	public List<LDSetsL> getAllLdPlaceInfo() {
		return imnList.get(imnIndex).getLdPlaceInfo();
	}

	public void addLdPlaceInfo(int rowId, int negativeid, int positiveid) {
		imnList.get(imnIndex).addLdPlaceInfo(rowId, negativeid, positiveid);
	}

	public List<LDSetsL> getAllLdTranInfo() {
		return imnList.get(imnIndex).getLdTranInfo();
	}

	public void addLdTranInfo(int colId, int negativeid, int positiveid) {
		imnList.get(imnIndex).addLdTranInfo(colId, negativeid, positiveid);
	}

	public void setLdTranInfo(LDSetsL ldset) {
		imnList.get(imnIndex).setLdTranInfo(ldset);
	}

	//	public void setParallelPlaceMap(Integer placeId, Set<Integer> places) {
	//		imnList.get(imnIndex).setPlaceParallelMap(placeId, places);
	//	}
	//
	//	public void setParallelPlaceMap(Integer placeId, Integer places) {
	//		imnList.get(imnIndex).setPlaceParallelMap(placeId, places);
	//	}
	//
	//	public Set<Integer> getParallelPlaceMap(Integer placeId) {
	//		return imnList.get(imnIndex).getPlaceParallelMap(placeId);
	//	}
	//	
	//	public Map<Integer,Set<Integer>> getPlaceParallelMapAll(){
	//		return imnList.get(imnIndex).getPlaceParallelMapAll();
	//	}

	public void updateLdTranInfo(int listID, int newNegId, int newPosId) {
		imnList.get(imnIndex).getLdTranInfo().get(listID).updateNegativeId(newNegId);
		imnList.get(imnIndex).getLdTranInfo().get(listID).updatePositiveId(newPosId);

	}

	//	public void setRrefMainPath(int id){
	//		imnList.get(imnIndex).setRrefMainPath(id);
	//	}
	//	public Set<Integer> getRrefMainPath(){
	//		return imnList.get(imnIndex).getRrefMainPath();
	//	}
	//
	//	public void setLoopTrans(int id){
	//		imnList.get(imnIndex).setLoopTrans(id);
	//	}
	//	public Set<Integer> getLoopTrans(){
	//		return imnList.get(imnIndex).getLoopTrans();
	//	}
	//	public void setLoopPlaces(int id){
	//		imnList.get(imnIndex).setLoopPlaces(id);
	//	}
	//	public Set<Integer> getLoopPlaces(){
	//		return imnList.get(imnIndex).getLoopPlaces();
	//	}

	public Set<LDSetsL> getLdPlaceMapForTranLD(Integer key) {
		return imnList.get(imnIndex).getLdPlaceMapForTranLD(key);
	}

	public void setLdPlaceMapForTranLD(Integer key, LDSetsL lds) {
		imnList.get(imnIndex).setLdPlaceMapForTranLD(key, lds);
	}

	public void removeLdPlaceMapForTranLD(Integer key, LDSetsL lds) {
		imnList.get(imnIndex).removeLdPlaceMapForTranLD(key, lds);
	}

	public Map<Integer, Set<Integer>> getAllLdPlaceMapForTranLD() {
		return imnList.get(imnIndex).getAllLdPlaceMapForTranLD();
	}

	public Set<LDSetsL> getAllTranLDFCs() {
		return imnList.get(imnIndex).getAllTranLDFCs();
	}

	//red tracker starts
	public ReductionTrackerL getCurrentRedTracker() {
		return imnList.get(imnIndex).getCurrentRedTracker();
	}

	public ReductionTrackerL getNextRedTracker() {
		return imnList.get(imnIndex).getNextRedTracker();
	}

	public void setCurrentRedTracker(ReductionTrackerL r) {
		imnList.get(imnIndex).setCurrentRedTracker(r);
	}

	public void setNextRedTracker(ReductionTrackerL r) {
		imnList.get(imnIndex).setNextRedTracker(r);
	}

	//red tracker ends

	//pairwise alignment starts
	//	public void setPairwiseAlignmentInfo(List<TraceLevelPairwiseInfo> pairwiseAlignmentInfo) {
	//		imnList.get(imnIndex).setPairwiseAlignmentInfo(pairwiseAlignmentInfo);
	//	}

	//	public List<AggregatedTraceLevelPairwiseInfo> getPairwiseAlignmentInfo() {
	//		return logInfo.traceLevelInfo;
	//	}
	//
	//	public AggregatedTraceLevelPairwiseInfo getPairwiseAlignmentInfoBasedOnIds(Set<Integer> traceIDs) {
	//		for (AggregatedTraceLevelPairwiseInfo tlpi : logInfo.traceLevelInfo)
	//			if (tlpi.getId().containsAll(traceIDs))
	//				return tlpi;
	//
	//		return null;
	//	}

	public void setTranPairs(Set<TransPairAlignmentL> tranPairs) {
		//		logInfo.tranPairs = tranPairs;
	}

	public Set<TransPairAlignmentL> getTranPairs() {
		//		return logInfo.tranPairs;
		return null;
	}

	//pairwise alignment ends

	//map of transition linear dependencies
	//	public Map<Set<Integer>, Set<Integer>> getMapLDTrans() {
	//		return imnList.get(imnIndex).getMapLDTrans();
	//	}

	public Map<Transition, Integer> getAggrSyncMoves() {
		return imnList.get(imnIndex).getAggrSyncMoves();
	}

	public void addToAggrSyncMoves(Transition t, Integer addVal) {
		Map<Transition, Integer> aggrSync = getAggrSyncMoves();
		if (aggrSync.containsKey(t)) {
			aggrSync.put(t, aggrSync.get(t) + addVal);
		} else {
			aggrSync.put(t, addVal);
		}
	}

	public void subFromAggrSyncMoves(Transition t, Integer subVal) {
		Map<Transition, Integer> aggrSync = getAggrSyncMoves();
		if (aggrSync.containsKey(t)) {
			aggrSync.put(t, aggrSync.get(t) - subVal);
		} else {
			aggrSync.put(t, 0);
		}
	}

	public Map<String, Integer> getAggrLogMoves() {
		return imnList.get(imnIndex).getAggrLogMoves();
	}

	public void addToAggrLogMoves(String t, Integer addVal) {
		Map<String, Integer> aggrLog = getAggrLogMoves();
		if (aggrLog.containsKey(t)) {
			aggrLog.put(t, aggrLog.get(t) + addVal);
		} else {
			aggrLog.put(t, addVal);
		}
	}

	public void subFromAggrLogMoves(String l, Integer subVal) {
		Map<String, Integer> aggrLog = getAggrLogMoves();
		if (aggrLog.containsKey(l)) {
			aggrLog.put(l, aggrLog.get(l) - subVal);
		} else {
			aggrLog.put(l, 0);
		}
	}

	public Map<Transition, Integer> getAggrModelMoves() {
		return imnList.get(imnIndex).getAggrModelMoves();
	}

	public void addToAggrModelMoves(Transition t, Integer addVal) {
		Map<Transition, Integer> aggrModel = getAggrModelMoves();
		if (aggrModel.containsKey(t)) {
			aggrModel.put(t, aggrModel.get(t) + addVal);
		} else {
			aggrModel.put(t, addVal);
		}
	}

	public void subFromAggrModelMoves(Transition t, Integer subVal) {
		Map<Transition, Integer> aggrModel = getAggrModelMoves();
		if (aggrModel.containsKey(t)) {
			aggrModel.put(t, aggrModel.get(t) - subVal);
		} else {
			aggrModel.put(t, 0);
		}
	}

	public boolean isAlignmentMode() {
		return alignment;
	}

	public void setAlignmentMode(boolean alignment) {
		this.alignment = alignment;
	}

	public boolean isPredictorMode() {
		return predictor;
	}

	public void setPredictorMode(boolean predictor) {
		this.predictor = predictor;
	}

	public boolean isKeepHistory() {
		return keepHistory;
	}

	public void setKeepHistory(boolean keepHistory) {
		this.keepHistory = keepHistory;
	}

	public ControllerViewModeL getViewMode() {
		return viewMode;
	}

	public void setViewMode(ControllerViewModeL viewMode) {
		this.viewMode = viewMode;
	}

	public boolean isCalculateAlignments() {
		return calculateAlignments;
	}

	public void setCalculateAlignments(boolean calculateAlignments) {
		this.calculateAlignments = calculateAlignments;
	}

	public List<Set<Integer>> getInputOutPlaces() {
		return imnList.get(imnIndex).getInputOutPlaces();
	}

	public void setInputOutPlaces(List<Set<Integer>> inputOutNodeCombo) {
		imnList.get(imnIndex).setInputOutPlaces(inputOutNodeCombo);
	}

	public List<Set<Integer>> getInputOutTransitions() {
		return imnList.get(imnIndex).getInputOutTransitions();
	}

	public void setInputOutTransitions(List<Set<Integer>> inputOutTrans) {
		imnList.get(imnIndex).setInputOutTransitions(inputOutTrans);
	}

	public int getPrevImnIndex1(int currId) {
		return orderOfImn.get(currId - 1);
	}

	public boolean isDataQuality() {
		return dataQuality;
	}

	public void setDataQuality(boolean dataQuality) {
		this.dataQuality = dataQuality;
	}

	public void setBruteForceCalc(boolean b) {
		this.bruteForce = b;

	}

	public PNetVisualizerControllerL getController() {
		return controller;
	}

	public void setController() {
		this.controller = new PNetVisualizerControllerL();
	}

	public boolean isDeclareAlignments() {
		return declareAlignments;
	}

	public void setDeclareAlignments(boolean declareAlignments) {
		this.declareAlignments = declareAlignments;
	}

	public AggregatedHeuristicsL getAggregatedHeuristics() {
		return logInfo.getAggHeu();
	}

	public void setFitPre(float[] fitPre) {
		imnList.get(imnIndex).setFitPre(fitPre);
		controller.setFitPre("Fitness: "
				+ BigDecimal.valueOf(fitPre[0]).setScale(2, BigDecimal.ROUND_HALF_UP).floatValue() + " Precision: "
				+ BigDecimal.valueOf(fitPre[1]).setScale(0, BigDecimal.ROUND_HALF_UP).floatValue() + " Log Coverage: "
				+ BigDecimal.valueOf(fitPre[2]).setScale(2, BigDecimal.ROUND_HALF_UP).floatValue());
	}
}
