package org.processmining.prabhakardixit.fcnets.models;

import java.util.HashSet;
import java.util.Set;

// contains the linearly dependent places (parallel places) and information
// related to it
public class LDSetsL {

	private int id;
	//	private Set<Integer> positiveTrans;
	//	private Set<Integer> negativeTrans;

	private int posiId;
	private int negId;
	boolean LDplaces; //true if places, false if trans

	public LDSetsL(int rowId, int negId, int posiId, boolean places) {
		setID(rowId);
		setPositiveID(posiId);
		setNegativeID(negId);
		this.LDplaces = places;
	}

	public int getID() {
		return id;
	}

	public void setID(int id) {
		this.id = id;
	}

	public Set<Integer> getNegativeNodes(InteractiveMatrixNetL imn) {
		return LDplaces ? imn.getInputOutTransitions().get(negId) : imn.getInputOutPlaces().get(negId);
	}

	public void setNegativeID(int negativeId) {
		this.negId = negativeId;
	}

	public Set<Integer> getPositiveNodes(InteractiveMatrixNetL imn) {
		return LDplaces ? imn.getInputOutTransitions().get(posiId) : imn.getInputOutPlaces().get(posiId);
	}

	public void setPositiveID(int positiveTrans) {
		this.posiId = positiveTrans;
	}

	public Set<Integer> getAllNodes(InteractiveMatrixNetL imn) {
		Set<Integer> allTrans = new HashSet<Integer>();
		allTrans.addAll(LDplaces ? imn.getInputOutTransitions().get(posiId) : imn.getInputOutPlaces().get(posiId));
		allTrans.addAll(LDplaces ? imn.getInputOutTransitions().get(negId) : imn.getInputOutPlaces().get(negId));
		return allTrans;
	}

	//	public void addNegativeTrans(Integer tranId){
	//		negativeTrans.add(tranId);
	//	}
	//	
	//	public void addPositiveTrans(Integer tranId){
	//		positiveTrans.add(tranId);
	//	}

	public void updateNegativeId(int newNegId) {
		this.negId = newNegId;
	}

	public void updatePositiveId(int newPosId) {
		this.posiId = newPosId;
	}

	public int getNegativeId() {
		return negId;
	}
	public int getPositiveId() {
		return posiId;
	}
}
