package org.processmining.prabhakardixit.fcnets.models;

import java.util.HashMap;
import java.util.Map;

import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.utils.PetrinetUtilsL;

public class PetriNetMapL {
	private Petrinet petriNet;
	private Map<Place, Place> mapPlaces = new HashMap<Place, Place>(); //Map places from original petrinet to new pn
	private Map<Transition, Transition> mapTransitions = new HashMap<Transition, Transition>();
	
	public Petrinet getPetriNet() {
		return petriNet;
	}

	public void setPetriNet(Petrinet petriNet) {
		this.petriNet = petriNet;
	}

	public Map<Place, Place> getMapPlaces() {
		return mapPlaces;
	}

	public void setMapPlaces(Map<Place, Place> mapPlaces) {
		this.mapPlaces = mapPlaces;
	}

	public Map<Transition, Transition> getMapTransitions() {
		return mapTransitions;
	}

	public void setMapTransitions(Map<Transition, Transition> mapTransitions) {
		this.mapTransitions = mapTransitions;
	}

	public PetriNetMapL(Petrinet petrinet) {
		this.petriNet = PetrinetUtilsL.duplicatePN(petrinet, this.mapPlaces, this.mapTransitions); //this function updates all the vars in this tree
	}

	public PetriNetMapL(PetriNetMapL pnmap) {
		this.petriNet = PetrinetUtilsL.duplicatePN(pnmap.getPetriNet(), this.mapPlaces, this.mapTransitions);
		//PetrinetUtils.copyPlacesSets(pnmap, this.mapPlaces, this.loopPlaces);
//		PetrinetUtils.copyPlacesSets(pnmap, this.mapPlaces, this.loopPlaces);

	}

	public Transition getOriginalTran(Transition t){
		for(Transition t2 : mapTransitions.keySet())
			if(mapTransitions.get(t2).equals(t))
				return t2;
		return null;
	}
	
	public Place getOriginalPlace(Place p){
		for(Place p2 : mapPlaces.keySet())
			if(mapPlaces.get(p2).equals(p))
				return p2;
		return null;
	}
	
}
