package org.processmining.prabhakardixit.logHeuristics;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.decomposelogs.AggregatedHeuristicsL;
import org.processmining.decomposelogs.Log2DeclareL;
import org.processmining.incrementaldiscovery.PolicyBasedOnOrderingL;
import org.processmining.prabhakardixit.alignments.TransPairAlignmentL;

public class CalculateLogHeuristicsL {
	public static Map<String, Map<String, Double>> followsMap;
	public static Map<String, Map<String, Double>> precedesMap;
	public static Map<String, Map<String, Double>> coOccursMap; //initiate all
	public static Map<String, Double> occursCount = new HashMap<String, Double>();
	//	public XLogInfo info;
	public Set<String> events;

	//this is info for the currently selected event
	private Map<String, Integer> eventuallyFollows = new HashMap<String, Integer>();
	private Map<String, Integer> eventuallyPrecedes = new HashMap<String, Integer>();
	private Map<String, Integer> directlyFollows = new HashMap<String, Integer>();
	private Map<String, Integer> directlyPrecedes = new HashMap<String, Integer>();

	//	private Map<String, Integer> directlyFollowsForViz = new HashMap<String, Integer>();
	//	private Map<String, Integer> directlyPrecedesForViz = new HashMap<String, Integer>();	
	private int maxOcc = 0; //max repeatations
	private int minOcc = 0; //min number of times 
	private float casePerct = 0.f; //percentage of cases in which act happens
	private float avgOcc = 0.f; //number of average occurrences per case

	private AggregatedHeuristicsL aggHeu;

	public Set<TransPairAlignmentL> tranPairs;

	public List<String> orderedBasedOnSeq;

	public CalculateLogHeuristicsL(XLog log, AggregatedHeuristicsL ahl) {

		//		XLog log = ipn.getLog();
		events = new HashSet<String>();

		if (log.size() < 500) {
			aggHeu = Log2DeclareL.getAllAggPairHeuristics(log);
			for (Set<String> ac : aggHeu.getActComb()) {
				events.addAll(ac);
			}
		} else {
			if (ahl != null)
				aggHeu = ahl;
			initiateInfo(log);
		}
		//alignment
		tranPairs = new HashSet<TransPairAlignmentL>();
		//		if (!ipn.isDeclareAlignments())
		//			initiateInfo(log); //this can be replaced after addition of dc
		//		else
		//			Log2Declare.calculate(this,log);

		Set<TransPairAlignmentL> tranPairs = new HashSet<TransPairAlignmentL>();
		this.tranPairs.addAll(tranPairs);

		PolicyBasedOnOrderingL pbo = new PolicyBasedOnOrderingL(events, log);
		orderedBasedOnSeq = pbo.getPolicyBasedOnOrdering();

	}

	private void initiateInfo(XLog log) {
		//		final XEventNameClassifier lifecycleClassifier = new XEventNameClassifier();

		//		XLogInfo info = XLogInfoFactory.createLogInfo(log, lifecycleClassifier);
		//		for (XEventClass event : info.getEventClasses().getClasses()) {
		//			events.add(event.toString());
		//			//			events.add(event.toString().replace("+complete", ""));
		//			//			System.out.println(event.getId());
		//		}
		for (XTrace t : log)
			for (XEvent e : t)
				events.add(XConceptExtension.instance().extractName(e));
	}

	public <K, V extends Comparable<? super V>> Map<K, V> entriesSortedByValues(Map<K, V> map) {

		List<Map.Entry<K, V>> list = new LinkedList<>(map.entrySet());
		Collections.sort(list, new Comparator<Map.Entry<K, V>>() {
			@Override
			public int compare(Map.Entry<K, V> e1, Map.Entry<K, V> e2) {
				return (e2.getValue()).compareTo(e1.getValue());
			}
		});

		Map<K, V> result = new LinkedHashMap<>();
		for (Map.Entry<K, V> entry : list) {
			result.put(entry.getKey(), entry.getValue());
		}

		return result;

	}

	public Set<String> getActivities() {
		return events;
	}

	public Map<String, Integer> getDirectlyFollows() {
		return directlyFollows;
	}

	public void setDirectlyFollows(String act, int val) {
		directlyFollows.put(act, val);
	}

	public void setDirectlyPrecedes(String act, int val) {
		directlyPrecedes.put(act, val);
	}

	public void setDirectlyFollows(Map<String, Integer> directlyFollows) {
		this.directlyFollows = directlyFollows;
	}

	public Map<String, Integer> getDirectlyPrecedes() {
		return directlyPrecedes;
	}

	public void setDirectlyPrecedes(Map<String, Integer> directlyPrecedes) {
		this.directlyPrecedes = directlyPrecedes;
	}

	//
	public Map<String, Integer> getEventuallyFollows() {
		return eventuallyFollows;
	}

	public void setEventuallyFollows(String act, int val) {
		eventuallyFollows.put(act, val);
	}

	public void setEventuallyPrecedes(String act, int val) {
		eventuallyPrecedes.put(act, val);
	}

	public int getMaxOcc() {
		return maxOcc;
	}

	public void setMaxOcc(int maxOcc) {
		this.maxOcc = maxOcc;
	}

	public int getMinOcc() {
		return minOcc;
	}

	public void setMinOcc(int minOcc) {
		this.minOcc = minOcc;
	}

	public float getCasePerct() {
		return casePerct;
	}

	public void setCasePerct(float casePerct) {
		this.casePerct = casePerct;
	}

	public void setEventuallyFollows(Map<String, Integer> eventuallyFollows) {
		this.eventuallyFollows = eventuallyFollows;
	}

	public Map<String, Integer> getEventuallyPrecedes() {
		return eventuallyPrecedes;
	}

	public void setEventuallyPrecedes(Map<String, Integer> eventuallyPrecedes) {
		this.eventuallyPrecedes = eventuallyPrecedes;
	}

	public List<String> getOrderedBasedOnSeq() {
		return orderedBasedOnSeq;
	}

	public void setOrderedBasedOnSeq(List<String> orderedBasedOnSeq) {
		this.orderedBasedOnSeq = orderedBasedOnSeq;
	}

	public float getAvgOcc() {
		return avgOcc;
	}

	public void setAvgOcc(float avgOcc) {
		this.avgOcc = avgOcc;
	}

	public AggregatedHeuristicsL getAggHeu() {
		return aggHeu;
	}

	public void setAggHeu(AggregatedHeuristicsL aggHeu) {
		this.aggHeu = aggHeu;
	}

	//	public Map<String, Integer> getDirectlyFollowsForViz() {
	//		// TODO Auto-generated method stub
	//		return directlyFollowsForViz;
	//	}
	//
	//	public Map<String, Integer> getDirectlyPrecedesForViz() {
	//		// TODO Auto-generated method stub
	//		return directlyPrecedesForViz;
	//	}
}
