package org.processmining.prabhakardixit.logHeuristics;

import java.awt.Component;
import java.awt.Dimension;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.table.DefaultTableModel;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.framework.util.ui.widgets.ProMTable;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.utils.MapUtilsL;

public class HeuristicsInfoL {
	private JPanel panel;
	JLabel labelDirectlyPrecedes;
	DefaultTableModel tableDirectlyPrecedes;
	JLabel labelDirectlyFollows;
	DefaultTableModel tableDirectlyFollows;
	JLabel labelEventuallyFollows;
	DefaultTableModel tableEventuallyFollows;
	JLabel labelEventuallyPrecedes;
	DefaultTableModel tableEventuallyPrecedes;
	JLabel labelLeastCoOccurrences;
	DefaultTableModel tableLeastCoOccurrences;
	JLabel labelMostCoOccurrences;
	DefaultTableModel tableMostCoOccurrences;
	JLabel maxOccurrences;
	JLabel totalNumOccurrences;
	JLabel minOccurrences;
	JLabel avgOccurrencesPerCase;

	public HeuristicsInfoL() {
		setPanel(new JPanel());
		//headers for the table
		String[] columns = new String[] { "Activity", "%" };
		//actual data for the table in a 2d array
		Object[][] data1 = new Object[5][2];
		Object[][] data2 = new Object[5][2];
		Object[][] data3 = new Object[5][2];
		Object[][] data4 = new Object[5][2];
		Object[][] data5 = new Object[5][2];
		Object[][] data6 = new Object[5][2];

		labelDirectlyPrecedes = new JLabel("Directly Precedes");
		labelDirectlyPrecedes.setAlignmentX(Component.CENTER_ALIGNMENT);
		tableDirectlyPrecedes = new DefaultTableModel(data1, columns);

		labelDirectlyFollows = new JLabel("Directly Follows");
		labelDirectlyFollows.setAlignmentX(Component.CENTER_ALIGNMENT);
		tableDirectlyFollows = new DefaultTableModel(data2, columns);

		labelEventuallyPrecedes = new JLabel("Eventually Precedes");
		labelEventuallyPrecedes.setAlignmentX(Component.CENTER_ALIGNMENT);
		tableEventuallyPrecedes = new DefaultTableModel(data3, columns);

		labelEventuallyFollows = new JLabel("Eventually Follows");
		labelEventuallyFollows.setAlignmentX(Component.CENTER_ALIGNMENT);
		tableEventuallyFollows = new DefaultTableModel(data4, columns);

		tableLeastCoOccurrences = new DefaultTableModel(data5, columns);
		labelLeastCoOccurrences = new JLabel("Least Co-occurring");
		tableMostCoOccurrences = new DefaultTableModel(data6, columns);
		labelMostCoOccurrences = new JLabel("Most Co-occurring");

		maxOccurrences = new JLabel(" ");
		maxOccurrences.setAlignmentX(Component.CENTER_ALIGNMENT);
		minOccurrences = new JLabel(" ");
		minOccurrences.setAlignmentX(Component.CENTER_ALIGNMENT);
		totalNumOccurrences = new JLabel(" ");
		totalNumOccurrences.setAlignmentX(Component.CENTER_ALIGNMENT);
		avgOccurrencesPerCase = new JLabel(" ");
		avgOccurrencesPerCase.setAlignmentX(Component.CENTER_ALIGNMENT);

		ProMTable tab1 = new ProMTable(tableDirectlyPrecedes);
		tab1.setPreferredSize(new Dimension(110, 120));
		tab1.getColumnModel().getColumn(0).setPreferredWidth(190);
		tab1.setEnabled(false);
		ProMTable tab2 = new ProMTable(tableDirectlyFollows);
		tab2.setPreferredSize(new Dimension(110, 120));
		tab2.getColumnModel().getColumn(0).setPreferredWidth(190);
		ProMTable tab3 = new ProMTable(tableEventuallyPrecedes);
		tab3.setPreferredSize(new Dimension(110, 120));
		tab3.getColumnModel().getColumn(0).setPreferredWidth(190);
		ProMTable tab4 = new ProMTable(tableEventuallyFollows);
		tab4.setPreferredSize(new Dimension(110, 120));
		tab4.getColumnModel().getColumn(0).setPreferredWidth(190);

		getPanel().add(maxOccurrences);
		getPanel().add(minOccurrences);
		getPanel().add(avgOccurrencesPerCase);
		getPanel().add(totalNumOccurrences);

		getPanel().add(labelDirectlyPrecedes);
		getPanel().add(tab1);
		getPanel().add(labelDirectlyFollows);
		getPanel().add(tab2);
		getPanel().add(labelEventuallyPrecedes);
		getPanel().add(tab3);
		getPanel().add(labelEventuallyFollows);
		getPanel().add(tab4);

		//		panel.add(labelLeastCoOccurrences);
		//		panel.add(tableLeastCoOccurrences);
		//		panel.add(labelMostCoOccurrences);
		//		panel.add(tableMostCoOccurrences);
		getPanel().setLayout(new BoxLayout(getPanel(), BoxLayout.PAGE_AXIS));
		updateHeuristics(null);
	}

	public void updateHeuristics(InteractivePetriNetL ipn) {
		if (ipn == null || ipn.getSelectedActivity().trim() == "") {
			//			labelDirectlyPrecedes.setVisible(false);
			//			labelDirectlyFollows.setVisible(false);
			//			labelEventuallyPrecedes.setVisible(false);
			//			labelEventuallyFollows.setVisible(false);
			//			labelLeastCoOccurrences.setVisible(false);
			//			labelMostCoOccurrences.setVisible(false);
			removeData();
			maxOccurrences.setText(" ");
			minOccurrences.setText(" ");
			totalNumOccurrences.setText(" ");
			avgOccurrencesPerCase.setText(" ");
		} else {
			labelDirectlyFollows.setVisible(true);
			labelDirectlyPrecedes.setVisible(true);
			labelEventuallyFollows.setVisible(true);
			labelEventuallyPrecedes.setVisible(true);
			labelLeastCoOccurrences.setVisible(true);
			labelMostCoOccurrences.setVisible(true);
			removeData();
			addEmptyRows();
			updateTable(ipn);
		}
	}

	private void addEmptyRows() {
		for (int i = 0; i < 5; i++) {
			tableDirectlyPrecedes.addRow(new Object[] { "", "" });
			tableDirectlyFollows.addRow(new Object[] { "", "" });
			tableEventuallyPrecedes.addRow(new Object[] { "", "" });
			tableEventuallyFollows.addRow(new Object[] { "", "" });
			tableLeastCoOccurrences.addRow(new Object[] { "", "" });
			tableMostCoOccurrences.addRow(new Object[] { "", "" });
		}
	}

	private void removeData() {
		for (int i = tableDirectlyPrecedes.getRowCount() - 1; i > -1; i--) {
			tableDirectlyPrecedes.removeRow(i);
		}
		for (int i = tableDirectlyFollows.getRowCount() - 1; i > -1; i--) {
			tableDirectlyFollows.removeRow(i);
		}
		for (int i = tableEventuallyPrecedes.getRowCount() - 1; i > -1; i--) {
			tableEventuallyPrecedes.removeRow(i);
		}
		for (int i = tableEventuallyFollows.getRowCount() - 1; i > -1; i--) {
			tableEventuallyFollows.removeRow(i);
		}
		for (int i = tableLeastCoOccurrences.getRowCount() - 1; i > -1; i--) {
			tableLeastCoOccurrences.removeRow(i);
		}
		for (int i = tableMostCoOccurrences.getRowCount() - 1; i > -1; i--) {
			tableMostCoOccurrences.removeRow(i);
		}
	}

	private void updateTable(InteractivePetriNetL ipn) {

		float numCases = ipn.getLogInfo().getCasePerct() * ipn.getLog().size() / 100;
		float numOcc = ipn.getLogInfo().getAvgOcc() * numCases;

		Map<String, Integer> map = MapUtilsL.sortByValue(ipn.getLogInfo().getDirectlyFollows(), true);
		map.remove(ipn.getSelectedActivity());
		updateTableProperties(map, tableDirectlyFollows, ipn.getSelectedActivity(),numOcc);

		map = MapUtilsL.sortByValue(ipn.getLogInfo().getDirectlyPrecedes(), true);
		map.remove(ipn.getSelectedActivity());
		updateTableProperties(map, tableDirectlyPrecedes, ipn.getSelectedActivity(),numOcc);

		map = MapUtilsL.sortByValue(ipn.getLogInfo().getEventuallyFollows(), true);
		map.remove(ipn.getSelectedActivity());
		updateTableProperties(map, tableEventuallyFollows, ipn.getSelectedActivity(),numOcc);

		map = MapUtilsL.sortByValue(ipn.getLogInfo().getEventuallyPrecedes(), true);
		map.remove(ipn.getSelectedActivity());
		updateTableProperties(map, tableEventuallyPrecedes, ipn.getSelectedActivity(),numOcc);

		maxOccurrences.setText("Max repeats per case: " + String.valueOf(ipn.getLogInfo().getMaxOcc()));
		minOccurrences.setText("Min occ per case: " + String.valueOf(ipn.getLogInfo().getMinOcc()));
		totalNumOccurrences.setText("% of cases : "
				+ (String.valueOf(ipn.getLogInfo().getCasePerct()).length() > 5 ? String.valueOf(
						ipn.getLogInfo().getCasePerct()).substring(0, 5) : String.valueOf(ipn.getLogInfo()
						.getCasePerct())));
		avgOccurrencesPerCase.setText("Avg occ per case : "
				+ (String.valueOf(ipn.getLogInfo().getAvgOcc()).length() > 5 ? String.valueOf(
						ipn.getLogInfo().getAvgOcc()).substring(0, 5) : String.valueOf(ipn.getLogInfo().getAvgOcc())));
		//		Map<String, Double> map = MapUtils.sortByValue(ipn.getLogInfo().directlyFollowsMap.get(ipn.getSelectedActivity()),true);
		//		
		//		
		//		int i = 0;
		//		
		//		updateTableProperties(map,tableDirectlyFollows);
		//		
		//		map = MapUtils.sortByValue(ipn.getLogInfo().directlyPrecedesMap.get(ipn.getSelectedActivity()),true);
		//		updateTableProperties(map,tableDirectlyPrecedes);
		//	
		//		
		//		map = MapUtils.sortByValue(ipn.getLogInfo().eventuallyFollowsMap.get(ipn.getSelectedActivity()),true);
		//		updateTableProperties(map,tableEventuallyFollows);
		//		
		//		map = MapUtils.sortByValue(ipn.getLogInfo().eventuallyPrecedesMap.get(ipn.getSelectedActivity()),true);
		//		updateTableProperties(map,tableEventuallyPrecedes);
		//				
		//		map = MapUtils.sortByValue(ipn.getLogInfo().coOccursMap.get(ipn.getSelectedActivity()),false);
		//		updateTableProperties(map,tableLeastCoOccurrences);
		//		
		//		map = MapUtils.sortByValue(ipn.getLogInfo().coOccursMap.get(ipn.getSelectedActivity()),true);
		//		updateTableProperties(map,tableMostCoOccurrences);
		//
		//		
		//		String avgOcc = "Avg occ/case: ";
		//		avgOcc+= ipn.getLogInfo().avgOccurrences.get(ipn.getSelectedActivity()).toString().substring(0, 3);
		//		averageOccurrences.setText(avgOcc);
		//		
		//		avgOcc="";
		//		avgOcc += (ipn.getLogInfo().occursCount.get(ipn.getSelectedActivity()) *100 / ipn.getLogInfo().info.getNumberOfTraces());
		//		avgOcc = "% of cases: " + (avgOcc.length()>5? avgOcc.substring(0, 5):avgOcc);
		//		totalNumOccurrences.setText(avgOcc);
	}

	private void updateTableProperties(Map<String, Integer> map, DefaultTableModel tableDirectlyFollows2, String currAct, float numOcc) {
		double total = 0.;
		for (int j = 0; j < 5; j++) {
			tableDirectlyFollows2.setValueAt("", j, 1);
			tableDirectlyFollows2.setValueAt("", j, 0);
		}
		for (String s : map.keySet())
			if (!s.equals(currAct))
				total += map.get(s);

		String str = "";
		Iterator it = map.entrySet().iterator();
		int i = 0;
		while (it.hasNext()) {
			Map.Entry pair = (Map.Entry) it.next();
			if (i < 10) {
				str = "";
				str += ((Double.valueOf(pair.getValue().toString()) / numOcc)) * 100;
				str = str.length() > 5 ? str.substring(0, 5) : str;
				tableDirectlyFollows2.addRow(new Object[] { "", "", "", "", "5" });
				tableDirectlyFollows2.setValueAt(str, i, 1);
				tableDirectlyFollows2.setValueAt(pair.getKey(), i, 0);
				i++;
			}
			it.remove();
		}
		//		tableDirectlyFollows2.getColumnModel().getColumn(1).setPreferredWidth(15);
		//		tableDirectlyFollows2.getColumnModel().getColumn(0).setPreferredWidth(65);
	}

	public void updateDirectRelations(PNetVisualizerControllerL controller) {
		XLog log = controller.getIPN().getLog();
		Map<String, Integer> directlyFollows = controller.getIPN().getLogInfo().getDirectlyFollows();
		Map<String, Integer> directlyPrecedes = controller.getIPN().getLogInfo().getDirectlyPrecedes();
		Map<String, Integer> eventuallyFollows = controller.getIPN().getLogInfo().getEventuallyFollows();
		Map<String, Integer> eventuallyPrecedes = controller.getIPN().getLogInfo().getEventuallyPrecedes();
		int maxCount = 0;
		int minCount = 100;
		int numCases = 0;
		int numOcc = 0;

		directlyFollows.clear();
		directlyPrecedes.clear();
		eventuallyFollows.clear();
		eventuallyPrecedes.clear();
		String selectedAct = controller.getActivity();

		Set<String> activitiesInModel = new HashSet<String>();
		for (Transition t : controller.getIPN().getselectedPetriNetMap().getPetriNet().getTransitions())
			if (!t.isInvisible())
				activitiesInModel.add(t.getLabel());
		//		activitiesInModel.addAll(controller.getIPN().getEventNames());
		
		//TODO a projected directly follows relations - which should be computed based on the current net
		for (XTrace trace : log) {
			int count = 0;
			Map<String, Integer> traceLvlFollows = new HashMap<String, Integer>();
			Map<String, Integer> traceLvlPrecedes = new HashMap<String, Integer>();
			String prevEvt = "";
			//			String nextEvt = "";
			boolean addNext = false;
			boolean actPresent = false;
			for (XEvent event : trace) {
				String currEvt = XConceptExtension.instance().extractName(event);
				//				if (!activitiesInModel.contains(currEvt) && !selectedAct.equals(currEvt))
				//					continue;
				if (currEvt.equals(selectedAct)) {
					count++;
					actPresent = true;
					addNext = true;
				}
				if (!selectedAct.equals(currEvt)) {
					if (addNext) {
						addNext = false;
						int val = directlyFollows.containsKey(currEvt) ? directlyFollows.get(currEvt) + 1 : 1;
						controller.getIPN().getLogInfo().setDirectlyFollows(currEvt, val);
					}
					if (actPresent) {
						int val = traceLvlFollows.containsKey(currEvt) ? traceLvlFollows.get(currEvt) + 1 : 1;
						traceLvlFollows.put(currEvt, val);
					}
					if (!actPresent) {
						int val = traceLvlPrecedes.containsKey(currEvt) ? traceLvlPrecedes.get(currEvt) + 1 : 1;
						traceLvlPrecedes.put(currEvt, val);

					}
				}
				if (currEvt.equals(selectedAct)) { //TODO add anyway for eventually follows
					int val = directlyPrecedes.containsKey(prevEvt) ? directlyPrecedes.get(prevEvt) + 1 : 1;
					controller.getIPN().getLogInfo().setDirectlyPrecedes(prevEvt, val);
				}

				prevEvt = currEvt;
			}
			if (actPresent) {
				numCases++;
				for (String act : traceLvlFollows.keySet()) {
					int val = eventuallyFollows.containsKey(act) ? eventuallyFollows.get(act) + 1 : 1;
					controller.getIPN().getLogInfo().setEventuallyFollows(act, val);
				}
				for (String act : traceLvlPrecedes.keySet()) {
					int val = eventuallyPrecedes.containsKey(act) ? eventuallyPrecedes.get(act) + 1 : 1;
					controller.getIPN().getLogInfo().setEventuallyPrecedes(act, val);

				}
			}
			maxCount = maxCount > count ? maxCount : count;
			minCount = minCount < count ? minCount : count;
			numOcc += count;

		}
		controller.getIPN().getLogInfo().setMaxOcc(maxCount);
		controller.getIPN().getLogInfo().setMinOcc(minCount);
		controller.getIPN().getLogInfo().setCasePerct((float) numCases / log.size() * 100);
		controller.getIPN().getLogInfo().setAvgOcc((float) numOcc / numCases);
	}

	public JPanel getPanel() {
		return panel;
	}

	public void setPanel(JPanel panel) {
		this.panel = panel;
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
	}
}
