package org.processmining.prabhakardixit.pluginsPN;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.expts.SynthesizeNetsL;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtilsL;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.fcnets.synthesis.CreateIPNL;
import org.processmining.prabhakardixit.fcnets.synthesis.VizToPnetMapperL;

@Plugin(name = "Synthesize random nets", parameterLabels = { "Log " }, returnLabels = { "Name of your output" }, returnTypes = { InteractivePetriNetL.class })
public class LogInputL {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public InteractivePetriNetL yourPrivatePlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {
		//AcceptingPetriNetArray apn =  tempRun.temprun(pn);
		//PetriNetMap pnMap = new PetriNetMap(pn);
		//List<PetriNetMap> pnMapList=  tempRun.temprun(pnMap);
		//List<PetriNetMap> pnMapList=  org.processmining.prabhakardixit.fcnets.synthesis.SynthesisTempRun.temprun(pnMap);
		//VisualizeAcceptingPetriNetArrayPlugin a = new VisualizeAcceptingPetriNetArrayPlugin();
		//a.visualize(context, apn);
		//InteractivePetriNet ipn = new InteractivePetriNet(pnMapList, "");
		//ipn.setAcceptingPetriNetArray(apn);
		//CalculateLogHeuristics.calculateRelations(log);
		VizToPnetMapperL.log = false;
		stop = false;
		long timeNow = System.currentTimeMillis();
		InteractivePetriNetL ipn = CreateIPNL.createIPN(log,null, context, false, false, true,false);
		MatrixUtilsL.initiate(ipn);
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		Random random = new Random();
		String analysis = "";
		//		int parPlacs = 5;//29;//bpic= 5*3;
		//		int choiceTrans = 19;//50; //bpic= 19*3;
		//		int seqUences = 24;//65;//bpic= 24*3;
		int k = 0;
		for (int j = 0; j < 2; j++) {
			int parPlacs = 5;//29;//bpic= 5*3;
			int choiceTrans = 19;//50; //bpic= 19*3;
			int seqUences = 24;//65;//bpic= 24*3;
			int iMax = choiceTrans + parPlacs + seqUences;
			for (int i = 0; i < iMax; i++) {
				boolean contains = false;
				k += 1;
				int opType = random.nextInt(5);

				while (!contains) {
					if (i == 0) //start with seq
						opType = 3;
					else
						opType = random.nextInt(5);
					//					
					//					if(i <35 && opType == 0)
					//						opType = 5;

					switch (opType) {
						case 0 :
							if (parPlacs > 0) {
								contains = true;
								parPlacs--;
							}
							break;
						case 1 :
							if (choiceTrans > 0) {
								contains = true;
								choiceTrans--;
							}
							break;
						case 2 :
						case 3 :
							if (seqUences > 0) {
								contains = true;
								seqUences--;
							}
							break;
					}
				}
				timeNow = System.currentTimeMillis();

				switch (opType) {
					case 0 :
						SynthesizeNetsL.addParallelPlace(ipn);
						break;
					case 1 :
						SynthesizeNetsL.addChoiceTran(ipn);
						break;
					case 2 :
						SynthesizeNetsL.addSequence(ipn, (int) 1);
						break;
					case 3 :
						SynthesizeNetsL.addSequence(ipn, (int) 2);
						break;
					case 4 :
						SynthesizeNetsL.addChoiceTran(ipn);
						break;
					default :
						SynthesizeNetsL.addSequence(ipn, (int) 2);
						break;
				}
				analysis += "\r\nIteration: " + k + " Op Type: " + opType + " # trans : " + pn.getTransitions().size()
						+ " # places " + pn.getPlaces().size() + " Size of place ld mat : "
						+ ipn.getAllLdPlaceInfo().size() + " Size of tran ld mat : " + ipn.getAllLdTranInfo().size()
						+ " Size of place ld FC mat : " + ipn.getplaceLDNonSiphons().size()
						+ " Size of tran ld FC non Sip mat : " + ipn.getTranLDFCs().size() + " time diff in millis "
						+ (System.currentTimeMillis() - timeNow);

								System.out.println("Iteration: " + k + " Op Type: " + opType + " # trans : "
										+ pn.getTransitions().size() + " # places " + pn.getPlaces().size()
										+ " Size of place ld mat : " + ipn.getAllLdPlaceInfo().size() + " Size of tran ld mat : "
										+ ipn.getAllLdTranInfo().size() + " Size of place ld FC mat : "
										+ ipn.getplaceLDNonSiphons().size() + " Size of tran ld FC non Sip mat : "
										+ ipn.getTranLDFCs().size() + " time diff in millis " + (System.currentTimeMillis() - timeNow));
				//			}
			}
		}
		
		try {
			PrintWriter writer = new PrintWriter("Analysis_0308.txt", "UTF-8");
			writer.println(analysis);
			writer.close();
		} catch (IOException e) {
			// do something
		}
		return ipn;
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati11on", requiredParameterLabels = { 0 })
	public InteractivePetriNetL yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {

		return yourPrivatePlugin(context, log);

	}
}
