package org.processmining.prabhakardixit.utils;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerControllerL;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;
import org.processmining.prabhakardixit.fcnets.synthesis.VizGraphParametersUtilsL;

import prefuse.data.Graph;
import prefuse.data.Node;
import prefuse.data.Table;
import prefuse.data.Tuple;

public class InteractiveUtilsL {
	static String TRANSITION = "TRANSITION";
	String PLACE = "PLACE";

	public static void updateVizParameters(Graph g, PNetVisualizerControllerL controller) {
		Iterator iter = g.getNodes().tuples();
		while (iter.hasNext()) {
			Tuple node = (Tuple) iter.next();
			PetrinetNode petriNode;
			if (node.get("type") == TRANSITION) {
				petriNode = controller.getIPN().getTranBasedOnID((int) node.get("ID"));
				System.out.println(node.get("InputOutputNodes"));
				node.set(
						"InputOutputNodes",
						VizGraphParametersUtilsL.addHighlightTransBasedOnLDMatrix((Transition) petriNode,
								controller.getIPN()));
				System.out.println(node.get("InputOutputNodes"));
			} else {
				petriNode = controller.getIPN().getPlaceBasedOnID((int) node.get("ID"));
				node.set(
						"InputOutputNodes",
						VizGraphParametersUtilsL.addHighlightPlacesBasedOnLDMatrix((Place) petriNode,
								controller.getIPN()));
				updatePlaceConformance(node, (Place) petriNode, controller.getIPN());
			}

			//			node.set("LoopPlaces", VizGraphParametersUtils.addLoopHighlightPlaces(petriNode, controller.getIPN()));
//			if (!controller.getIPN().getFollowsRelations().containsKey(node.get("label")))
//				continue;
//			String strtemp = "";
//			for (String key : controller.getIPN().getFollowsRelations().get(node.get("label")).keySet()) {
//				strtemp += key + "," + controller.getIPN().getFollowsRelations().get(node.get("label")).get(key) + ";";
//			}
//			node.set("Follows", strtemp);
//			strtemp = "";
//			for (String key : controller.getIPN().getCoOccorsRelations().get(node.get("label")).keySet()) {
//				strtemp += key + "," + controller.getIPN().getCoOccorsRelations().get(node.get("label")).get(key) + ";";
//			}
//			node.set("CoOccurs", strtemp);
		}

	}

	public static void updateBasicNodeInfo(Node n, String type, int newPlaceID, String activity) {
		n.set("label",activity);
		n.set("ID", newPlaceID);
		n.set("type", type);
	}

	private static void updatePlaceConformance(Tuple node, Place petriNode, InteractivePetriNetL ipn) {

	}

	//copy n update graph
	public static Graph duplicateGraph(Graph graph) {
		Table nodeTable = graph.getNodeTable();
		Table edgeTable = graph.getEdgeTable();
		Table nodeTableNew = new Table(nodeTable.getRowCount(), nodeTable.getColumnCount());
		Table edgeTableNew = new Table(edgeTable.getRowCount(), edgeTable.getColumnCount());

		//update table val first
		copyTable(nodeTable, nodeTableNew);
		copyTable(edgeTable, edgeTableNew);
		return (new Graph(nodeTableNew, edgeTableNew, true));
	}

	private static void copyTable(Table tableOld, Table tableNew) {
		for (int r = 0; r < tableOld.getRowCount(); r++)
			for (int c = 0; c < tableOld.getColumnCount(); c++) {
				if (r == 0) //initiate column names
					tableNew.addColumn(tableOld.getColumnName(c), tableOld.getColumnType(c));
				tableNew.set(r, tableOld.getColumnName(c), tableOld.get(r, c));
				//					tableNew.set(r, c, tableOld.get(r, c));
			}

	}

}
