package org.processmining.viz;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JTextPane;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.decomposelogs.ConstraintsBasedFitnessPrecision;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNetL;

public class ConstraintsBasedVisualization {
	@Plugin(name = "@0 Visualize Fitness Precision", returnLabels = { "Visualized Fitness/Precision" }, returnTypes = { JComponent.class }, parameterLabels = { "Fitness/Precision" }, userAccessible = true)
	@Visualizer
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(UIPluginContext context, ConstraintsBasedFitnessPrecision fitPre) {
		JFrame frame = new JFrame();
		JTextPane body = new JTextPane();
		body.setBorder(BorderFactory.createEmptyBorder());
		body.setContentType("text/html");
		body.setEditable(false);
		body.setCaretPosition(0);

		//Text
		StringBuffer text = new StringBuffer();
		text.append("<html><body bgcolor=\"#888888\" text=\"#111111\">");

	

		String fontText = "<font face=\"helvetica,arial,sans-serif\" size=\"4\">";
		
//		text.append(fontText + "Heuristics: <b>");
		text.append("</b><br>");
		text.append("</td></tr>");

		//LOG AND MODEL
		text.append("<tr><td width=\"100%\" align=\"left\" bgcolor=\"#AAAAAA\">");
		text.append("<font face=\"arial,helvetica,sans-serif\" size=\"+2\" color=\"#111111\">");
		text.append("Fitness And Precision");
		text.append("</font><hr noshade width=\"100%\" size=\"1\"><br>");

		text.append(fontText + "Agg Fitness : " + fitPre.fit1 + "<br>");
		text.append(fontText + "Fitness 1: " + fitPre.fit2 + "<br>");
		text.append(fontText + "Fitness 2: " + fitPre.fit3 + "<br>");
		text.append(fontText + "Agg Precision: " + fitPre.pre1 + "<br>");
		text.append(fontText + "Precision 1: " + fitPre.pre2 + "<br>");
		text.append(fontText + "Precision 2: " + fitPre.pre3 + "<br>");
		
		//Return
		body.setText(text.toString());
		return body;

	}

	private JComboBox createActivityList(final InteractivePetriNetL ipn) {
		JComboBox<String> activities = new JComboBox();
		//		for (String s : ipn.getActivityList()) {
		//			activities.addItem(s);
		//		}
		activities.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				ipn.setSelectedActivity(e.getItem().toString());
				e.paramString();
			}
		});
		return activities;
	}
}
